/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

public class SCAlphaConverter
{
    /*
	̃NXObjective-Cŏꂽۂ̃R[hJavaĂяõׂANZbTłB
    */
    protected static SCAlphaConverter_Impl implimentation;
    protected static NSObjectiveCSelector sel_convertImage;
    protected static NSObjectiveCSelector sel_attachAlphaToImage;
    static
    {
	implimentation = new SCAlphaConverter_Impl(); // shared object
	sel_convertImage = new NSObjectiveCSelector("convertImage:");
	sel_attachAlphaToImage = new NSObjectiveCSelector("attachAlpha:toImage:");
    }
    
    public static NSImage convertImage(NSImage srcImage)
    {
	try
	{
	    /*long starttime = System.currentTimeMillis();
	    NSImage img = (NSImage)sel_convertImage.invoke(implimentation,new Object[] {srcImage});
	    System.out.println(System.currentTimeMillis() - starttime);
	    return img;*/
	    
	    return (NSImage)sel_convertImage.invoke(implimentation,new Object[] {srcImage});
	}
	catch (Exception e)
	{
	    System.err.println("SCAlphaConverter : Couldn\'t call the obj-c method convertImage:");
	    e.printStackTrace();
	    return null;
	}
    }
    
    public static void attachAlphaToImage(NSImage src,NSImage dest)
    {
	try
	{
	    sel_attachAlphaToImage.invoke(implimentation,new Object[] {src,dest});
	}
	catch (Exception e)
	{
	    System.err.println("SCAlphaConverter : Couldn\'t call the obj-c method attachAlpha:toImage:");
	    e.printStackTrace();
	}
    }
}
