/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import "SCAlphaConverter_Impl.h"


@implementation SCAlphaConverter_Impl

- (id)_initWithJavaObject:(id)sender {
  return self;
}

- (NSImage *)convertImage:(NSImage *)srcImage {
  // srcImage̍̍W𓧉ߐFƂăAt@`lɓWJANSImage쐬܂B
  NSBitmapImageRep *srcBitmap,*destBitmap;
  unsigned char *srcData,*destData;
  unsigned char trR,trG,trB,trA;
  int spp,width,height,bytesPerPlane,i,sI,dI;
  NSImage *image;
  
  srcBitmap = [[srcImage representations] objectAtIndex:0];
  srcData = [srcBitmap bitmapData];
  trR = srcData[0];
  trG = srcData[1];
  trB = srcData[2];
  spp = [srcBitmap samplesPerPixel];
  width = [srcBitmap pixelsWide];
  height = [srcBitmap pixelsHigh];
  
  image = [[[NSImage alloc] init] autorelease];
  destBitmap = [[NSBitmapImageRep alloc] initWithBitmapDataPlanes:NULL
					 pixelsWide:width
					 pixelsHigh:height
					 bitsPerSample:[srcBitmap bitsPerSample]
					 samplesPerPixel:4
					 hasAlpha:YES
					 isPlanar:NO
					 colorSpaceName:NSCalibratedRGBColorSpace
					 bytesPerRow:0
					 bitsPerPixel:0];
  [image addRepresentation:destBitmap];
  [destBitmap release];
  
  destData = [destBitmap bitmapData];
  bytesPerPlane = [srcBitmap bytesPerPlane];
  switch ([srcBitmap samplesPerPixel]) {
  case	3:
    for (sI = 0,dI = 0;sI < bytesPerPlane;sI += 3,dI += 4) {
      if (!(srcData[sI] == trR && srcData[sI + 1] == trG && srcData[sI + 2] == trB)) {
	destData[dI] = srcData[sI];
	destData[dI + 1] = srcData[sI + 1];
	destData[dI + 2] = srcData[sI + 2];
	destData[dI + 3] = 0xff;
      }
      else {
	destData[dI    ] = 0x00; // red
	destData[dI + 1] = 0x00; // green
	destData[dI + 2] = 0x00; // blue
	destData[dI + 3] = 0x00; // alpha
      }
    }
    break;
    
  case	4:
    trA = srcData[3];
    for (i = 0;i < bytesPerPlane;i += 4) {
      // 2002-04-03 toveta 32bit̏ꍇ̓At@`l܂߂ĔrKvB
      if (!(srcData[i] == trR && srcData[i + 1] == trG && srcData[i + 2] == trB && srcData[i + 3] == trA)) {
	destData[i] = srcData[i];
	destData[i+1] = srcData[i+1];
	destData[i+2] = srcData[i+2];
	destData[i+3] = 0xff; // At@`l̖{̈ӖłsrcData[i+3];Ƃׂc
      }
      else {
	destData[i  ] = 0x00; // red
	destData[i+1] = 0x00; // green
	destData[i+2] = 0x00; // blue
	destData[i+3] = 0x00; // alpha
      }
    }
    break;
  }
  
  return image;
}

- (void)attachAlpha:(NSImage *)src toImage:(NSImage *)dest {
  // OCXP[摜srcAt@`lƌ􂵂destɐݒ肵܂B
  // ỏ摜̃TCYvĂȂdestAt@`lĂȂ肷Ή܂B
  // srcOCXP[łȂꍇ͕̓ۏ؂܂B
  NSBitmapImageRep *srcBits,*destBits;
  unsigned char *srcData,*destData;
  int bytesPerPlane,i,sI,dI;
  
  if ([src size].width != [dest size].width || [src size].height != [dest size].height) {
    NSLog(@"SCAlphaConverter -attachAlpha:toImage: : Parameters were images which have different size.");
    return;
  }
  
  srcBits = [[src representations] objectAtIndex:0];
  destBits = [[dest representations] objectAtIndex:0];
  
  if ([destBits samplesPerPixel] != 4) {
    NSLog(@"SCAlphaConverter -attachAlpha:toImage: : Destination didn\'t have alpha channel.");
    return;
  }
  
  // 2002-04-03 toveta ColorSpacȅꍇAϊ܂
  if(![ [ srcBits colorSpaceName ] isEqualToString:NSCalibratedRGBColorSpace ]) {
    NSImage *buffer=[ [NSImage alloc] initWithSize:[src size] ];
    [ buffer lockFocus ];
    [ src compositeToPoint:NSZeroPoint operation:NSCompositeCopy ];
    [ buffer unlockFocus ];
    srcBits = [ [ [ NSBitmapImageRep alloc ] initWithData:[ buffer TIFFRepresentation ] ] autorelease ];
  }
  
  srcData = [srcBits bitmapData];
  destData = [destBits bitmapData];
  
  bytesPerPlane = [srcBits bytesPerPlane];
  switch ([srcBits samplesPerPixel]) {
  case	3:
    for (sI = 0,dI = 0;sI < bytesPerPlane;sI += 3,dI += 4) {
      destData[dI  ] *= srcData[sI] / 255.0;
      destData[dI+1] *= srcData[sI] / 255.0;
      destData[dI+2] *= srcData[sI] / 255.0;
      destData[dI+3] = srcData[sI]; // dest.A = src.R
    }
    break;
    
  case	4:
    for (i = 0;i < bytesPerPlane;i += 4) {
      destData[i  ] *= srcData[i] / 255.0;
      destData[i+1] *= srcData[i] / 255.0;
      destData[i+2] *= srcData[i] / 255.0;
      destData[i+3] = srcData[i]; // dest.A = src.R
    }
    break;
  }
}

@end
