/*  $Id: SCBalloonSkinServer.java,v 1.6 2004/02/05 09:29:34 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import util.*;

public class SCBalloonSkinServer {
    public static final int ARROW_UP = 0;
    public static final int ARROW_DOWN = 1;
    
    Vector balloons; // [SCBalloonSkin]
    File dir;
    String path;
    String name;
    SCDescription desc;
    NSImage sstpMarker;
    NSImage arrow_up,arrow_down;
    
    public SCBalloonSkinServer(String dir_path) {
	// ݂ȂpXo[XLT[o낤ƂꍇÃT[o[܂B
        balloons = new Vector();
    	path = dir_path;
        
        if (dir_path == null || dir_path.length() == 0) {
	    desc = new SCDescription();
	    return;
	}
        
        dir = new File(SCFoundation.getParentDirOfBundle(),dir_path);
        if (!dir.exists() || !dir.isDirectory()) {
	    desc = new SCDescription();
	    return;
	}
        
	desc = new SCDescription(new File(dir,"descript.txt"));
	name = desc.getStrValue("name");
	
	File sstpmarkerfile = new File(dir,"sstp.png");
	File arrow0file = new File(dir,"arrow0.png");
	File arrow1file = new File(dir,"arrow1.png");
	if (sstpmarkerfile.exists()) {
	    sstpMarker = SCAlphaConverter.convertImage(new NSImage(sstpmarkerfile.getPath(),true));
	}
	if (arrow0file.exists()) {
	    arrow_up = SCAlphaConverter.convertImage(new NSImage(arrow0file.getPath(),true));
	}
	if (arrow1file.exists()) {
	    arrow_down = SCAlphaConverter.convertImage(new NSImage(arrow1file.getPath(),true));
	}
    }
    
    public SCBalloonSkin findSkin(int id,int type) {
        // ȂnullԂ܂B
        // null̏ꍇ͋UьftHgo[i摜gȂjg܂B
	
	// ܂̓[hĂo[XL
        int n_balloons = balloons.size();
        for (int i = 0;i < n_balloons;i++) {
            SCBalloonSkin bs = (SCBalloonSkin)balloons.elementAt(i);
            if (bs.getID() == id && bs.getType() == type) return bs;
        }
	
	// Ȃ̂ŁAt@C݂Ă΃[hĕԂB
	String bskinname = "balloon"+(type == SCFoundation.HONTAI ? 's' : 'k')+id;
	File bskinPng = new File(dir,bskinname+".png");
	if (bskinPng.exists()) {
	    SCBalloonSkin bskin = new SCBalloonSkin(desc,dir,bskinname,id,type);
	    balloons.add(bskin);
	    return bskin;
	}
        
	// t@C݂ȂB
        return null;
    }
    
    public String getPath() {
	// home/Ŏn܂Ão[XL̃fBNgւ̃pXԂ܂B
	return path;
    }
    
    public SCDescription getDescription() {
	return desc;
    }
	
    public String getName() {
	return name;
    }
    
    public NSImage getSstpMarkerImage() {
	// }[J[nullԂB
	return sstpMarker;
    }
	
    public NSImage getArrowImage(int id) {
	// id͒萔B
	return (id == ARROW_UP ? arrow_up : arrow_down);
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("name: ").append(name);
	buf.append("; path: ").append(path);
	return buf.toString();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
}
