/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.net.*;

public class SCBannerDownloader extends Thread
{
    private static final boolean DEBUG = false;
    private static final int TIMEOUT_CONNECTING = 15 * 1000;
    
    private volatile boolean flagTerm = false;
    String banner_url;
    SCBannerServer bserver;
    
    public SCBannerDownloader(SCBannerServer bserver,String url)
    {
	this.bserver = bserver;
	banner_url = url;
    }
    
    public void run()
    {
	if (!banner_url.startsWith("http://")) return;
	
	try
	{
	    debugmsg("Trying to establish a connection...");
	    
	    // ڑ
	    URL url = new URL(banner_url);
	    SCHTTPSession session = new SCHTTPSession(url);
	    session.setSoTimeout(TIMEOUT_CONNECTING);
	    session.connect();
	    
	    // Ԃꂽwb_Location΃_CNgB
	    String location = session.getHeader("Location");
	    if (location != null)
	    {
		session.disconnect();
		
		boolean done = false;
		String nextLocation = location;
		for (int i = 0;i < 10;i++) // \񂽂炢񂵂ɂꂽ₳B
		{
		    URL redirect_url = new URL(nextLocation);
		    SCHTTPSession redirect_session = new SCHTTPSession(redirect_url);
		    redirect_session.setSoTimeout(TIMEOUT_CONNECTING);
		    redirect_session.connect();
		    
		    nextLocation = session.getHeader("Location");
		    if (nextLocation == null) // Ō
		    {
			done = true;
			session = redirect_session;
			break;
		    }
		    
		    redirect_session.disconnect();
		}
		if (!done)
		{
		    // ₳
		    return;
		}
	    }
	    
	    // ^[R[h𒲂ׂāA200łȂΐڑ؂ďIB
	    int respCode = session.getStatusCode();
	    debugmsg("Connection established. Responce code was "+respCode);
	    if (respCode != 200)
	    {
		session.disconnect();
		return;
	    }
	    
	    // ǂoi[̓TCŶňUɑSēǂݏoĂ܂B
	    InputStream is = session.getInputStream();
	    ByteArrayOutputStream baos = new ByteArrayOutputStream();
	    byte[] buf = new byte[1024];
	    while (true)
	    {
		if (flagTerm)
		{
		    session.disconnect();
		    return; // t@CɕۑɋIB
		}
		
		int count = is.read(buf);
		if (count == -1) break; // data end
		
		baos.write(buf,0,count);
	    }
	    debugmsg("Finished downloading. Total size is "+baos.size()+" bytes.");
	    
	    // t@CɕۑB_E[_[̔CIB
	    bserver.saveToDisk(banner_url,new ByteArrayInputStream(baos.toByteArray()));
	    baos.close();
	    debugmsg("Saved to disk.");
	    
	    session.disconnect();
	}
	catch (Exception e){e.printStackTrace();}
	
	bserver.interrupt(); // _E[_[̏IɑCtB
    }
    
    public String getBannerUrl()
    {
	return banner_url;
    }
    
    public void terminate()
    {
	if (!isAlive()) return;
	
	flagTerm = true;
	interrupt();
	while (isAlive()) {}
    }
    
    private void debugmsg(String msg)
    {
	if (DEBUG)
	{
	    System.out.println(banner_url+" :  "+msg);
	}
    }
}
