/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;
import java.io.*;

/*
    ̃NX̓lbg[Ñoi[摜_E[hۑĊǗ܂B
    oi[擾ɂgetBanner()ɉ摜URLnŁAIɃlbg[Nɐڑ
    t@CʃXbhŃ_E[h܂B
    ȂASCBannerServer̂~ĂԂłAɃt@C_E[hς݂ł
    摜擾邱Ƃo܂B
*/

public class SCBannerServer extends Thread
{
    /**************** ݒ ******************/
    // ɍő剽Ƃ̐ڑsB
    private static final int MAX_CONNECTIONS = 3;
    /********************************************/
    
    final File banner_dir;
    Vector waiting_queue; // DL҂L[B content: (String)oi[URL
    Vector downloading_queue; // DLsXbh̃XgB content: (SCBannerDownloader)_E[_[Xbh
    Vector save_waiting_queue; // ۑ҂̃L[Bcontent: (SavingQueueElement)Z[u҂̃f[^
    
    volatile boolean flagTerm = false;
    
    public SCBannerServer()
    {
	banner_dir = new File(SCFoundation.getParentDirOfBundle(),"home/_system/banner");
	
	waiting_queue = new Vector();
	downloading_queue = new Vector();
	save_waiting_queue = new Vector();
	
	convert_old_type();
    }
    
    public void run()
    {
	while (!flagTerm)
	{
	    // ۑ҂̃f[^Sĕۑ
	    if (save_waiting_queue.size() > 0)
	    {
		synchronized (save_waiting_queue)
		{
		    for (int i = 0;i < save_waiting_queue.size();i++)
		    {
			SavingQueueElement current = (SavingQueueElement)save_waiting_queue.elementAt(i);
			_saveToDisk(current.url(),current.datastream());
		    }
		    save_waiting_queue.clear();
		}
	    }
	    
	    // IXbhXg폜
	    if (downloading_queue.size() > 0)
	    {
		synchronized (downloading_queue)
		{
		    for (int i = 0;i < downloading_queue.size();i++)
		    {
			SCBannerDownloader current = (SCBannerDownloader)downloading_queue.elementAt(i);
			if (!current.isAlive())
			{
			    downloading_queue.removeElementAt(i);
			    i--; // xiŃ[v
			}
		    }
		}
	    }
	    
	    // VKɃ_E[_[N
	    while (downloading_queue.size() <= MAX_CONNECTIONS && waiting_queue.size() > 0)
	    {
		synchronized (waiting_queue)
		{
		    // 擪̍ڂo
		    String url = (String)waiting_queue.elementAt(0);
		    waiting_queue.removeElementAt(0);
		    
		    SCBannerDownloader bd = new SCBannerDownloader(this,url);
		    bd.start();
		    downloading_queue.add(bd);
		}
	    }
	    
	    try
	    {
		sleep(30 * 1000);
	    }
	    catch (InterruptedException e)
	    {
		continue;
	    }
	}
    }
    
    public synchronized NSImage getBanner(String banner_url)
    {
	// _E[hĂȂA͊ĂȂnullԂB
	if (banner_url == null || !banner_url.startsWith("http://")) return null;
	// png,gif,jpĝǂꂩłȂnullԂB
	if (!banner_url.endsWith(".png") && !banner_url.endsWith(".gif") && !banner_url.endsWith(".jpg")) return null;
	
	// DLς݂ŎۂɃt@C݂NSImage쐬ĕԂB
	File bannerfile = new File(banner_dir,SCMiscUtils.getMD5AsString(banner_url));
	if (bannerfile.exists())
	{
	    return new NSImage(bannerfile.getPath(),true);
	}
	
	
	// ȉAT[o[XbhNĂԂłȂΈӖB
	if (!isAlive()) return null;
	
	
	// DL҂nullԂB
	Enumeration waiting_urls = waiting_queue.elements();
	while (waiting_urls.hasMoreElements())
	{
	    String current = (String)waiting_urls.nextElement();
	    if (banner_url.equals(current))
	    {
		return null;
	    }
	}
	
	// DLnullԂB
	Enumeration downloading_urls = downloading_queue.elements();
	while (downloading_urls.hasMoreElements())
	{
	    SCBannerDownloader current = (SCBannerDownloader)downloading_urls.nextElement();
	    if (banner_url.equals(current.getBannerUrl()))
	    {
		return null;
	    }
	}
	
	// DLłDL҂łȂDL҂L[ɓo^nullԂB
	waiting_queue.add(banner_url);
	interrupt(); // L[̕ωɋCt
	return null;
    }
    
    public void close()
    {
	if (!isAlive()) return;
	
	// oi[T[o[̂I
	flagTerm = true;
	interrupt();
	while (isAlive()) {}
	
	// _E[_[SċI
	/*Enumeration downloaders = downloading_queue.elements();
	while (downloaders.hasMoreElements())
	{
	    SCBannerDownloader current = (SCBannerDownloader)downloaders.nextElement();
	    current.terminate();
	}*/
    }
        
    public void saveToDisk(String url,InputStream datastream)
    {
	save_waiting_queue.add(new SavingQueueElement(url,datastream));
	interrupt();
    }
    
    private synchronized void _saveToDisk(String url,InputStream datastream)
    {
	// datat@CɏoB
	File outfile = new File(banner_dir,SCMiscUtils.getMD5AsString(url));
	
	try
	{
	    FileOutputStream fos = new FileOutputStream(outfile);
	    byte[] buf = new byte[1024];
	    
	    while (true)
	    {
		int count = datastream.read(buf);
		if (count == -1) break; // end
		
		fos.write(buf,0,count);
	    }
	    
	    datastream.close();
	    fos.flush();
	    fos.close();
	}
	catch (Exception e){}
    }
    
    private void convert_old_type()
    {
	// indexǂŃt@CςĂB
	// ̐݌v~X̂@R[hBp炵[`B
	File idxfile = new File(banner_dir,"index");
	if (idxfile.exists())
	{
	    // CfBbNX݂B
	    try
	    {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(idxfile)));
		while (true)
		{
		    boolean done = false;
		    
		    String url,filename;
		    url = filename = null;
		    while (!done)
		    {
			String line = br.readLine();
			if (line == null) {done = true; break;} // eof
			if (line.length() == 0 || line.indexOf('=') == -1) break; // ̃R[hI
			
			int equal_pos = line.indexOf('=');
			String key = line.substring(0,equal_pos).trim();
			String value = line.substring(equal_pos+1).trim();
			
			if (key.equals("url"))
			{
			    url = value;
			}
			else if (key.equals("filename"))
			{
			    filename = value;
			}
		    }
		    
		    // url,filename̓Ă΃t@Cϊ
		    if (url != null && filename != null)
		    {
			File before = new File(banner_dir,filename);
			if (!before.exists()) continue;
			
			File after = new File(banner_dir,SCMiscUtils.getMD5AsString(url));
			
			before.renameTo(after);
		    }
		    
		    if (done) break;
		}
		br.close();
		
		idxfile.delete(); // index͂ȂB
	    }
	    catch (Exception e)
	    {
		System.out.println("SCBannerServer : convert_old_type() caused an exception.");
		e.printStackTrace();
	    }
	}
    }
    
    private class SavingQueueElement
    {
	String url;
	InputStream datastream;
	
	public SavingQueueElement(String url,InputStream datastream)
	{
	    this.url = url;
	    this.datastream = datastream;
	}
	
	public String url() { return url; }
	public InputStream datastream() { return datastream; }
    }
}
