/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCESSystemCommands extends SCESCommands
{
    public SCESSystemCommands(SCEseShiori e)
    {
	super(e);
    }
    
    public String MODE(Vector args) throws Exception
    {
	/*
	    @F$MODE( str1 [,str2] )
	    ߂lF
	    
	    _ZeX[hstr1ɐݒ肵A
	    str2ĒuL̈900ԂɑB
	*/
	eseshiori.setRandomSentenceMode('%' + eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(0)));
	if (args.size() >= 2)
	{
	    eseshiori.putToReplaceDataArea(900,eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(1)));
	}
	return null;
    }
    
    public String REMODE(Vector args)
    {
	/*
	    @F$REMODE()
	    ߂lF
	    
	    _ZeX[hŌɐݒ肵̂֕AB
	*/
	eseshiori.restoreRandomSentenceMode();
	return null;
    }
    
    public String REFLECT(Vector args) throws Exception
    {
	/*
	    @F$REFLECT( [ghostname,ref0,ref1,ref2,...,ref7] )
	    ߂lF
	    
	    P͑ΏۃS[XgłBΏۃS[Xgw肳Ăꍇ͂̃S[XgցA
	    w肳ĂȂꍇ͌Ăъ|̃S[XgiĂъ|ꂽꍇjA
	    ̓_ȑiŏ̔b҂̏ꍇjɘb|܂B
	    Q`X͑ΏۃS[XgɑttłB
	*/
	String target = null;
	final int argc = args.size();
	if (argc >= 1)
	{
	    String ghostname = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(0));
	    if (ghostname.length() > 0)
	    {
		target = ghostname;
	    }
	}
	if (target == null)
	{
	    String sender = eseshiori.getLastGhostNameWhoTalkedToThis();
	    if (sender != null)
	    {
		target = sender;
	    }
	    else
	    {
		Vector others = eseshiori.getOtherGhostNames();
		if (others.size() == 0) return null; // ɃS[XgȂB
		
		int sel = (int)((Math.random() * 100000) % others.size());
		target = (String)others.elementAt(sel);
	    }
	}
	eseshiori.setGhostToSendMessage(target); // ^[Qbg
	
	if (argc > 1)
	{
	    for (int i = 1;i < argc;i++)
	    {
		String ref = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(i));
		if (ref.length() == 0) continue;
		
		eseshiori.setReferenceOutput(i-1,ref);
	    }
	}
	
	return null;
    }
    
    public String GETGHOST(Vector args) throws Exception
    {
	/*
	    @F$GETGHOST( target , [n,flag] )
	    ߂lFflag == 1Ȃ猋ʂ̕
	    
	    target͑ΏۃS[Xgw肵܂Bw肵ꍇA
	    ̃S[Xg𔭌΂̃S[XgAoȂ΋󕶎ʂƂ܂B
	    target""Ƃȗꍇ́AȊÕ_ȃS[Xg擾܂B
	    ȊÕS[Xg݂Ȃꍇ͋󕶎ʂƂ܂B
	    nw肳ĂΔėpL̈nԖڂɌʂA
	    flag == 1Ȃ猋ʂԂ܂B
	*/
	Vector others = eseshiori.getOtherGhostNames();
	final int argc = args.size();
	String result = null;
	boolean result_ok = false; // resultm肵ԂBꂪtrueɂȂresultύXĂ͂ȂȂB
	if (argc >= 1)
	{
	    String target = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(0));
	    if (target.length() > 0)
	    {
		result = (others.contains(target) ? target : null);
		result_ok = true;
	    }
	}
	
	if (!result_ok)
	{
	    // _ɑI
	    final int n_others = others.size();
	    if (n_others == 0)
	    {
		result = null;
		result_ok = true;
	    }
	    else
	    {
		int sel = (int)((Math.random() * 10000) % n_others);
		result = (String)others.elementAt(sel);
		result_ok = true;
	    }
	}
	
	if (argc >= 2)
	{
	    String n = (String)args.elementAt(1);
	    if (n.length() > 0)
	    {
		eseshiori.putToUnivDataArea(Integer.parseInt(n),result);
	    }
	}
	if (argc >= 3)
	{
	    String flag = (String)args.elementAt(2);
	    if (flag.length() > 0)
	    {
		return (flag.equals("1") ? result : null);
	    }
	}
	return null;
    }
    
    public String TALK_INTERVAL(Vector args) throws Exception
    {
	/*
	    @F$TALK_INTERVAL( n , flag )
	    ߂lF
	    
	    flag == 0ȂꎞIɁAflag == 1ȂPvI
	    g[N̊Ԋuݒ肷B
	    ꎞȈꍇ͎̎g[N܂ŗLŁA
	    PvȈꍇeseai.txtɕۑB
	*/
	String n = (String)args.elementAt(0);
	String flag = (String)args.elementAt(1);
	
	int interval = Integer.parseInt(n);
	if (flag.equals("1"))
	{
	    eseshiori.getIni().setRandomTalkInterval(interval);
	}
	eseshiori.setTalkInterval(interval);
	
	return null;
    }
    
    public String TAGSEL_STYLE(Vector args) throws Exception
    {
	/*
	    @F$TAGSEL_STYLE( entry , type [,flag] )
	    ߂lF
	    
	    entryŎꂽGgAtype == 0Ȃ烉_[h[hɁAtype == 1Ȃ珇[h[hɐݒ肵܂B
	    ̍flag == 1ȂGg̃[hʒu퓬ɃZbg܂B
	*/
	String entry = eseshiori.getEvaluator().validateStringArgument((String)args.elementAt(0));
	String type = (String)args.elementAt(1);
	
	SCESNormalEntry ne = eseshiori.getDictionary().findNormalEntry(entry);
	ne.setMode(type.equals("1") ? SCESNormalEntry.SEQUENTIAL_MODE : SCESNormalEntry.RANDOM_MODE);
	
	if (args.size() >= 3)
	{
	    String flag = (String)args.elementAt(2);
	    if (flag.equals("1"))
	    {
		ne.setPos(0);
	    }
	}
	
	return null;
    }
}
