/*  $Id: SCExtMakoto.java,v 1.2 2004/04/08 08:56:26 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.lang.*;
import java.util.*;

// checkengmakoto.dll 1.02 

public class SCExtMakoto {
    public SCExtMakoto(File makotofile) {
        // ܂listt@C͖B
    }
    
    public static boolean checkIfUsable(File makotofile) {
        // makoto.dll̃oCit@CuMakoto Basic with Select and Repeatv̕B
	return (SCFileUtils.findData(makotofile,"Makoto Basic with Select and Repeat".getBytes()) != -1);
    }
    
    public void terminate() {
        // do nothing
    }
    
    public static String getModuleName() {
	return "\u62e1\u5f35makoto.dll"; // gmakoto.dll
    }

    private static Vector esc_table; // [String[2], ...]
    private static synchronized void make_escape_table() {
	/*
	  obNXbVƁ͓ꎋB(ɕϊ)
	  
	  &  -> &amp;
	  \\ -> &yen;
	  \( -> &#40;
	  \) -> %#41;
	  \| -> &brvbar;
	  \1 ... \9 -> &#49; .. &#57;
	*/
	esc_table = new Vector();
	esc_table.add(new String[] {"\\",           "\u00a5"  });
	esc_table.add(new String[] {"&",            "&amp;"   });
	esc_table.add(new String[] {"\u00a5\u00a5", "&yen;"   });
	esc_table.add(new String[] {"\u00a5(",      "&#40;"   });
	esc_table.add(new String[] {"\u00a5)",      "&#41;"   });
	esc_table.add(new String[] {"\u00a5|",      "&brvbar;"});
	for (int i = 1; i <= 9; i++) {
	    esc_table.add(new String[] {"\u00a5" + i, "&#" + (48 + i) + ";"});
	}
    }
    private static Vector unesc_table; // [String[2], ...]
    private static synchronized void make_unescape_table() {
	unesc_table = new Vector();
	unesc_table.add(new String[] {"&yen;",    "\u00a5"});
	unesc_table.add(new String[] {"&#40;",    "("     });
	unesc_table.add(new String[] {"&#41;",    ")"     });
	unesc_table.add(new String[] {"&brvbar;", "|"     });
	for (int i = 1; i <= 9; i++) {
	    unesc_table.add(new String[] {"&#" + (48 + i) + ";", ""+i});
	}
	unesc_table.add(new String[] {"&amp;",    "&"});
    }
    public static String escape(String str) {
	if (esc_table == null) {
	    make_escape_table();
	}
	
	StringBuffer buf = new StringBuffer(str);
	for (Iterator ite = esc_table.iterator(); ite.hasNext();) {
	    String[] pair = (String[])ite.next();

	    while (true) {
		int pos = buf.indexOf(pair[0]);
		if (pos == -1) {
		    break; // ułȂ
		}
		buf.replace(pos, pos + pair[0].length(), pair[1]);
	    }
	}
	return buf.toString();
    }

    public static String unescape(String str) {
	if (unesc_table == null) {
	    make_unescape_table();
	}
	
	StringBuffer buf = new StringBuffer(str);
	for (Iterator ite = unesc_table.iterator(); ite.hasNext();) {
	    String[] pair = (String[])ite.next();

	    while (true) {
		int pos = buf.indexOf(pair[0]);
		if (pos == -1) {
		    break; // ułȂ
		}
		buf.replace(pos, pos + pair[0].length(), pair[1]);
	    }
	}
	return buf.toString();
    }
    
    public String translate(String param) {
	StringBuffer buf = new StringBuffer(escape(param));

	while (true) {
	    // ʂT
	    int pos_close = buf.indexOf(")");
	    if (pos_close == -1) {
		break; // 
	    }

	    // ɑΉJʂT
	    int pos_open = buf.lastIndexOf("(", pos_close);
	    if (pos_open == -1) {
		break; // ΉJʂ
	    }

	    // I
	    String replaced = select(
		pos_open == pos_close ? "" :  buf.substring(pos_open + 1, pos_close));

	    // JԂ
	    boolean repeated = false;
	    if (pos_close < buf.length() - 1) {
		char next = buf.charAt(pos_close + 1);
		if (Character.isDigit(next) && next != '0') {
		    replaced = repeat(replaced, next - '0');
		    repeated = true;
		}
	    }

	    buf.replace(
		pos_open,
		repeated ? pos_close + 2 : pos_close + 1,
		replaced);
	}

	return unescape(buf.toString());
    }

    private static String select(String param) {
	// (|||foo)Ƃ鎖ɒӁB

	Vector parts = new Vector();
	for (int begin = 0;;) {
	    int pos_pipe = param.indexOf('|', begin);
	    
	    int end;
	    if (pos_pipe == -1) {
		end = param.length();
	    }
	    else {
		end = pos_pipe;
	    }
	    parts.add(param.substring(begin, end));

	    if (pos_pipe == -1) {
		break;
	    }
	    else {
		begin = pos_pipe + 1;
	    }
	}

	int idx = (int)(Math.random() * parts.size());
	return (String)parts.get(idx);
    }

    private static String repeat(String str, int times) {
	StringBuffer buf = new StringBuffer(str.length() * times);
	for (int i = 0; i < times; i++) {
	    buf.append(str);
	}
	return buf.toString();
    }
    
    public String request(String req) {
	BufferedReader br = new BufferedReader(new StringReader(req));
	
	// ܂̓wb_ǂ
	String header = null;
	try{ header = br.readLine(); }catch (Exception e){}
	
	// NGXgŜǂ
	Hashtable hash = new Hashtable();
	String line = null;
	while (true) {
	    try{ line = br.readLine(); }catch (Exception e){}
	    if (line == null) break;
	    if (line.indexOf(':') == -1) continue;
	    
	    String label = line.substring(0,line.indexOf(':'));
	    String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
	    hash.put(label,data);
	}
	
	try{ br.close(); }catch(IOException e){}
	
	// ߊJnB
	if (header.startsWith("EXECUTE")) {
	    String param = (String)hash.get("String");
	    if (param == null) {
		return "MAKOTO/2.0 400 Bad Request\r\n\r\n";
	    }
	    else {
		return "MAKOTO/2.0 200 OK\r\nString: "+translate(param)+"\r\n\r\n";
	    }
	}
	else {
	    return "MAKOTO/2.0 400 Bad Request\r\n\r\n";
	}
    }

    public static void main(String[] args) {
	// eXgpmain
	SCExtMakoto m = new SCExtMakoto(new File(""));
	
	System.out.print("Checking if (foo) becomes foo... ");
	String t = m.translate("(foo)");
	if (t.equals("foo")) {
	    System.out.println("yes ["+t+"]");
	}
	else {
	    System.out.println("NO  ["+t+"]");
	    System.exit(1);
	}

	System.out.print("Checking if (|||foo) becomes \"\" or foo... ");
	t = m.translate("(|||foo)");
	if (t.equals("") || t.equals("foo")) {
	    System.out.println("yes ["+t+"]");
	}
	else {
	    System.out.println("NO  ["+t+"]");
	    System.exit(1);
	}

	System.out.print("Checking if (a|(b|c)2) becomes a, bb or cc... ");
	t = m.translate("(a|(b|c)2)");
	if (t.equals("a") || t.equals("bb") || t.equals("cc")) {
	    System.out.println("yes ["+t+"]");
	}
	else {
	    System.out.println("NO  ["+t+"]");
	    System.exit(1);
	}

	System.out.print("Checking if (a|b)\\2 becomes a2 or b2... ");
	t = m.translate("(a|b)\\2");
	if (t.equals("a2") || t.equals("b2")) {
	    System.out.println("yes ["+t+"]");
	}
	else {
	    System.out.println("NO  ["+t+"]");
	    System.exit(1);
	}
    }
}
