/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import java.security.MessageDigest;

public class SCFileUtils
{
    public static void cp(File src,File dest) throws Exception
    {
	FileInputStream fis = null;
	FileOutputStream fos = null;
	try
	{
	    fis = new FileInputStream(src);
	    fos = new FileOutputStream(dest);
	    byte[] buf = new byte[1024];
	    while (true)
	    {
		int readCount = fis.read(buf);
		if (readCount == -1) break;
		fos.write(buf,0,readCount);
	    }
	    fis.close();
	    fos.close();
	}
	catch (Exception e)
	{
	    throw e;
	}
    }
    
    public static boolean sameFiles(File a,File b) throws Exception
    {
	// ̃t@C̓etrueAȂfalseԂ܂B
	if (a.length() != b.length())
	{
	    return false; // TCYႦΊmB
	}
	
	// TCYȂ璆gǂށB
	FileInputStream afis = new FileInputStream(a);
	FileInputStream bfis = new FileInputStream(b);
	byte[] abuf = new byte[1024];
	byte[] bbuf = new byte[1024];
	while (true)
	{
	    int readCount = afis.read(abuf);
	    if (readCount == -1) break;
	    bfis.read(bbuf);
	    
	    for (int i = 0;i < readCount;i++)
	    {
		if (abuf[i] != bbuf[i])
		{
		    return false;
		}
	    }
	}
	
	return true;
    }
    
    public static void deleteRecursively(File path)
    {
        // t@CȂAfBNgȂĂB
	if (!path.exists()) return;
	
        if (path.isFile())
        {
            path.delete();
        }
        else if (path.isDirectory())
        {
            File[] items = path.listFiles();
            for (int i = 0;i < items.length;i++)
            {
                deleteRecursively(items[i]);
            }
            // ċA甲̂ŋɂȂĂ͂
            path.delete();
        }
    }
    
    public static void deleteRecursively(File path,Vector undelete_mask)
    {
	// undelete_mask : <String>Ȃt@C̖O̗
	if (!path.exists()) return;
	
	if (path.isFile())
	{
	    if (!undelete_mask.contains(path.getName()))
	    {
		path.delete();
	    }
	}
	else if (path.isDirectory())
	{
	    File[] items = path.listFiles();
            for (int i = 0;i < items.length;i++)
            {
                deleteRecursively(items[i],undelete_mask);
            }
	    if (path.list().length == 0) path.delete(); // ɂȂĂfBNg폜B
	}
    }
    
    public static String getMD5AsString(File f)
    {
	// t@CMD5vZĕԂ܂B
	// 16i̕ƂĕԂ܂B
	return SCMiscUtils.bytesToHexString(calcMD5(f));
    }
    
    public static byte[] calcMD5(File f)
    {
	// t@CMD5vZĕԂ܂B
	try
	{
	    MessageDigest md5sum = MessageDigest.getInstance("MD5");
	    FileInputStream fis = new FileInputStream(f);
	    byte[] buf = new byte[512];
	    while (true)
	    {
		int count = fis.read(buf);
		if (count == -1) break; // end
		
		md5sum.update(buf,0,count);
	    }
	    return md5sum.digest();
	}
	catch (Exception e)
	{
	    e.printStackTrace();
	    return null;
	}
    }
    
    public static int findData(File f,byte[] data)
    {
	// t@CoCgA΂ꂪn܂ItZbgAȂ-1Ԃ܂B
	// ݂̎ł̓t@Cۂƃɓǂݍł܂̂ŁA܂ɋȃt@Cɑ΂Ă͗ps\łB
	try
	{
	    FileInputStream fis = new FileInputStream(f);
	    ByteArrayOutputStream baos = new ByteArrayOutputStream();
	    byte[] buf = new byte[512];
	    while (true)
	    {
		int count = fis.read(buf);
		if (count == -1) break; // eof
		
		baos.write(buf,0,count);
	    }
	    byte[] world = baos.toByteArray();
	    
	    return SCMiscUtils.findData(world,data);
	}
	catch (Exception e)
	{
	    e.printStackTrace();
	    return -1;
	}
    }
    
    public static String stringByDeletingExtension(String path)
    {
	int period_pos = path.lastIndexOf('.');
	if (period_pos == -1)
	{
	    return path;
	}
	else
	{
	    return path.substring(0,period_pos);
	}
    }
}
