/*  $Id: SCFoundation.java,v 1.24 2004/02/11 12:22:14 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;
import java.io.*;
import util.*;

public class SCFoundation {
    /**************** GLOBAL SWITCHES *****************/
    public static boolean DEBUG = false;
    public static String  FIXED_GHOST_TO_BOOT = null;
    public static boolean LOG_SHIORI_SESSION = false; // trueɂΑSĂSHIORIWo͂ɃOfB
    public static boolean LOG_MAKOTO_SESSION = false; // trueɂΑSĂMAKOTOWo͂ɃOfB
    public static boolean LOCK_SHIORI_EVENTS = false; // trueɂSHIORIɃCxgSȂB
    public static boolean LOAD_WHOLE_SURFACES_ON_BOOTING_SURFACE_SERVER = false; // trueɂ΃T[tBXT[o[NɑSẴT[tBX[hB
    public static boolean STOP_SERIKO = false; // trueɂSERIKOAj[V삵ȂBiÑAj[V͎~܂ȂBj
    public static boolean COMPRESS_SURFACES_ON_MEMORY = false; // trueɂSCSurface摜ŉtkB
    public static boolean LOCK_BALLOONS = false; // trueɂΌĉȂB
    public static boolean DO_NOT_BOOT_ANY_GHOSTS_AT_STARTUP = false; // trueɂ΃AvP[V̋NɃS[XgNȂB
    public static boolean SSTP_CONFLICT_IF_ANYONE_SPEAKING = true; // trueȂASSTPŔb̃S[XglłꍇɁASSTP SEND409 ConflictԂB
    public static boolean DO_NOT_DETERMINE_GHOST_DETAIL = false; // trueȂAS[Xg}l[WeS[XgSHIORIMAKOTO𒲂ׂȂB
    public static boolean BALLOON_USES_CLICK_THROUGH = false; // trueȂAo[EChENbNX[gB
    /**************************************************/
    
    /**************** GLOBAL CONSTANTS ****************/
    public static final int HONTAI = 1;
    public static final int SAKURA = 1;
    public static final int UNYUU = 2;
    public static final int KERO = 2;
    public static final String STRING_FOR_SENDER = "NiseRingo"; // x^Ղ֓nSenderwb_
    /**************************************************/
    
    static {
	if (DEBUG) {
	    Logger.setLogLevelLimit(Logger.DEBUG);
	    DO_NOT_BOOT_ANY_GHOSTS_AT_STARTUP = true;
	    DO_NOT_DETERMINE_GHOST_DETAIL = true;

	    Logger.log(null, Logger.NOTICE, "NiseRingo was built in DEBUG mode.");
	}
	else {
	    Logger.setLogLevelLimit(Logger.NOTICE);
	}
    }
    
    // Cg[hňꎞIɋNĂZbV̍ő吔B
    // zƁAłgppx̒ႢZbVjB
    protected static final int TEMPORARY_GHOST_CACHE_SIZE = 10;
    
    private static SCFoundation _sharedInstance = null;
    
    Vector sessions; // gSCSessionB
    Vector temporary_sessions; // <SCSession>
    SCSSTPDaemon sstpDaemon;
    SCMailCheckDaemon mailCheckDaemon;
    SCTimeEventTriggerDaemon timeEventTriggerDaemon;
    SCBannerServer bannerServer;
    SCStatusWindowCenter statusCenter;
    SCInstaller lastExecutedInstaller; // ŌɋNCXg[B
    SCOnlineInstaller lastExecutedOI; // ŌɋNICCXg[B
    SCUpdateDataMaker lastExecutedUDM; // ŌɋNDAU[JB
    SCNarMaker lastExecutedNM; // ŌɋNNAR[JB
    SCSessionVanisher lastExecutedVanisher; // ŌɋNVanishZbVB
    SCAppQuitter quitter; // ꂪNďI΃AvP[VIB
    SCPluginManager pluginManager;
    
    private volatile boolean flagTerm = false;
    
    private static String[] ET_TAG_EXT = {
	"\u30df\u30ea\u79d2", // ~b
	"\u5e74", // N
	"\u30c1\u30a7\u30ad", // `FL
	"\u30b0\u30e9\u30e0", // O
    };
    
    // constructor and accessor
    public static SCFoundation sharedFoundation() {
        return _sharedInstance;
    }
    
    public NSRunLoop mainthread_runloop;
    public NSRunLoop getRunLoopOfMainThread() {
	return mainthread_runloop;
    }
    
    private SCFoundation() {
        _sharedInstance = this;
	
        sessions = new Vector();
	temporary_sessions = new Vector();
	
	timeEventTriggerDaemon = new SCTimeEventTriggerDaemon();
	timeEventTriggerDaemon.start();
	
	bannerServer = new SCBannerServer();
	bannerServer.start();
	
	statusCenter = new SCStatusWindowCenter();
    }
    
    public void performQuit() {
	// ŏIIȏI̓CXbhōŝŁA
	// ̃\bh̓TuXbhĂł\܂B
	if (quitter != null && quitter.isAlive()) return;
	
	quitter = new SCAppQuitter();
	quitter.start();
    }
    
    public static String getVersion() {
	return NSBundle.mainBundle().localizedStringForKey(
	    "CFBundleShortVersionString",
	    "\"pseudo apple\" [version info not found]",
	    "InfoPlist"
	    );
    }
    
    public static String pseudoHoursFromStartTime() {
	// ŰNԂԂ܂B
	int select = (int)((Math.random() * 10000) % ET_TAG_EXT.length);
	int num = (int)(Math.random() * 1000);
	return num + ET_TAG_EXT[select];
    }
    
    public static void debugstr(String s) {
	if (s == null) return;
	try{System.out.println(new String(s.getBytes("SJIS")));}catch(Exception e){}
    }
    
    public void install(String fpath) {
	if (lastExecutedInstaller != null && lastExecutedInstaller.isAlive()) return;
	
	lastExecutedInstaller = new SCInstaller(fpath);
	lastExecutedInstaller.start();
    }
    
    public void install(String fpath,SCSession target) {
	if (lastExecutedInstaller != null && lastExecutedInstaller.isAlive()) return;
	
	lastExecutedInstaller = new SCInstaller(fpath,target);
	lastExecutedInstaller.start();
    }
    
    public void install(String fpath,SCSession target,boolean deleteAfterSuccess) {
	if (lastExecutedInstaller != null && lastExecutedInstaller.isAlive()) return;
	
	lastExecutedInstaller = new SCInstaller(fpath,target,deleteAfterSuccess);
	lastExecutedInstaller.start();
    }
    
    public void downloadAndInstall(String url) {
	if (lastExecutedOI != null && lastExecutedOI.isAlive()) return;
	
	lastExecutedOI = new SCOnlineInstaller(url);
	lastExecutedOI.start();
    }
    
    public void downloadAndInstall(String url,SCSession target) {
	if (lastExecutedOI != null && lastExecutedOI.isAlive()) return;
	
	lastExecutedOI = new SCOnlineInstaller(url,target);
	lastExecutedOI.start();
    }
    
    public void makeDau(String dirpath) {
	if (lastExecutedUDM != null && lastExecutedUDM.isAlive()) return;
	
	lastExecutedUDM = new SCUpdateDataMaker(dirpath);
	lastExecutedUDM.start();
    }
    
    public void makeDau(String dirpath,SCSession target) {
	if (lastExecutedUDM != null && lastExecutedUDM.isAlive()) return;
	
	lastExecutedUDM = new SCUpdateDataMaker(dirpath,target);
	lastExecutedUDM.start();
    }
    
    public void makeNar(String dirpath) {
	if (lastExecutedNM != null && lastExecutedNM.isAlive()) return;
	
	lastExecutedNM = new SCNarMaker(new File(dirpath));
	lastExecutedNM.start();
    }
    
    public void makeNar(String dirpath,SCSession target) {
	if (lastExecutedNM != null && lastExecutedNM.isAlive()) return;
	
	lastExecutedNM = new SCNarMaker(new File(dirpath),target);
	lastExecutedNM.start();
    }
    
    public void startVanishSession(SCSession session) {
	if (lastExecutedVanisher != null && lastExecutedVanisher.isAlive()) return;
	
	lastExecutedVanisher = new SCSessionVanisher(session);
	lastExecutedVanisher.start();
    }
    
    public boolean isThisInVanishEvent(SCSession session) {
	if (lastExecutedVanisher == null || !lastExecutedVanisher.isAlive()) return false;
	if (lastExecutedVanisher.getTarget() != session) return false;
	
	return lastExecutedVanisher.isInLastEvent();
    }
    
    public void holdVanishSession() {
	// Ō̃Cxg̏IɊԂɍȂΎxłB
	if (lastExecutedVanisher == null || !lastExecutedVanisher.isAlive()) return;
	
	lastExecutedVanisher.hold();
    }
    
    // delegete methods
    public boolean applicationOpenFile(NSApplication theApplication,String filename) {
	File f = new File(filename);
	if (f.isDirectory() && SCUpdateDataMaker.hasDauFile(f)) {
	    makeDau(filename);
	}
	else if (f.isDirectory() && SCNarMaker.hasManifestFile(f)) {
	    makeNar(filename);
	}
	else if (f.isFile() && (f.getName().toLowerCase().endsWith(".zip") || f.getName().toLowerCase().endsWith(".nar"))) {
	    install(filename);
	}
	return true;
    }
    
    public static String getParentDirOfBundle() {
        String parOfBundle = NSBundle.mainBundle().bundlePath();
        parOfBundle = parOfBundle.substring(0,parOfBundle.lastIndexOf("/"));
        
        return parOfBundle;
    }
    
    public void checkAndMakeSystemDirs() {
        // KvȃfBNg܂B
        String parOfBundle = getParentDirOfBundle();
        
        String[] dirs = {
	    "home",
	    "home/ghost",
	    //"home/shell",
	    "home/balloon",
	    "home/plugin",
	    "home/nar",
	    "home/saori",
	    "home/_system",
	    "home/_system/banner",
	    "home/_system/updating_temp",
	    "home/_system/headline_hash",
	    "home/_system/headline_temp"
	    //"home/_system/updatechecker_db",
	    //"home/_system/updatechecker_temp"
	};
        for (int i = 0;i < dirs.length;i++) {
            File cur_dir = new File(parOfBundle,dirs[i]);
            if (!cur_dir.exists()) {
                cur_dir.mkdir();
            }
        }
    }
    
    public void applicationDidFinishLaunching(NSNotification notification) {
	mainthread_runloop = NSRunLoop.currentRunLoop();
	Thread.currentThread().setName("main"); // ̃\bh͏ɃCXbhĂ΂̂ŖOtĂB

	bootcode();
    }
	
    public static boolean isHereMainThread() {
	// ̃\bh̓CXbhĂ΂trueԂ܂B
	return Thread.currentThread().getName().equals("main");
    }
    
    public void bootcode() {
        // applicationDidFinishLaunchingI܂ŃAvANeBuɂłȂ悤Ȃ̂ŁA
        // dȂNSTimerɂĂ΂B
	
        checkAndMakeSystemDirs();
	//checkGhostsExistance();
	convertKeysOfDefaults();
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();

	File quitcheck = new File(getParentDirOfBundle(),"home/_system/quitcheck");
	if (quitcheck.exists()) {
	    // ُIB
	    System.out.println("Last time, NiseRingo exitted abnormaly.");
	    System.out.println("Auto-boot of ghosts is disabled.");
	    SCGhostManager.sharedGhostManager().clearBootFlags();
	}

	// t@Chome/_system/quitcheck쐬BُImਁB
	try {
	    FileOutputStream fos = new FileOutputStream(quitcheck);
	    fos.close();
	} catch (Exception e) {}
	
	if (defaults.objectForKey("display.balloon.wait_rate") != null) {
	    SCScriptRunner.setWaitRatio(defaults.doubleForKey("display.balloon.wait_rate"));
	}
	if (defaults.integerForKey("booting.converter.inverse_type") == 1) {
	    SCOldTypeConverter.convertAll();
	}
	if (defaults.integerForKey("booting.converter.zeropoint_balloon") == 1) {
	    SCOldBalloonConverter.convertAll();
	}
	if (defaults.integerForKey("booting.converter.thumbnail") == 1) {
	    SCGhostThumbnailMover.moveAll();
	}
	SCFoundation.LOAD_WHOLE_SURFACES_ON_BOOTING_SURFACE_SERVER =
	    (defaults.integerForKey("misc.load_whole_surfaces_on_booting_surface_server") == 1);
	SCFoundation.STOP_SERIKO =
	    (defaults.integerForKey("misc.disable_seriko_animation") == 1);
	SCFoundation.BALLOON_USES_CLICK_THROUGH =
	    (defaults.integerForKey("display.balloon.clickthrough") != 0);
	
	pluginManager = new SCPluginManager();
	
        if (defaults.integerForKey("sstp_switch") == 1) {
            startSSTPServer();
        }
	
	if (defaults.integerForKey("mailcheck_check_enable") == 1 &&
	    defaults.integerForKey("mailcheck_check_autocheck") == 1) {
	    startMailCheckDaemon();
	}

	if (FIXED_GHOST_TO_BOOT != null) {
	    SCSessionStarter.sharedStarter().start(FIXED_GHOST_TO_BOOT, "", 1.0);
	}
	else {
	    if (!DO_NOT_BOOT_ANY_GHOSTS_AT_STARTUP) {
		SCGhostManager.sharedGhostManager().bootAllGhostsToBoot();
	    }
	}
	
	//SCUpdateChecker.sharedUpdateChecker(); // ŏĂB
    }
    
    public void applicationWillTerminate(NSNotification notification) {
	// AvP[VI鎞ɌĂ΂܂B
	bannerServer.close();
		
	// CXg[[͒foȂB
	if (lastExecutedInstaller != null && lastExecutedInstaller.isAlive()) lastExecutedInstaller.waitUntilEnd();
	// OI͒foȂB
	if (lastExecutedOI != null && lastExecutedOI.isAlive()) lastExecutedOI.waitUntilEnd();
	// UDM͒foȂB
	if (lastExecutedUDM != null && lastExecutedUDM.isAlive()) lastExecutedUDM.waitUntilEnd();
	// NM͒foȂB
	if (lastExecutedNM != null && lastExecutedNM.isAlive()) lastExecutedNM.waitUntilEnd();

	// home/_system/quitcheck폜B
	File quitcheck = new File(getParentDirOfBundle(),"home/_system/quitcheck");
	quitcheck.delete();
    }
    
    public void applicationDidBecomeActive(NSNotification notification) {
        // AvP[VtgɂȂƌĂ΂܂B
        // SẴEChEtgɂ܂B
        NSApplication.sharedApplication().arrangeInFront(null);
    }
    
    public void startSSTPServer() {
        // SSTPINĂȂN܂B
        if (sstpDaemon == null || !sstpDaemon.isAlive()) {
            NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
            int port = defaults.integerForKey("sstp_port");
            if (port == 0) port = 11000;
            
            sstpDaemon = new SCSSTPDaemon(port);
            sstpDaemon.start();
        }
    }
    
    public void startSSTPServer(int port) {
        // SSTPINĂȂN܂B
        if (sstpDaemon == null || !sstpDaemon.isAlive()) {
            sstpDaemon = new SCSSTPDaemon(port);
            sstpDaemon.start();
        }
    }
    
    public void stopSSTPServer() {
        // SSTPINĂ~܂B
        if (sstpDaemon != null && sstpDaemon.isAlive()) {
            sstpDaemon.terminate();
        }
    }
    
    public SCSSTPDaemon getSSTPDaemon() {
        return sstpDaemon;
    }
    
    public SCBannerServer getBannerServer() {
	return bannerServer;
    }
    
    public SCStatusWindowCenter getStatusCenter() {
	return statusCenter;
    }
    
    public void startMailCheckDaemon() {
	// I[g[`FbNf[NĂȂN܂B
	// NĂꍇ͏̍XV̂ݍs܂B
	if (mailCheckDaemon == null || !mailCheckDaemon.isAlive()) {
	    mailCheckDaemon = new SCMailCheckDaemon();
	    mailCheckDaemon.start();
	}
	mailCheckDaemon.reloadPref();
    }
    
    public void stopMailCheckDaemon() {
	// I[g[`FbNf[NĂI܂B
	if (mailCheckDaemon != null && mailCheckDaemon.isAlive()) {
	    mailCheckDaemon.terminate();
	}
    }
    
    public SCBalloonSkinServer getBalloonServer(String balloon_path) {
	return getBalloonServer(balloon_path,null);
    }
    public SCBalloonSkinServer getBalloonServer(String balloon_path,SCStatusWindowController status) {
	/*
	  ̃\bh́Ahome/pXŎw肳ꂽo[XL̃T[o[A
	  炩̎iŕԂ܂B
	  Ăяo͂̃\bhԂo[XLT[o[
	  ǂĎ擾ꂽ̂ł邩͍lKv܂B
	  
	  ̃\bh́A܂N̑SẴZbV̒A
	  w肳ꂽo[T[o[ɎĂZbVTA
	  炻ԂAȂVɍ쐬
	  Ԃ܂B
	  
	  ZbV͏I鎞ɂ̎gĂo[T[o[
	  QƂ܂B
	  o[T[o[gZbVSďIɁA
	  ̃T[o[̓S~ƂȂAɃKx[WRNg܂B
	*/
	for (Iterator ite = sessions.iterator(); ite.hasNext(); ) {
	    SCSession ses = (SCSession)ite.next();

	    if (ses.getBalloonServer().getPath().equals(balloon_path)) {
		if (status != null) {
		    status.texttype_print(
			"balloon \"%[color,white]"+
			ses.getBalloonServer().getName()+
			"%[color,default]\" was already loaded.\n");
		}
		return ses.getBalloonServer();
	    }
	}
	for (Iterator ite = temporary_sessions.iterator(); ite.hasNext(); ) {
	    SCSession ses = (SCSession)ite.next();

	    if (ses.getBalloonServer().getPath().equals(balloon_path)) {
		if (status != null) {
		    status.texttype_print(
			"balloon \"%[color,white]"+
			ses.getBalloonServer().getName()+
			"%[color,default]\" was already loaded.\n");
		}
		return ses.getBalloonServer();
	    }
	}
	
	// not found
	SCBalloonSkinServer balloon_server;
	if (status != null) {
	    status.texttype_print("%[color,orange]loading balloon... ");
	    long start_time = System.currentTimeMillis();
	    balloon_server = new SCBalloonSkinServer(balloon_path);
	    status.texttype_print(
		"%[color,white]done.("+
		(System.currentTimeMillis()-start_time)+
		"ms)%[color,default]\n");
	    status.texttype_print(
		"balloon loaded: %[color,yellow]"+
		balloon_server.getName()+
		"%[color,default]\n");
	}
	else {
	    balloon_server = new SCBalloonSkinServer(balloon_path);
	}
	return balloon_server;
    }
    
    public SCSession openSession(String ghost_path,String balloon_path) {
	return openSession(ghost_path,balloon_path,1.0);
    }
	
    public SCSession openSession(
	String ghost_path,String balloon_path,double scale) {
	
	// ǂhome/n܂pXB
        SCSession s = new SCSession(ghost_path,balloon_path);
	s.start();
        s.resizeShell(scale);
	sessions.add(s);
	
	notifyOtherGhostNames();
	
	// temporary_sessionsɓS[XgĂAjB
	final int n_temporaries = temporary_sessions.size();
	for (int i = 0; i < n_temporaries; i++) {
	    SCSession tmp = (SCSession)temporary_sessions.elementAt(i);
	    if (tmp.getGhostDir().equals(s.getGhostDir())) {
		temporary_sessions.removeElementAt(i);
		break;
	    }
	}
	
	return s;
    }
    
    public SCSession openSessionTemporarily(
	String ghost_path, String balloon_path, double scale) {
	
	return openSessionTemporarily(ghost_path, null, balloon_path, scale);
    }
    public SCSession openSessionTemporarily(
	String ghost_path, String shelldir_name,
	String balloon_path, double scale) {

	SCSession s = new SCSession(ghost_path, shelldir_name, balloon_path, true);
	s.start();
	s.resizeShell(scale);
	
	final int n_temp_sessions = temporary_sessions.size();
	if (n_temp_sessions >= TEMPORARY_GHOST_CACHE_SIZE) {
	    // Ō̃ZbVj
	    SCSession last = (SCSession)temporary_sessions.elementAt(n_temp_sessions-1);
	    Logger.log(this, Logger.DEBUG, "cache expired: {"+last+"}");
	    
	    temporary_sessions.remove(n_temp_sessions-1);
	    last.close();

	    last = null;
	    System.gc();
	}
	
	temporary_sessions.add(0,s);
	return s;
    }
        
    public void closeSession(String ghost_path) {
        // ghost_pathhome/n܂pXB
        // w肳ꂽZbVI܂B
        SCSession s = getSession(ghost_path);
        if (s == null) return;
        
        if (s.getStatus() != SCSession.CLOSED) s.close();
        sessions.remove(s);
	notifyOtherGhostNames();
	
	System.gc(); // ŖIɃKx[WRN^𑖂点B
    }
    
    public void closeSession(SCSession s) {
	// ZbVI܂B
	if (s.getStatus() != SCSession.CLOSED) s.close();
	
	sessions.remove(s);
	
	notifyOtherGhostNames();
	System.gc();
    }
    
    public SCSession getSession()
    {
        // ÑZbV̂AǂꂩԂ܂B
        // NĂȂnullԂ܂B
        if (sessions.size() == 0) return null;
        
	int session_idx = (int)((Math.random() * 10000) % sessions.size());
	return (SCSession)sessions.elementAt(session_idx);
    }
    
    public SCSession getSession(String ghostPath) {
        // ÑZbV̒AS[XgpXghostPathłZbVTĕԂ܂B
        // ȂnullԂ܂B
        SCSession result = null;
        int n_sessions = sessions.size();
        for (int i = 0;i < n_sessions;i++)
        {
            SCSession s = (SCSession)sessions.elementAt(i);
            if (s.getGhostPath().equals(ghostPath))
            {
                result = s;
                break;
            }
        }
        return result;
    }
    
    public SCSession getSession(String name,boolean wantAny) {
        /*
	  name:
	  ,ɂイ
	  
	  ɂイ
	  Aw肳ꂽꍇ͊SvAЕ݂̂̏ꍇ͑OvŌ܂B
          
	  wantAnyfalsȅꍇ́AȂnullԂ܂B
	  truȅꍇ́ANĂVF_őIт܂ANĂȂnullԂ܂B
        */
	SCSession result =
	    findSessionInVectorWithSignature(name,sessions);
	
	return (result == null && wantAny ? getSession() : result);
    }
    
    protected static SCSession findSessionInVectorWithSignature(
	String signature,Vector vec) {
	
	int n_sessions = vec.size();
        SCSession result = null;

	boolean both = (signature.indexOf(',') != -1);
	for (int i = 0;i < n_sessions;i++) {
	    SCSession session = (SCSession)vec.elementAt(i);
	    String id = session.getCurrentIdentification();

	    if (both) {
		// w肳ꂽB
                if (id.equals(signature)) {
                    result = session;
                    break;
                }
            }
	    else {
		// Е̎w
		if (id.startsWith(signature)) {
                    result = session;
                    break;
                }
	    }
        }
	
	return result;
    }

    public synchronized SCSession getTemporarySession(String name) {
	return getTemporarySession(name, true);
    }
    public synchronized SCSession getTemporarySession(
	String name, boolean boot_if_not_in_cache) {
	
	// ܂̓LbVTB
	SCSession s = findTemporarySessionInCache(name);

	if (boot_if_not_in_cache) {
	    // ΃CXg[Ă钆TB
	    if (s == null) {
		s = findTemporarySessionInInstalled(name);
	    }
	}
	
	return s;
    }
    protected SCSession findTemporarySessionInCache(String name) {
	SCSession s =
	    findSessionInVectorWithSignature(name, temporary_sessions);
	if (s != null) {
	    // LbV̐擪ɈړB
	    temporary_sessions.remove(s);
	    temporary_sessions.add(0,s);

	    Logger.log(this, Logger.DEBUG, "temporary cache hit: {"+s+"}");
	}
	return s;
    }
    protected SCSession findTemporarySessionInInstalled(String name) {
	/*
	  getSession(String,boolean)Ɠ悤Ƀ}b`OsȂ܂A
	  ̑Ώۂ͋ÑS[Xgł͂ȂACXg[ĂS[XgłB
	  
	  tȂnullԂ܂B
	*/
	Vector installed_list =
	    SCGhostManager.sharedGhostManager().getInstalledGhostList();
	final int n_installed = installed_list.size();
	
	SCInstalledGhostsList.ListsElement found = null;
	String with_special_shell_dir = null;

	boolean both = (name.indexOf(',') != -1);
	for (int i = 0; i < n_installed; i++) {
	    SCInstalledGhostsList.ListsElement le =
		(SCInstalledGhostsList.ListsElement)installed_list.elementAt(i);

	    if (both) {
		// w肳ꂽB
		if (name.equals(le.getIdentification())) {
		    found = le;
		    break;
		}
	    }
	    else {
		// Е̎w
		if (le.getIdentification().startsWith(name)) {
		    found = le;
		    break;
		}
	    }
	    
	    String indep_shell = le.search_id_in_independent_shells(name);
	    if (indep_shell != null) {
		found = le;
		with_special_shell_dir = indep_shell;
		break;
	    }
	}
	
	if (found == null) {
	    return null;
	}
	else {
	    return openSessionTemporarily(
		found.getPath(), with_special_shell_dir, found.getBalloonPath(), found.getScale());
	}
    }
    
    public boolean isAnyoneSpeakingNow() {
	// sessions܂temporary_sessions̒ɁA
	// \tŒĂŒ̃ZbVłtrueԂB
	if (isAnyoneSpeakingNow(temporary_sessions)) {
	    return true;
	}
	else if (isAnyoneSpeakingNow(sessions)) {
	    return true;
	}
	else {
	    return false;
	}
    }
    protected boolean isAnyoneSpeakingNow(Vector vec) {
	final int size = vec.size();
	for (int i = 0; i < size; i++) {
	    SCSession s = (SCSession)vec.elementAt(i);
	    if (s.isScriptRunnerProtected()) {
		return true;
	    }
	}
	return false;
    }
    
    public String getAnyGhostPathInAsleep() {
        // NĂȂS[Xg̒烉_ɑIł̃pXԂ܂B
	// nullԂ܂B
        Vector ghostsInAsleep = SCGhostManager.sharedGhostManager().getAllGhostPathsInAsleep();
	if (ghostsInAsleep.size() == 0) return null;
	
	int sel = (int)((Math.random() * Integer.MAX_VALUE) % ghostsInAsleep.size());
	return (String)ghostsInAsleep.elementAt(sel);
    }
    
    public Vector getSessionsList() {
        // ̍XȂB
        return sessions;
    }
    
    public int numOfSessions() {
	return sessions.size();
    }
    
    public SCPluginManager getPluginManager() {
	return pluginManager;
    }
    
    private void notifyOtherGhostNames() {
	// NĂSĂSHIORINOTIFY OtherGhostName𑗂܂B
	final int n_sessions = sessions.size();
	
	// ÕZbVNĂ牽ł܂BN[ׂ炸B
	for (int i = 0;i < n_sessions;i++) {
	    SCSession receiver = (SCSession)sessions.elementAt(i);
	    SCSpirit spirit_of_receiver = receiver.getMasterSpirit();
	    if (receiver.getMasterSpirit().getShiori() == null) continue;
	    
	    StringBuffer buf = new StringBuffer();
	    if (spirit_of_receiver.getShioriProtocolVersion() == 2) {
		buf.append("NOTIFY OtherGhostName SHIORI/2.3\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
	    }
	    else {
		buf.append("NOTIFY SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
		buf.append("ID: otherghostname\r\n");
	    }
	    
	    for (int j = 0;j < n_sessions;j++) {
		if (j == i) continue; // g
		SCSession toBeSent = (SCSession)sessions.elementAt(j);
		
		if (spirit_of_receiver.getShioriProtocolVersion() == 2) {
		    buf.append("Ghost: "+toBeSent.getMasterSpirit().getSelfName()+"\r\n");
		    buf.append("GhostEx: "+toBeSent.getMasterSpirit().getSelfName()+"\u0001"+toBeSent.getSakura().baseSurfaceId()+"\u0001"+toBeSent.getKero().baseSurfaceId()+"\r\n");
		}
		else {
		    buf.append("Reference"+j+": "+toBeSent.getMasterSpirit().getSelfName()+"\u0001"+toBeSent.getSakura().baseSurfaceId()+"\u0001"+toBeSent.getKero().baseSurfaceId()+"\r\n");
		}
	    }
	    buf.append("\r\n"); // NGXgB
	    
	    receiver.forwardToShioriKernel(buf.toString());
	}
    }
    
    protected void convertKeysOfDefaults() {
	// defaultsɕۑĂS[Xg̃L[shell_pref [path]ghost.pref.[path]ɕύXB
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	
	NSArray keys = defaults.dictionaryRepresentation().allKeys();
	final int n_keys = keys.count();
	boolean dirty = false;
	for (int i = 0;i < n_keys;i++) {
	    String key = (String)keys.objectAtIndex(i);
	    
	    if (key.startsWith("shell_pref")) {
		String newKey = "ghost.pref."+key.substring(11);
		defaults.setObjectForKey(defaults.dictionaryForKey(key),newKey);
		defaults.removeObjectForKey(key);
		dirty = true;
	    }
	}
	
	if (dirty) defaults.synchronize();
    }
    
    public void doMailCheck() {
	SCSession anySession = getSession();
	if (anySession == null || anySession.isInPassiveMode()) return;
	
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	
	String server = (String)defaults.objectForKey("mailcheck_server");
	String username = (String)defaults.objectForKey("mailcheck_username");
	String password = (String)defaults.objectForKey("mailcheck_password");
	
	if (server == null || username == null || password == null) return;
	if (server.length() == 0 || username.length() == 0 || password.length() == 0) return;
	
	anySession.doShioriEvent("OnBIFFBegin",null);
	
	StringBuffer resultdata = new StringBuffer();
	switch (SCMailChecker.pop3check(server,username,password,resultdata)) {
	case	SCMailChecker.RESULT_OK:
	    try {
		String count = resultdata.substring(0, resultdata.toString().indexOf(','));
		String size = resultdata.substring(resultdata.toString().indexOf(',')+1);
		
		anySession.doShioriEvent("OnBIFFComplete",new String[] {count,size});
	    } catch (Exception e) {return;}
	    break;
	    
	case	SCMailChecker.RESULT_CANNOT_CONNECT_TO_SERVER:
	case	SCMailChecker.RESULT_SERVER_RETURNED_ERROR:
	case	SCMailChecker.RESULT_COMMUNICATION_ERROR:
	    anySession.doShioriEvent("OnBIFFFailure",new String[] {"kick"});
	    break;
	    
	case	SCMailChecker.RESULT_USERNAME_WAS_INVALID:
	case	SCMailChecker.RESULT_PASSWORD_WAS_INVALID:
	    anySession.doShioriEvent("OnBIFFFailure",new String[] {"defect"});
	    break;
	    
	case	SCMailChecker.RESULT_COMMAND_STAT_ERROR:
	    anySession.doShioriEvent("OnBIFFFailure",new String[] {"kick"});
	    break;
	    
	case	SCMailChecker.RESULT_COMMUNICATION_TIMEDOUT:
	    anySession.doShioriEvent("OnBIFFFailure",new String[] {"timeout"});
	    break;
	    
	case	SCMailChecker.RESULT_UNEXPECTED_ERROR:
	    anySession.doShioriEvent("OnBIFFFailure",new String[] {"kick"});
	    break;
	}
    }

    /*
    public void mouseMoved(NSEvent theEvent) {
	// NSApplication - delegate
	// mouseMovedCxgȂꍇɁANĂSĂ
	// S[Xg̃VFyуo[mouseMoved𑗂B
	System.out.println("NSApplication - mouseMoved");
	final int n_sessions = sessions.size();
	for (int i = 0;i < n_sessions;i++) {
	    SCSession s = (SCSession)sessions.elementAt(i);
	    s.getSakura().window().mouseMoved(theEvent);
	    s.getKero().window().mouseMoved(theEvent);
	    s.getSakuraBalloon().window().mouseMoved(theEvent);
	    s.getKeroBalloon().window().mouseMoved(theEvent);
	}
    }
    
    public void keyDown(NSEvent theEvent) {
	System.out.println("keyDown");
    }
	
    public void scrollWheel(NSEvent theEvent) {
	System.out.println("scrollWheel");
    }
    */
}
