/*
    $Id: SCGhostManagerWindowController.java,v 1.5 2003/10/04 02:01:57 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.text.*;

public class SCGhostManagerWindowController extends NSWindowController {
    SCGhostManager ghostManager;
    
    // root
    NSTableView table_installed;
    NSTabView tabview_info;
    NSTextField find_box;
    NSButton btn_thumb_view;
    NSDrawer drawer_thumbnail;
    
    // tab CONTROL/PREVIEW
    SCGhostPreviewView view_preview;
    NSTextField fld_scale;
    NSSlider slider_scale;
    NSButton btn_networkupdate;
    NSButton btn_tate_kesi;
    NSButton btn_vanish;
    
    // tab SHELL
    NSTableView table_shell;
    
    // tab BALLOON
    NSTableView table_balloon;
    
    // view DETAIL
    NSTextField fld_identification;
    NSTextField fld_mastershiori;
    NSTextField fld_n_shells;
    NSTextField fld_makoto;
    
    // view THUMBNAIL
    NSImageView image_thumbnail;
    
    public SCGhostManagerWindowController(SCGhostManager s) {
        super("GhostManager");
        window();
	window().setFrameAutosaveName("ghostmanager.frame");
	
	table_balloon.setAutosaveName("ghostmanager.balloontable.columns");
	table_balloon.setAutosaveTableColumns(true);
	
	// ^u̕A
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	String tab_id = (String)defaults.objectForKey("ghostmanager.tabview_info.IdOflastSelectedTab");
	if (tab_id != null) {
	    tabview_info.selectTabViewItemWithIdentifier(tab_id);
	}

	// TlCh[\Ԃ̕d
	if (defaults.integerForKey("ghostmanager.drawer.thumbnail.visible") != 0) {
	    btn_thumb_view.setIntValue(1);
	    //drawer_thumbnail.open();
	}
	
	ghostManager = s;
    }

    public void showWindow(Object sender) {
	super.showWindow(sender);
	
	if (btn_thumb_view.intValue() != 0) {
	    drawer_thumbnail.open(); // h[JȂhack
	    drawer_thumbnail.contentView().window().display(); // h[ĕ`悳Ȃhack
	}
    }
    
    /******** delegate methods ********/
    public boolean windowShouldClose(Object sender) {
        // Ԃdefaultsɕۑ܂B
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
        defaults.setObjectForKey(tabview_info.selectedTabViewItem().identifier(),"ghostmanager.tabview_info.IdOflastSelectedTab");
	defaults.setIntegerForKey(btn_thumb_view.intValue(), "ghostmanager.drawer.thumbnail.visible");
        
        defaults.synchronize();
        return true; // falseԂ΃N[YH~߂B
    }
	
    public NSTextField getFindBox() {
	return find_box;
    }
    
    public SCGhostPreviewView getPreviewView()
    {
		return view_preview;
    }
    
    public NSTableView getTableInstalled()
    {
        return table_installed;
    }
    
    public NSTableView getTableBalloons()
    {
        return table_balloon;
    }
    
    public NSTextField getScaleIndicator()
    {
        return fld_scale;
    }
    
    public NSSlider getScaleSlider()
    {
        return slider_scale;
    }
    
    public void setMasterShioriKernelName(String name)
    {
        fld_mastershiori.setStringValue(name);
    }
    
    public void setMakotoName(String name)
    {
		fld_makoto.setStringValue(name);
    }
    
    public void setIdentification(String id)
    {
        fld_identification.setStringValue(id);
    }
    
    // Actions
	public void findBoxUpdated(Object sender)
	{
		ghostManager.getInstalledList().findBoxUpdated();
	}
	
    public void tate_kesi(Object sender)
    {
		ghostManager.getInstalledList().bootOrQuit();
    }
    
    public void networkupdate(Object sender)
    {
		ghostManager.getInstalledList().networkupdate();
    }
    
    public void vanish(Object sender)
    {
		ghostManager.getInstalledList().vanish();
    }
    
    public void reloadLists(Object sender)
    {
		SCOldTypeConverter.convertAll();
		SCOldBalloonConverter.convertAll();
		SCGhostThumbnailMover.moveAll();
		ghostManager.reloadLists();
    }
    
    public void slider_scale(Object sender)
    {
        updateScaleIndicator();
        ghostManager.getInstalledList().changeScale(slider_scale.doubleValue());
    }
    
    public void updateScaleIndicator()
    {
        String value = (int)(slider_scale.doubleValue() * 100) + "%";
        fld_scale.setStringValue(value);
    }
    
    public NSTableView getTableShells()
    {
		return table_shell;
    }
    
    public void setNumberOfShells(int n)
    {
		// -1Ȃ܂B
		if (n == -1)
		{
			fld_n_shells.setStringValue("");
		}
		else
		{
			fld_n_shells.setIntValue(n);
		}
		fld_n_shells.setTextColor(n == 1 || n == -1 ? NSColor.blackColor() : NSColor.redColor());
    }
    
    public void setThumbnail(NSImage img)
    {
		image_thumbnail.setImage(img);
    }
    
    public void setEnabledOfNetworkUpdateButton(boolean bool)
    {
		btn_networkupdate.setEnabled(bool);
    }
    
    public void setEnabledOfVanishButton(boolean bool)
    {
		btn_vanish.setEnabled(bool);
    }
    
    public NSButton getBootAndQuitButton()
    {
		return btn_tate_kesi;
    }
}
