/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

public class SCImageUtils
{
    /*
	̃NXObjective-Cŏꂽۂ̃R[hJavaĂяõׂANZbTłB
    */
    protected static SCImageUtils_Impl implimentation;
    protected static NSObjectiveCSelector sel_getBottomRightColor;
    protected static NSObjectiveCSelector sel_getTopLeftColor;
    static
    {
	implimentation = new SCImageUtils_Impl(); // shared object
	sel_getBottomRightColor = new NSObjectiveCSelector("getBottomRightColor:");
	sel_getTopLeftColor = new NSObjectiveCSelector("getTopLeftColor:");
    }
    
    public static NSColor getBottomRightColor(NSImage img)
    {
	try
	{
	    return (NSColor)sel_getBottomRightColor.invoke(implimentation,new Object[] {img});
	}
	catch (Exception e)
	{
	    System.err.println("SCImageUtils : Couldn\'t call the obj-c method getBottomRightColor:");
	    e.printStackTrace();
	    return null;
	}
    }
    
    public static NSColor getTopLeftColor(NSImage img)
    {
	try
	{
	    return (NSColor)sel_getTopLeftColor.invoke(implimentation,new Object[] {img});
	}
	catch (Exception e)
	{
	    System.err.println("SCImageUtils : Couldn\'t call the obj-c method getTopLeftColor:");
	    e.printStackTrace();
	    return null;
	}
    }
}
