/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "SCImageUtils_Impl.h"


@implementation SCImageUtils_Impl

- (id)_initWithJavaObject:(id)sender
{
    return self;
}

- (NSColor *)getBottomRightColor:(NSImage *)img
{
    NSBitmapImageRep *bitmap = [[img representations] objectAtIndex:0];
    unsigned char *data = [bitmap bitmapData];
    int spp = [bitmap samplesPerPixel];
    int bytesPerPlane = [bitmap bytesPerPlane];
    float r,g,b,a;
    
    r = g = b = a = 0.0f; // [jÖׁB
    switch (spp)
    {
	case	3:
	    // Ō3oCgꂼr,g,bB
	    r = data[bytesPerPlane - 3] / 255.0f;
	    g = data[bytesPerPlane - 2] / 255.0f;
	    b = data[bytesPerPlane - 1] / 255.0f;
	    return [NSColor colorWithCalibratedRed:r green:g blue:b alpha:1.0f];
	
	case	4:
	    // Ō4oCgꂼr,g,b,aB
	    r = data[bytesPerPlane - 4] / 255.0f;
	    g = data[bytesPerPlane - 3] / 255.0f;
	    b = data[bytesPerPlane - 2] / 255.0f;
	    a = data[bytesPerPlane - 1] / 255.0f;
	    return [NSColor colorWithCalibratedRed:r green:g blue:b alpha:a];
	
	default:
	    return NULL;
    }
}

- (NSColor *)getTopLeftColor:(NSImage *)img
{
    NSBitmapImageRep *bitmap = [[img representations] objectAtIndex:0];
    unsigned char *data = [bitmap bitmapData];
    int spp = [bitmap samplesPerPixel];
    float r,g,b,a;
    
    r = g = b = a = 0.0f; // [jÖׁB
    switch (spp)
    {
	case	3:
	    // ŏ3oCgꂼr,g,bB
	    r = data[0] / 255.0f;
	    g = data[1] / 255.0f;
	    b = data[2] / 255.0f;
	    return [NSColor colorWithCalibratedRed:r green:g blue:b alpha:1.0f];
	
	case	4:
	    // ŏ4oCgꂼr,g,b,aB
	    r = data[0] / 255.0f;
	    g = data[1] / 255.0f;
	    b = data[2] / 255.0f;
	    a = data[3] / 255.0f;
	    return [NSColor colorWithCalibratedRed:r green:g blue:b alpha:a];
	
	default:
	    return NULL;
    }
}

@end
