/*  $Id: SCInstaller.java,v 1.8 2004/04/09 08:34:27 phonohawk Exp $

    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.zip.*;
import java.util.*;
import java.io.*;

/*
    %lastghostname%lastobjectnameAt@Cj󂷂鋰̂ŁA
    ̃Xbh͌ēȏ㓯ɑ点ȂłB
*/

public class SCInstaller extends Thread {
    private static String LAST_GHOST_NAME;
    private static String LAST_OBJECT_NAME;
    
    String fpath;
    SCSession target;
    boolean deleteAfterSuccess;
    
    public SCInstaller(String fpath) {
	this.fpath = fpath;
	this.target = null;
	this.deleteAfterSuccess = false;
    }
    
    public SCInstaller(String fpath,SCSession target) {
	// targetnull̏ꍇA
	// [1] supplementłȂ΋ÑZbV̂ǂꂩ^[Qbgɐݒ肵āA
	//     NĂȂCXg[Cxg𔭍sɖقăCXg[s܂B
	// [2] supplement炻̃A[JCuw肷ZbV^[Qbgɐݒ肵āA
	//     NĂȂ΃G[oďI܂B
	this.fpath = fpath;
	this.target = target;
	this.deleteAfterSuccess = false;
    }
    
    public SCInstaller(String fpath,SCSession target,boolean deleteAfterSuccess) {
	this.fpath = fpath;
	this.target = target;
	this.deleteAfterSuccess = deleteAfterSuccess;
    }
    
    public void run() {
	if (target != null && target.isInPassiveMode()) return; // pbVu[hł΋IB
	int pool = NSAutoreleasePool.push();
	
	sendInstallEvent("OnInstallBegin");
	
	SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	stat.setTypeToText();
	stat.show();
	stat.texttype_print("Installer started...\n");
	
	final ZipFile zf;
	try {
	    zf = new ZipFile(fpath);
	}
	catch (ZipException e) {
	    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.zipException");
	    stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
	    return;
	}
        catch (IOException e) {
	    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.ioException");
            stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
            return;
        }
        
        // install.txtGgTB
	// A[JCũ[g猩čł󂢈ʒuɂt@CgpB
	Enumeration entries = zf.entries();
	ZipEntry instDefEntry = null;
	int garbageCharsOfPath = -1; // install.txtւǂ蒅܂ł̃pX̒
	while(entries.hasMoreElements()) {
	    ZipEntry ent = (ZipEntry)entries.nextElement();
	    if (ent.getName().endsWith("/install.txt") || ent.getName().equals("install.txt")) {
		int temp_garbage = ent.getName().indexOf("install.txt");
		
		if (garbageCharsOfPath == -1 || temp_garbage < garbageCharsOfPath) {
		    instDefEntry = ent;
		    garbageCharsOfPath = temp_garbage;
		}
	    }
	}
        if (instDefEntry == null) {
	    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.descriptionNotFound");
	    stat.texttype_print("install.txt : %[color,yellow]*** NONE ***%[color,default]\n");
            stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
            return;
        }
	else {
	    stat.texttype_println("install.txt : %[color,orange]"+instDefEntry.getName()+"%[color,default]");
	}
	
	// ǂݍ
	SCDescription install_txt;
	try {
	    install_txt = new SCDescription(zf.getInputStream(instDefEntry));
	}
	catch (IOException e) {
	    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.ioException");
	    stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
	    return;
	}
	String type = install_txt.getStrValue("type");
	String directory = install_txt.getStrValue("directory");
	String name = install_txt.getStrValue("name");
	String accept = install_txt.getStrValue("accept");
	String script = install_txt.getStrValue("script");
	String balloon_directory = install_txt.getStrValue("balloon.directory");
	String refreshundeletemask = install_txt.getStrValue("refreshundeletemask");
	String permission = install_txt.getStrValue("permission"); // foo=755:bar=400:baz=666:saitama/taiyou=700
	String sh = install_txt.getStrValue("sh"); // foo.sh
	boolean refresh = false;
	if (install_txt.exists("refresh")) {
	    refresh = install_txt.getStrValue("refresh").equals("1");
	}
	boolean is_normal_dir = true; // ...A../foołfalseB
	if (directory != null) {
	    if (directory.equals(".") || directory.equals("..") ||
		directory.startsWith("./") || directory.startsWith("../")) {
		is_normal_dir = false;
	    }
	}

	// typesaoripluginłȂ̂is_normal_dirfalseȂG[B
	if (!type.equals("saori") && !type.equals("plugin") && !is_normal_dir) {
	    String errorString = "Security Error: bad directory for this type";
	    stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
            return;
	}
	
	stat.texttype_println("type : %[color,orange]"+type+"%[color,default]");
        if (!type.equals("shell") && !type.equals("ghost") && !type.equals("balloon") &&
	    !type.equals("plugin") && !type.equals("supplement") && !type.equals("saori")) {
	    String errorString = SCErrorStringServer.getErrorMessage(
		"foundation.installer.undefinedType",new String[] {type});
            stat.texttype_println(errorString);
	    stat.closeWindow();
	    sendInstallEvent("OnInstallFailure",new String[] {errorString});
	    NSAutoreleasePool.pop(pool);
            return;
        }
		
	// permission
	Hashtable chmod_table = new Hashtable();
	if (permission != null) {
	    try {
		StringTokenizer st = new StringTokenizer(permission,":");
		while (st.hasMoreTokens()) {
		    String file = st.nextToken();
		    
		    int equalpos = file.indexOf('=');
		    if (equalpos == -1) {
			throw new Exception("Illegal permission; '=' not found: "+file);
		    }
		    
		    try {
			String fpath = file.substring(0,equalpos).trim();
			int mode = Integer.parseInt(file.substring(equalpos+1).trim(),8);
			
			chmod_table.put(fpath,new Integer(mode));
		    }
		    catch (Exception ex) {
			throw new Exception("Illegal permission; "+ex.toString()+"; "+file);
		    }
		}
	    }
	    catch (Exception e) {
		stat.texttype_println("%[color,red]"+e.getMessage()+"%[color,default]");
		stat.closeWindow();
		sendInstallEvent("OnInstallFailure",new String[] {e.getMessage()});
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
	
	// ^[Qbgw蓙
	if (target == null) {
	    if (!type.equals("supplement") && !type.equals("shell")) {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("directory : %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = name;
		
		target = SCFoundation.sharedFoundation().getSession();
	    }
	    else {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("accept : %[color,yellow]"+accept+"%[color,default]");
		if (type.equals("shell")) stat.texttype_println("directory: %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = accept;
		LAST_OBJECT_NAME = name;
		
		target = SCFoundation.sharedFoundation().getSession(accept,false);
		if (target == null) { // acceptwZbVNĂȂ
		    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.supplementTargetNotBooted",new String[] {accept});
		    stat.texttype_println("%[color,red]"+errorString+"%[color,default]");
		    stat.closeWindow();
		    sendInstallEvent("OnInstallFailure",new String[] {errorString});
		    NSAutoreleasePool.pop(pool);
		    return;
		}
	    }
	}
	else {
	    if (!type.equals("supplement")) {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("directory : %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = name;
	    }
	    else {
		stat.texttype_println("name : %[color,white]"+name+"%[color,default]");
		stat.texttype_println("accept : %[color,yellow]"+accept+"%[color,default]");
		if (type.equals("shell")) stat.texttype_println("directory: %[color,orange]"+directory+"%[color,default]");
		LAST_GHOST_NAME = accept;
		LAST_OBJECT_NAME = name;
	    }
	    
	    if ((type.equals("supplement") || type.equals("shell")) && !target.getMasterSpirit().getSelfName().equals(accept)) {
		String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.supplementRefused",new String[] {accept});
		stat.texttype_println("%[color,red]"+errorString+"%[color,default]");
		stat.closeWindow();
		sendInstallEvent("OnInstallRefuse",new String[] {accept});
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
        
        SCFoundation.sharedFoundation().checkAndMakeSystemDirs();
        
	final String destDirPathFromHome;
	final File destDir;
	if (type.equals("supplement")) {
	    destDirPathFromHome = target.getGhostPath();
	    destDir = new File(SCFoundation.getParentDirOfBundle(),destDirPathFromHome);
	    stat.texttype_println("destination : %[color,orange]"+destDirPathFromHome+"%[color,default]");
	}
	else if (type.equals("shell")) {
	    // w肳ꂽOŃfBNgB
	    destDirPathFromHome = target.getGhostPath()+"/shell/"+directory; // homen܂fBNgւ̃pXB
	    destDir = new File(SCFoundation.getParentDirOfBundle(),destDirPathFromHome);
	    
	    stat.texttype_println("directory %[color,orange]"+destDirPathFromHome+"%[color,default] exists : %[color,white]"+(destDir.exists() ? "YES" : "NO")+"%[color,default]");
	    destDir.mkdir();
	    stat.texttype_println("%[color,white]created "+destDirPathFromHome+"%[color,default]");
	}
	else {
	    // w肳ꂽOŃfBNgB
	    destDirPathFromHome = "home/"+type+"/"+directory; // homen܂fBNgւ̃pXB
	    destDir = new File(SCFoundation.getParentDirOfBundle(),destDirPathFromHome);
	    
	    stat.texttype_println("directory %[color,orange]"+destDirPathFromHome+"%[color,default] exists : %[color,white]"+(destDir.exists() ? "YES" : "NO")+"%[color,default]");
	    destDir.mkdir();
	    stat.texttype_println("%[color,white]created "+destDirPathFromHome+"%[color,default]");
	}
	
	// refresh
	stat.texttype_println("refresh : "+(refresh ? "%[color,yellow]YES%[color,default]" : "NO"));
	if (refresh && is_normal_dir) {
	    if (refreshundeletemask == null) {
		SCFileUtils.deleteRecursively(destDir); // S
	    }
	    else {
		// RŃZp[gĂ̂łVector<String>ɂB
		StringTokenizer st = new StringTokenizer(refreshundeletemask,":");
		Vector mask = new Vector();
		while (st.hasMoreTokens()) {
		    mask.add(st.nextToken());
		}
		SCFileUtils.deleteRecursively(destDir,mask);
	    }
	    destDir.mkdir();
	    stat.texttype_println("%[color,yellow]refreshed : "+destDirPathFromHome+"%[color,default]");
	}
	
	// with balloon
	final String destBalloonDirPathFromHome;
	final File home_balloon = new File(SCFoundation.getParentDirOfBundle(),"home/balloon");
	if (balloon_directory != null) {
	    destBalloonDirPathFromHome = "home/balloon/"+balloon_directory;
	    File destBalloonDir = new File(SCFoundation.getParentDirOfBundle(),"home/balloon/"+balloon_directory);
	    
	    stat.texttype_println("%[color,white]\"with balloon\" directory : "+balloon_directory);
	    stat.texttype_println("\"with balloon\" directory "+destBalloonDirPathFromHome+" exists : "+(destBalloonDir.exists() ? "%[color,orange]YES%[color,white]" : "NO")+"%[color,default]");
	    if (!destBalloonDir.exists()) {
		destBalloonDir.mkdir();
		stat.texttype_println("%[color,white]created "+destBalloonDirPathFromHome+"%[color,default]");
	    }
	}
	else {
	    destBalloonDirPathFromHome = null;
	}
        // ۂɃCXg[Binstall.txt͏OB
	
	final int n_entries = zf.size();
	SCStatusWindowController prog = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	prog.setTypeToProgressBar();
	prog.show();
	prog.pbartype_setText1("Extracting archive...");
	
	int installedItemsCount = 0;
	int current_entry_index = -1;
        for ( Enumeration e = zf.entries() ; e.hasMoreElements() ; ) {
	    current_entry_index++;
	    prog.pbartype_setVal((double)current_entry_index / (double)n_entries);
	    
            ZipEntry curEnt = (ZipEntry)e.nextElement();
            
            // Ggɍ쐬t@C/fBNg̃pX߂B
            File pathToDest = null;
	    String valid_name = null;
            try {
		// R[hSJISƂB~ނ𓾂ȂB
		// łɃfR[ho҂Ȃꍇ₤Łc
		valid_name = new String(curEnt.getName().getBytes(), "SJIS").substring(garbageCharsOfPath);
		if (balloon_directory != null && valid_name.startsWith(balloon_directory)) {
		    pathToDest = new File(home_balloon,valid_name);
		}
		else {
		    pathToDest = new File(
			destDir,
			valid_name
			);
		}
            } catch (Exception ex) {
		ex.printStackTrace();
	    }
	    if (pathToDest.getName().equals("install.txt") || pathToDest.getName().equals("delete.txt")) {
		// install.txtOB
		// ȂsupplementCXg[ۂɍŌɓꂽsupplementinstall.txt݂̂cB
		
		// delete.txtOB
		continue;
	    }
	    if (pathToDest.exists()) {
		if (pathToDest.isFile()) {
		    // t@C폜B
		    pathToDest.delete();
		}
	    }
	    prog.pbartype_setText2(valid_name);
	    
	    installedItemsCount++;
	    
            if (curEnt.isDirectory()) { // fBNg
		if (!pathToDest.exists()) { // ݂Ȃ΍쐬B
		    try {
			pathToDest.mkdir();
		    }
		    catch (Exception ex) {
			ex.printStackTrace();
		    }
		}
            }
            else { // t@C璆gRs[B
                try {
                    // zipWJRs[
		    pathToDest.getParentFile().mkdirs(); // fBNgGg݂ȂꍇɔBThanx > MacX2.0113
                    InputStream inStream = zf.getInputStream(curEnt);
		    if (inStream == null) {
			stat.texttype_println("Unzip error: "+valid_name);
			installedItemsCount--;
			continue;
		    }
                    FileOutputStream outStream = new FileOutputStream(pathToDest);
                    byte[] data = new byte[2048];
                    int bytesRead;
                    do {
                        bytesRead = inStream.read(data);
                        if (bytesRead != -1) {
                            outStream.write(data,0,bytesRead);
                        }
                    } while (bytesRead > 0);
		    outStream.close();
		    
		    // chmod tableɊY鍀ڂ΁AchmodsB
		    Integer mode = (Integer)chmod_table.get(valid_name);
		    if (mode != null) {
			SCUnixSystemCalls.chmod(pathToDest.getAbsolutePath(),mode.intValue());
		    }
                }
                catch (IOException ex) {
		    String errorString = SCErrorStringServer.getErrorMessage("foundation.installer.ioException");
		    prog.pbartype_setText1("Error!");
		    prog.closeWindow();
                    stat.texttype_println(errorString);
		    stat.closeWindow();
		    sendInstallEvent("OnInstallFailure",new String[] {errorString});
		    NSAutoreleasePool.pop(pool);
                    return;
                }
		catch (Exception ex) {
		    stat.texttype_println("Install error ("+ex.toString()+"): "+valid_name);
		    installedItemsCount--;
		}
            }
        }
	prog.pbartype_setVal(1.0);
	prog.pbartype_setText1("Done.");
	prog.pbartype_setText2(null);
	prog.closeWindow();
	stat.texttype_println("installed "+installedItemsCount+" items");
	
	// with balloon
	if (balloon_directory != null) {
	    try {
		SCGhostManager.sharedGhostManager().getInstalledList().
		    changeBalloonOfGhost(destDirPathFromHome,destBalloonDirPathFromHome);
	    }
	    catch (Exception ex) {
		ex.printStackTrace();
	    }
	}
	
	// delete.txtΎs
	ZipEntry delete_txt_entry = null;
        for ( Enumeration e = zf.entries() ; e.hasMoreElements() ; ) {
            ZipEntry curEnt = (ZipEntry)e.nextElement();
	    
	    if (curEnt.getName().endsWith("/delete.txt") || curEnt.getName().equals("delete.txt")) {
		delete_txt_entry = curEnt;
	    }
	}
	if (delete_txt_entry == null) {
	    stat.texttype_println("delete.txt : %[color,yellow]*** NONE ***%[color,default]");
	}
	else {
	    try {
		stat.texttype_println("delete.txt : %[color,orange]"+delete_txt_entry.getName()+"%[color,default]");
		SCDeletesList dlist = new SCDeletesList(zf.getInputStream(delete_txt_entry));
		final int n_dfiles = dlist.size();
		
		SCStatusWindowController prog_del = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
		prog_del.setTypeToProgressBar();
		prog_del.show();
		prog_del.pbartype_setText1("Deleting...");
		
		for (int i = 0;i < n_dfiles;i++) {
		    prog_del.pbartype_setVal((double)i / (double)n_dfiles);
		    prog_del.pbartype_setText2(dlist.getFile(i));
					
		    File fileToDel = new File(destDir,dlist.getFile(i));
		    if (fileToDel.exists()) {
			SCFileUtils.deleteRecursively(fileToDel);
						
			prog_del.pbartype_setText2(dlist.getFile(i));
			stat.texttype_println("%[color,yellow]deleted : "+dlist.getFile(i)+"%[color,default]");
		    }
		}
		prog_del.pbartype_setVal(1.0);
		prog_del.closeWindow();
	    }
	    catch (Exception e) {
		e.printStackTrace();
	    }
	}

	// shΎsBAtypesaori܂plugin̏ꍇ̂݁B
	if (sh != null && (type.equals("saori") || type.equals("plugin"))) {
	    stat.texttype_println("%[color,red]shell script exists : "+sh+"%[color,default]");
	    try {
		Process p = Runtime.getRuntime().exec(
		    new String[] {"/bin/sh", sh},
		    null,
		    destDir);
		
		// I҂
		while (true) {
		    try {
			p.waitFor();
			break;
		    }
		    catch (InterruptedException e) {}
		}

		stat.texttype_println("%[color,green]"+sh+" exitted with status "+p.exitValue()+"%[color,default]");
	    }
	    catch (Exception e) {
		e.printStackTrace();
	    }
	    // sht@CB
	    new File(destDir, sh).delete();
	}
		
	if (deleteAfterSuccess) {
	    File archive = new File(fpath);
	    archive.delete();
	    stat.texttype_println("%[color,white]deleted local archive "+archive.getName()+"%[color,default]");
	}
	
	stat.texttype_println("%[color,orange]INSTALL completed.%[color,default]");
	stat.closeWindow();
	if (type.equals("supplement")) {
	    if (script != null) {
		target.runScript(replaceInstallerEnvs(script),false);
	    }
	}
	else {
	    if (balloon_directory != null) { // with balloon
		sendInstallEvent("OnInstallComplete",new String[] {type,name,balloon_directory});
	    }
	    else { // ʏpbP[W
		sendInstallEvent("OnInstallComplete",new String[] {type,name});
	    }
	}

	try {
	    SCGhostManager.sharedGhostManager().reloadLists();
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
	
	try {
	    zf.close();
	} catch (IOException ex) {}
	
	// typeghostballoonłreadme.txt݂΂JB
	if (type.equals("ghost") || type.equals("balloon")) {
	    File readme_txt = new File(destDir,"readme.txt");
	    if (readme_txt.exists()) {
		//new SCDocumentWindowController(readme_txt,destDirPathFromHome+"/readme.txt").showWindow(null);
		NSWorkspace.sharedWorkspace().openFile(readme_txt.getPath(),null,true);
	    }
	}
	
	// typepluginȂvOC}l[W[hB
	if (type.equals("plugin")) {
	    SCFoundation.sharedFoundation().getPluginManager().rescan();
	    
	    // ݒpl̃vOCXgr[[hB
	    SCPrefWindowController.sharedPrefWindowController().reloadPluginList();
	}
	
	// meBtBP[Vuinstaller.endv𔭍sB
	// ɂăS[Xg}l[W[hB
	NSNotificationCenter.defaultCenter().postNotification("installer.end",null,null);
	
	NSAutoreleasePool.pop(pool);
    }
    
    public void waitUntilEnd()
    {
		while (isAlive()) {}
    }
    
    private void sendInstallEvent(String eventName,String[] references)
    {
		if (target != null) target.doShioriEvent(eventName,references);
    }
    
    private void sendInstallEvent(String eventName)
    {
		if (target != null) target.doShioriEvent(eventName);
    }
    
    public static String replaceInstallerEnvs(String script) {
	// CXg[[ϐ%lastobjectname,%lastghostnameuĕԂ܂B
	StringBuffer buf = new StringBuffer(script);
	while (true) {
	    int pos = buf.toString().indexOf("%lastobjectname");
	    if (pos == -1) break;
	    
	    buf.replace(pos,pos+("%lastobjectname".length()),LAST_OBJECT_NAME);
	}
	while (true) {
	    int pos = buf.toString().indexOf("%lastghostname");
	    if (pos == -1) break;
	    
	    buf.replace(pos,pos+("%lastghostname".length()),LAST_GHOST_NAME);
	}
	return buf.toString();
    }
}
