/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.net.*;
import java.util.*;
import java.io.*;

public class SCMailChecker
{
    public static final int RESULT_OK = 0;
    public static final int RESULT_CANNOT_CONNECT_TO_SERVER = -1;
    public static final int RESULT_SERVER_RETURNED_ERROR = -2;
    public static final int RESULT_COMMUNICATION_ERROR = -3;
    public static final int RESULT_USERNAME_WAS_INVALID = -4;
    public static final int RESULT_PASSWORD_WAS_INVALID = -5;
    public static final int RESULT_COMMAND_STAT_ERROR = -6;
    public static final int RESULT_COMMUNICATION_TIMEDOUT = -7;
    public static final int RESULT_UNEXPECTED_ERROR = -100;
    
    public static int pop3check(String server,String username,String password,StringBuffer result)
    {
	// POP3T[o[ɃANZXāA[̌Ƃ̍voCg߂܂B
	// ʂresultɕԂÃtH[}bg
	// ,oCg
	// ƂȂ܂B
	// result͂炩ߍ쐬ĂĉB
	
	// ͐߂܂̂ŁAƗXbhŎgقłB
	
	Socket s = null;
	try
	{
	    s = new Socket(server,110);
	    s.setSoTimeout(10 * 1000);
	}
	catch (Exception e) {return RESULT_CANNOT_CONNECT_TO_SERVER;}
	
	BufferedReader in = null;
        DataOutputStream out = null;
	try
	{
	    in = new BufferedReader(new InputStreamReader(s.getInputStream()));
	    out = new DataOutputStream(s.getOutputStream());
	}
	catch (Exception e) {return RESULT_UNEXPECTED_ERROR;}
	
	String resp;
	try
	{
	    // ڑB+OKłȂ΃G[B
	    resp = in.readLine();
	    if (resp == null || !resp.startsWith("+OK")) {s.close(); return RESULT_SERVER_RETURNED_ERROR;}
	    
	    // F
	    out.writeBytes("USER "+username); crlfAndFlush(out);
	    resp = in.readLine();
	    if (resp == null || !resp.startsWith("+OK")) {s.close(); return RESULT_USERNAME_WAS_INVALID;}
	    out.writeBytes("PASS "+password); crlfAndFlush(out);
	    resp = in.readLine();
	    if (resp == null || !resp.startsWith("+OK")) {s.close(); return RESULT_PASSWORD_WAS_INVALID;}
	    
	    // STATs
	    out.writeBytes("STAT"); crlfAndFlush(out);
	    resp = in.readLine();
	    if (resp == null || !resp.startsWith("+OK")) {s.close(); return RESULT_COMMAND_STAT_ERROR;}
	    try
	    {
		StringTokenizer st = new StringTokenizer(resp," ");
		st.nextToken(); // +OK̂Ă
		result.setLength(0);
		result.append(st.nextToken() + "," + st.nextToken());
	    }
	    catch (Exception e) {s.close(); return RESULT_COMMAND_STAT_ERROR;}
	    
	    // QUITs
	    out.writeBytes("QUIT"); crlfAndFlush(out);
	    s.close();
	}
	catch (InterruptedIOException e) {return RESULT_COMMUNICATION_TIMEDOUT;}
	catch (Exception e) {return RESULT_COMMUNICATION_ERROR;}
	
	return RESULT_OK;
    }
    
    private static void crlfAndFlush(DataOutputStream out)
    {
	try
	{
	    out.write(13);
	    out.write(10);
	    out.flush();
	}
	catch (Exception e){}
    }
}
