/*
	$Id: SCMenuController.java,v 1.2 2002/12/08 16:10:05 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

/*
    Cj[
    
    ʏ̍ڂid = 0B
    uւv̓}[J[ƂȂĂAid = 1B̉ɒւgSERIKÕVFA˂܂B
    ւɑΉĂVF̍ڂid = 2ɂȂĂ܂B
    ܂bindtSERIKOIۂid = 2̍ڂ폜ׂڂ܂B
    
    ւTuj[ĩ^Cg̓VFj̒g̍ڂ́A
    idbindgroupidłA{̑͐̐łɂイ͕̐i܂ΒlidjɂȂ܂B
*/

public class SCMenuController implements NSMenu.MenuValidation
{
    private static SCMenuController _sharedInstance = null;
    
    NSMenuItem showPrefWindow;
    NSMenuItem quit;
    
    NSMenu mainmenu;
    NSMenuItem mailcheck;
    
    public static SCMenuController sharedMenuController()
    {
        return _sharedInstance;
    }
    
    public SCMenuController()
    {
        _sharedInstance = this;
    }
    
    public void quit(Object sender)
    {
		SCFoundation.sharedFoundation().performQuit();
    }
    
    public void pseudoAI(Object sender)
    {
        // fobOpB
        // AĨZt𒝂点܂B
        SCSession anySession = SCFoundation.sharedFoundation().getSession();
        if (anySession != null)
        {
            anySession.doShioriRandomTalk();
        }
    }
    
    public void eventOnBoot(Object sender)
    {
		// fobOpB
		// OnBootCxg𑗂܂B
		SCSession anySession = SCFoundation.sharedFoundation().getSession();
        if (anySession != null)
        {
            anySession.doShioriEvent("OnBoot",new String[] {anySession.getCurrentShell().getShellName()});
        }
    }
    
    public void showPrefWindow(Object sender)
    {
        SCPrefWindowController pwc = SCPrefWindowController.sharedPrefWindowController();
        pwc.showWindow(null);
    }
    
    public void showShellManager(Object sender)
    {
        SCGhostManager shellm = SCGhostManager.sharedGhostManager();
        shellm.showManagerWindow();
    }
    
    public void doMailCheck(Object sender)
    {
		SCFoundation.sharedFoundation().doMailCheck();
    }
    
    public void showUpdateChecker(Object sender)
    {
		SCUpdateChecker.sharedUpdateChecker().showWindow();
    }
    
    public void toggleShioriLog(Object sender)
    {
		SCFoundation.LOG_SHIORI_SESSION = !SCFoundation.LOG_SHIORI_SESSION;
    }
    
    public void toggleShioriLocked(Object sender)
    {
		SCFoundation.LOCK_SHIORI_EVENTS = !SCFoundation.LOCK_SHIORI_EVENTS;
		((NSMenuItem)sender).setState(SCFoundation.LOCK_SHIORI_EVENTS ? NSCell.OnState : NSCell.OffState);
    }
    
    public boolean validateMenuItem(_NSObsoleteMenuItemProtocol menuItem)
    {
        if (menuItem == showPrefWindow)
        {
            SCPrefWindowController pref = SCPrefWindowController.sharedPrefWindowController();
            return !pref.window().isVisible();
        }
		else if (menuItem == mailcheck)
		{
			SCSession anySession = SCFoundation.sharedFoundation().getSession();
			if (anySession == null) return false;
			
			NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
			
			if (defaults.integerForKey("mailcheck_check_enable") != 1) return false;
			
			String workstr;
			workstr = (String)defaults.objectForKey("mailcheck_server");
			if (workstr == null || workstr.length() == 0) return false;
			workstr = (String)defaults.objectForKey("mailcheck_username");
			if (workstr == null || workstr.length() == 0) return false;
			workstr = (String)defaults.objectForKey("mailcheck_password");
			if (workstr == null || workstr.length() == 0) return false;
			
			return true;
		}
		else if (menuItem == quit)
		{
			// pbVu[hɓĂZbVłfalseB
			Vector sessions = SCFoundation.sharedFoundation().getSessionsList();
			final int n_sessions = sessions.size();
			for (int i = 0;i < n_sessions;i++)
			{
				SCSession session = (SCSession)sessions.elementAt(i);
				if (session.isInPassiveMode()) return false;
			}
			return true;
		}
        
        return true;
    }
    
    public NSMenu makeNewBindGroupSubMenu(String title)
    {
		// ւSERIKOTuj[쐬ĕԂ܂B
		// ID 1iځuւvj̉ɑ}܂B
		NSMenuItem item_submenu = new NSMenuItem(title,null,"");
		item_submenu.setTag(2);
		mainmenu.insertItemAtIndex(item_submenu,mainmenu.indexOfItemWithTag(1) + 1);
		
		NSMenu submenu = new NSMenu();
		submenu.setAutoenablesItems(false);
		item_submenu.setSubmenu(submenu);
		
		return submenu;
    }
    
    public void removeBindGroupSubMenu(String title)
    {
		// ւSERIKOTuj[č폜܂B
		// ID 2̒猟܂B
		NSArray items = mainmenu.itemArray();
		int n_items = items.count();
		for (int i = 0;i < n_items;i++)
		{
			NSMenuItem item = (NSMenuItem)items.objectAtIndex(i);
			if (item.tag() == 2 && item.title().equals(title))
			{
				mainmenu.removeItemAtIndex(i);
				break;
			}
		}
    }
}
