/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
import java.io.*;

public class SCNSConfig
{
    File f;
    Hashtable table; // key : (String)key , value : (String)value
    
    public SCNSConfig(File f)
    {
	// f : nsconf.txtt@C
	this.f = f;
	table = new Hashtable();
	try
	{
	    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(f),"SJIS"));
	    
	    // 擪[NISESHIORI]B
	    if (!br.readLine().equals("[NISESHIORI]")) return;
	    
	    while (true)
	    {
		String line = br.readLine();
		if (line == null) break; // eof
		
		int commapos = line.indexOf(',');
		if (line.indexOf(',') == -1) continue;
		
		String key = line.substring(0,commapos);
		String value = line.substring(commapos+1);
		
		table.put(key,value);
	    }
	    
	    br.close();
	}
	catch (Exception e) {} // t@C
    }
    
    public void put(String key,String value)
    {
	table.put(key,value);
    }
    
    public void put(String key,int value)
    {
	table.put(key,Integer.toString(value));
    }
    
    public String getStr(String key)
    {
	return (String)table.get(key);
    }
    
    public int getInt(String key)
    {
	try
	{
	    return Integer.parseInt(getStr(key));
	}
	catch (Exception e)
	{
	    return 0;
	}
    }
    
    public boolean exists(String key)
    {
	return table.get(key) != null;
    }
    
    public void synchronize()
    {
	try
	{
	    if (f.exists()) f.delete();
	    OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(f),"SJIS");
	    
	    String magic = "[NISESHIORI]\r\n";
	    osw.write(magic,0,magic.length());
	    
	    Enumeration keys = table.keys();
	    while (keys.hasMoreElements())
	    {
		String key = (String)keys.nextElement();
		String line = key + ',' + table.get(key) + "\r\n";
		osw.write(line,0,line.length());
	    }
	    
	    osw.flush();
	    osw.close();
	}
	catch (Exception e) {}
    }
}
