/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCNSWordCategory
{
    Hashtable types; // ށ@, key : (String)ށ^ނ΋󔒕 , value: (Vector)P̏W
    // Vector content : (SCNSWord)P
    
    Vector allWords; // ̃JeSɑSĂ̒P , content : (SCNSWord)P
    
    
    public SCNSWordCategory()
    {
	types = new Hashtable();
	allWords = new Vector();
    }
    
    public void addWord(SCNSWord word)
    {
	Vector vec = (Vector)types.get(word.getType());
	if (vec == null) // ߂Č镪ނ
	{
	    vec = new Vector();
	    types.put(word.getType(),vec);
	}
	vec.add(word);
	allWords.add(word);
    }
    
    public SCNSWord chooseOne(String type)
    {
	// type == null͑S^Cv̑I
	Vector items = (type == null ? allWords : (Vector)types.get(type));
	if (items == null) return null;
	
	// eڂ̊mIB
	// ܂͍vl߂
	final int n_items = items.size();
	if (n_items == 0) return null;
	
	int sum = 0;
	for (int i = 0;i < n_items;i++)
	{
	    sum += ((SCNSWord)items.elementAt(i)).getProb();
	}
	
	final int randnum = (int)((Math.random() * Integer.MAX_VALUE) % sum);
	int floor = 0;
	SCNSWord word = null;
	for (int i = 0;i < n_items;i++)
	{
	    SCNSWord current = (SCNSWord)items.elementAt(i);
	    if (floor <= randnum && floor + current.getProb() > randnum)
	    {
		// Ɍ
		word = current;
		break;
	    }
	    else
	    {
		floor += current.getProb();
	    }
	}
	return word;
    }
    
    public Object[] getTypes()
    {
	// ݂S^Cṽ^CvXgԂ܂B
	// Map.Entry̔zŁA̒gStringɂȂ܂B
	return types.keySet().toArray();
    }
    
    public Object[] getWordLists()
    {
	// ݂S^Cv̒g̃XgԂ܂B
	// Map.Entry̔zŁA̒gVectorɂȂ܂B
	return types.entrySet().toArray();
    }
    
    public int countWords(String type)
    {
	// type == null͂̃JeS̑SPꐔB
	if (type == null)
	{
	    return allWords.size();
	}
	else
	{
	    Vector words = (Vector)types.get(type);
	    return (words == null ? 0 : words.size());
	}
    }
}
