/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.apple.cocoa.foundation._private.*;

public class SCNoiseImageDrawer
{
    protected SCNoiseImageDrawer_Impl implimentation;
    protected NSObjectiveCSelector sel_initWithSize;
    protected NSObjectiveCSelector sel_drawToPoint;
    
    public SCNoiseImageDrawer(int width,int height)
    {
	implimentation = new SCNoiseImageDrawer_Impl(); // shared object
	sel_initWithSize = new NSObjectiveCSelector("initWithSize:");
	sel_drawToPoint = new NSObjectiveCSelector("drawToPoint:");
	
	try
	{
	    byte[] data = new byte[8];
	    data[0] = (byte)((width >> 24) & 0x000000ff);
	    data[1] = (byte)((width >> 16) & 0x000000ff);
	    data[2] = (byte)((width >> 8) & 0x000000ff);
	    data[3] = (byte)((width) & 0x000000ff);
	    data[4] = (byte)((height >> 24) & 0x000000ff);
	    data[5] = (byte)((height >> 16) & 0x000000ff);
	    data[6] = (byte)((height >> 8) & 0x000000ff);
	    data[7] = (byte)((height) & 0x000000ff);
	    sel_initWithSize.invoke(implimentation,new Object[] {new NSData(data)});
	}
	catch (Exception e)
	{
	    System.err.println("SCNoiseImageGenerator : Couldn\'t call the obj-c method initWithSize:");
	    e.printStackTrace();
	}
    }
    
    public void drawToPoint(int x,int y)
    {
	try
	{
	    byte[] data = new byte[8];
	    data[0] = (byte)((x >> 24) & 0x000000ff);
	    data[1] = (byte)((x >> 16) & 0x000000ff);
	    data[2] = (byte)((x >> 8) & 0x000000ff);
	    data[3] = (byte)((x) & 0x000000ff);
	    data[4] = (byte)((y >> 24) & 0x000000ff);
	    data[5] = (byte)((y >> 16) & 0x000000ff);
	    data[6] = (byte)((y >> 8) & 0x000000ff);
	    data[7] = (byte)((y) & 0x000000ff);
	    sel_drawToPoint.invoke(implimentation,new Object[] {new NSData(data)});
	}
	catch (Exception e)
	{
	    System.err.println("SCNoiseImageGenerator : Couldn\'t call the obj-c method drawToPoint:");
	    e.printStackTrace();
	}
    }
}
