/*
	$Id: SCOldBalloonConverter.java,v 1.2 2002/12/08 16:10:05 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;

public class SCOldBalloonConverter
{
    /*
		̃NX͎̂悤ȓs܂B
		
		eo[̊eT[tBXdescription擾A
		@1-origin.xyorigin.yT[tBXꖇł݂origin^Cvƌ􂵂ĎցB
		@2-zeropoint.xyzeropoint.yT[tBXꖇł݂zeropoint^Cvƌ􂵂ĕϊB
		@3-ǂorigin^Cvƌ􂵂ĎցB
		
		zeropointorigin֕ϊꂽہASĂ̒`descript.txt痣ĊeT[tBXs.txtփRs[܂B
		descript.txt̒`lɕϊAtype,balloonɒ`܂B
		s.txtȂT[tBẌׂłB
    */
    public static void convertAll()
    {
		String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
		
		File home_balloon = new File(bundleDir,"home/balloon");
		File[] baloons = home_balloon.listFiles();
		for (int i = 0;i < baloons.length;i++)
		{
			if (!baloons[i].isDirectory()) continue;
			
			convertThis(baloons[i]);
		}
    }
    
    protected static void convertThis(File balloon)
    {
		// ܂descript.txtǂŁAorigin.x݂ΑɔB
		SCDescription parentDesc = new SCDescription(new File(balloon,"descript.txt"));
		if (parentDesc.exists("origin.x")) return;
		
		// e`t@CǂށB
		File[] files = balloon.listFiles();
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].getName().startsWith("balloon") && files[i].getName().endsWith("s.txt"))
			{
				// s.txtt@CKɏ]Ă̂ł`t@Cƌ􂷁B
				// origin.x݂ΑɔB
				SCDescription individualDesc = new SCDescription(parentDesc,files[i]);
				if (individualDesc.exists("origin.x")) return;
				
				// zeropoint.x݂zeropoint^Cvł邱Ƃm肳̂őRׂϊsɏIB
				if (individualDesc.exists("zeropoint.x"))
				{
					convertZeropointToOrigin(parentDesc,balloon);
					return;
				}
			}
		}
		
		// Ō܂Ŋm肵Ȃzeropointorigin݂Ȃo[͖B
    }
    
    protected static void convertZeropointToOrigin(SCDescription parentDesc,File balloon)
    {
		File[] files = balloon.listFiles();
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].getName().startsWith("balloon") && files[i].getName().endsWith("s.txt"))
			{
				SCDescription individualDesc = new SCDescription(parentDesc,files[i]);
				convertDescription(individualDesc);
				
				// name,type͏B
				individualDesc.remove("name");
				individualDesc.remove("type");
				
				// ۑB
				try
				{
					individualDesc.save(files[i]);
				}
				catch (Exception e)
				{
					System.err.println("SCOldBalloonConverter : couldn\'t update file "+files[i].getName());
					e.printStackTrace();
				}
			}
		}
		
		// Ōdescript.txtϊB
		convertDescription(parentDesc);
		parentDesc.setStrValue("type","balloon");
		try
		{
			parentDesc.save(new File(balloon,"descript.txt"));
		}
		catch (Exception e)
		{
			System.err.println("SCOldBalloonConverter : couldn\'t update file descript.txt");
			e.printStackTrace();
		}
    }
    
    protected static final String[] POINTS_TO_CONVERT =
	{
		"wordwrappoint",
		"allow0",
		"allow1",
		"onlinemarker",
		"sstpmarker",
		"sstpmessage",
		"communicatebox"
	};
    protected static void convertDescription(SCDescription desc)
    {
		int zeropoint_x = desc.getIntValue("zeropoint.x");
		int zeropoint_y = desc.getIntValue("zeropoint.y");
		
		// validrect͌΍WȂ̂ŖB
		// wordwrappoint,allow0,allow1,onlinemarker,sstpmarker,sstpmessage,communicatebox̂ꂼxy΍W֊ZB
		for (int j = 0;j < POINTS_TO_CONVERT.length;j++)
		{
			String entryName;
			
			entryName = POINTS_TO_CONVERT[j]+".x";
			if (desc.exists(entryName))
			{
				int x = desc.getIntValue(entryName);
				x += zeropoint_x;
				desc.setIntValue(entryName,x);
			}
			
			entryName = POINTS_TO_CONVERT[j]+".y";
			if (desc.exists(entryName))
			{
				int y = desc.getIntValue(entryName);
				y += zeropoint_y;
				desc.setIntValue(entryName,y);
			}
		}
		
		// zeropointoriginɃl[B
		desc.setStrValue("origin.x",(desc.exists("zeropoint.x") ? desc.getStrValue("zeropoint.x") : "0"));
		desc.setStrValue("origin.y",(desc.exists("zeropoint.y") ? desc.getStrValue("zeropoint.y") : "0"));
		desc.remove("zeropoint.x");
		desc.remove("zeropoint.y");
    }
}
