/*
    $Id: SCPrefWindowController.java,v 1.9 2003/10/30 13:57:37 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCPrefWindowController extends NSWindowController
{
    /********* normal fields **********/
    private static SCPrefWindowController _sharedPrefWindow = null;
    
    /************ outlets *************/
    private NSButton booting_check_ghost_thumbnail;
    private NSButton booting_check_inverse_type;
    private NSButton booting_check_oldest_type;
    private NSButton booting_check_zeropoint_balloon;
    
    private NSButton mailcheck_check_enable;
    private NSTextField mailcheck_fld_server;
    private NSTextField mailcheck_fld_username;
    private NSSecureTextField mailcheck_fld_password;
    private NSButton mailcheck_check_autocheck;
    private NSTextField mailcheck_fld_autocheck_interval;
    
    private NSTextView sstp_logview;
    private NSMatrix sstp_portselect;
    private NSButton sstp_switch;
    
    private NSTableView plugin_list;
    
    private NSMatrix display_sb_levelselect;
    private NSTextField display_sb_fontnamefield;
    private NSTextField display_sb_fontsizefield;
    private NSSlider display_sb_slider_transparency;
    private NSTextField display_sb_fld_transparency;
    private NSButton display_sb_balloon_fadeout;
    private NSButton display_sb_balloon_clickthrough;
    private NSSlider display_sb_slider_waitrate;
    private NSTextField display_sb_fld_waitrate;
    /* -- */
    private NSTextField display_gm_preview_fpath;
    
    private NSButton misc_always_show_vanish;
    private NSButton misc_delete_after_online_install;
    private NSButton misc_load_whole_surfaces;
    private NSButton misc_disable_seriko_animation;
    private NSButton misc_show_dev_interfaces;
    private NSButton misc_lightmode_on_sstp;
    private NSButton misc_reset_surface_on_sstp;
    /**********************************/
    
    SCPluginListDataSource plugin_list_datasource;
    
    
    /********** normal methods ********/
    public static SCPrefWindowController sharedPrefWindowController() {
        if (_sharedPrefWindow == null) _sharedPrefWindow = new SCPrefWindowController();
        
        return _sharedPrefWindow;
    }
    
    public SCPrefWindowController() {
        super("PrefWindow");
        window();
	
	plugin_list_datasource = new SCPluginListDataSource();
	plugin_list.setDataSource(plugin_list_datasource);
    }
    
    public void showWindow(Object sender) {
        NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	String workstr;
        // defaultsǂݍ݂܂B
	
	// N
	booting_check_oldest_type.setIntValue(0);
	if (defaults.objectForKey("booting.converter.inverse_type") == null) {
	    booting_check_inverse_type.setIntValue(1);
	}
	else {
	    booting_check_inverse_type.setIntValue(defaults.integerForKey("booting.converter.inverse_type"));
	}
	if (defaults.objectForKey("booting.converter.thumbnail") == null) {
	    booting_check_ghost_thumbnail.setIntValue(1);
	}
	else {
	    booting_check_ghost_thumbnail.setIntValue(defaults.integerForKey("booting.converter.thumbnail"));
	}
	if (defaults.objectForKey("booting.converter.zeropoint_balloon") == null) {
	    booting_check_zeropoint_balloon.setIntValue(1);
	}
	else {
	    booting_check_zeropoint_balloon.setIntValue(defaults.integerForKey("booting.converter.zeropoint_balloon"));
	}
		
	// [`FbN
	workstr = (String)defaults.objectForKey("mailcheck_server");
	mailcheck_fld_server.setStringValue(workstr == null ? "" : workstr);
	workstr = (String)defaults.objectForKey("mailcheck_username");
	mailcheck_fld_username.setStringValue(workstr == null ? "" : workstr);
	workstr = (String)defaults.objectForKey("mailcheck_password");
	mailcheck_fld_password.setStringValue(workstr == null ? "" : workstr);
		
	mailcheck_check_enable.setIntValue(defaults.integerForKey("mailcheck_check_enable"));
	mailcheck_check_enable(mailcheck_check_enable); // ԍXVB
		
	mailcheck_check_autocheck.setIntValue(defaults.integerForKey("mailcheck_check_autocheck"));
	mailcheck_check_autocheck(mailcheck_check_autocheck); // ԍXVB
		
	mailcheck_fld_autocheck_interval.setIntValue(defaults.integerForKey("mailcheck_autocheck_interval"));
	
        
        // SSTP
        // Gg݂Ȃ0Ԃ遨off̎0Ԃ遨ftHgon̕ƎvǁAʓ|߂悤B
        sstp_switch.setIntValue(defaults.integerForKey("sstp_switch"));
        sstp_switch(sstp_switch); // enabledԂ̍XV
        int port = defaults.integerForKey("sstp_port");
        if (port == 0) port = 11000;
        if (port == 11000) {
            sstp_portselect.selectCellAtLocation(0,0);
        }
        else {
            sstp_portselect.selectCellAtLocation(1,0);
        }
        
        // \
	//   VF/o[
        int levelType = defaults.integerForKey("display_levelselect");
        if (levelType == NSWindow.NormalWindowLevel) {
	    // Gg݂Ȃ0Ԃ遨NSWindow.NormalWindowLevel0łB
            display_sb_levelselect.selectCellAtLocation(0,0);
        }
        else if (levelType == NSWindow.FloatingWindowLevel) {
            display_sb_levelselect.selectCellAtLocation(1,0);
        }
        else if (levelType == NSWindow.ModalPanelWindowLevel) {
            display_sb_levelselect.selectCellAtLocation(2,0);
        }
        String fontname = (String)defaults.objectForKey("display_fontname");
        if (fontname == null) fontname = "Osaka";
        float fontsize = defaults.floatForKey("display_fontsize");
        if (fontsize == 0) fontsize = 9.0f;
        display_sb_fontnamefield.setStringValue(fontname);
        display_sb_fontsizefield.setFloatValue(fontsize);
        NSFontManager fm = NSFontManager.sharedFontManager();
        fm.setSelectedFont(NSFont.fontWithNameAndSize(fontname,fontsize),false);
        fm.setAction(new NSSelector("_font_changed",new Class[] {}));
	double display_transparency_val = defaults.doubleForKey("display_slider_transparency"); // `Ȃ0B
        display_sb_slider_transparency.setDoubleValue(display_transparency_val);
        display_sb_slider_transparency(display_sb_slider_transparency); // CWP[^[̍XV
	double display_waitrate_val;
	if (defaults.objectForKey("display.balloon.wait_rate") == null) {
	    display_waitrate_val = 1.0; // ftHg100%
	}
	else {
	    display_waitrate_val = defaults.doubleForKey("display.balloon.wait_rate");
	}
	display_sb_slider_waitrate.setDoubleValue(display_waitrate_val);
	display_sb_slider_waitrate(display_sb_slider_waitrate); // CWP[^̍XV
	if (defaults.objectForKey("display.balloon.fadeout") == null) {
	    display_sb_balloon_fadeout.setIntValue(1); // ftHgonB
	}
	else {
	    display_sb_balloon_fadeout.setIntValue(defaults.integerForKey("display.balloon.fadeout"));
	}
	int ct = defaults.integerForKey("display.balloon.clickthrough");
	SCFoundation.BALLOON_USES_CLICK_THROUGH = (ct != 0);
	display_sb_balloon_clickthrough.setIntValue(ct);
	//   S[Xg}l[W
	String bgimage_path = (String)defaults.objectForKey("display.ghostmanager.preview.filepath");
	if (bgimage_path == null) bgimage_path = "/Library/Desktop Pictures/Aqua Blue.jpg";
	display_gm_preview_fpath.setStringValue(bgimage_path);
	
	// ̑
	misc_always_show_vanish.setIntValue(defaults.integerForKey("misc.always_show_vanish"));
	misc_delete_after_online_install.setIntValue(defaults.integerForKey("misc.delete_after_online_install"));
	misc_load_whole_surfaces.setIntValue(defaults.integerForKey("misc.load_whole_surfaces_on_booting_surface_server"));
        misc_disable_seriko_animation.setIntValue(defaults.integerForKey("misc.disable_seriko_animation"));
	misc_show_dev_interfaces.setIntValue(defaults.integerForKey("misc.show_dev_interfaces"));
	misc_lightmode_on_sstp.setIntValue(defaults.integerForKey("misc.lightmode_on_sstp"));
	misc_reset_surface_on_sstp.setIntValue(defaults.integerForKey("misc.reset_surface_on_sstp"));
	
        super.showWindow(sender);
    }
    
    public void reloadPluginList() {
	plugin_list_datasource.reloadData();
	plugin_list.reloadData();
    }
    
    public void addStringToSSTPLog(String str) {
        //sstp_logview.replaceCharactersInRange(new NSRange(sstp_logview.string().length(),0),str);
        //sstp_logview.scrollRangeToVisible(new NSRange(sstp_logview.string().length(),0));
    }
    
    /******** delegate methods ********/
    public boolean windowShouldClose(Object sender) {
        NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
        // defaultsɕۑ܂B
	
	// N
	defaults.setIntegerForKey(booting_check_inverse_type.intValue(),"booting.converter.inverse_type");
	defaults.setIntegerForKey(booting_check_ghost_thumbnail.intValue(),"booting.converter.thumbnail");
	defaults.setIntegerForKey(booting_check_zeropoint_balloon.intValue(),"booting.converter.zeropoint_balloon");
	
	// [`FbN
	mailcheck_update(null);
        
        // SSTP
        defaults.setIntegerForKey(sstp_switch.intValue(),"sstp_switch");
        int sstp_sel_id = sstp_portselect.selectedRow();
        int port = (sstp_sel_id == 0 ? 11000 : 9801);
        defaults.setIntegerForKey(port,"sstp_port");
        
        // \
	//   VF/o[
        int levelType = NSWindow.NormalWindowLevel;
        int sel_id = display_sb_levelselect.selectedRow();
        if (sel_id == 1) {
	    // sel_id == 0̎͏ȗB
            levelType = NSWindow.FloatingWindowLevel;
        }
        else if (sel_id == 2) {
            levelType = NSWindow.ModalPanelWindowLevel;
        }
        defaults.setIntegerForKey(levelType,"display_levelselect");
        NSFontManager fm = NSFontManager.sharedFontManager();
        NSFont newfont = fm.selectedFont();
        String name = null;
        float size = 9.0f;
        if (newfont != null) {
            name = newfont.fontName();
            size = newfont.pointSize();
        }
        else {
            name = "Osaka";
            size = 9.0f;
        }
        defaults.setObjectForKey(name,"display_fontname");
        defaults.setFloatForKey(size,"display_fontsize");
	defaults.setIntegerForKey(display_sb_balloon_fadeout.intValue(), "display.balloon.fadeout");
	defaults.setIntegerForKey(display_sb_balloon_clickthrough.intValue(), "display.balloon.clickthrough");
	SCFoundation.BALLOON_USES_CLICK_THROUGH = (display_sb_balloon_clickthrough.intValue() != 0);
	//   S[Xg}l[W
	defaults.setObjectForKey(display_gm_preview_fpath.stringValue(),"display.ghostmanager.preview.filepath");
	
	// ̑
	defaults.setIntegerForKey(misc_always_show_vanish.intValue(),"misc.always_show_vanish");
	defaults.setIntegerForKey(misc_delete_after_online_install.intValue(),"misc.delete_after_online_install");
	defaults.setIntegerForKey(misc_load_whole_surfaces.intValue(),"misc.load_whole_surfaces_on_booting_surface_server");
	defaults.setIntegerForKey(misc_disable_seriko_animation.intValue(),"misc.disable_seriko_animation");
	SCFoundation.LOAD_WHOLE_SURFACES_ON_BOOTING_SURFACE_SERVER = (misc_load_whole_surfaces.intValue() == 1);
	SCFoundation.STOP_SERIKO = (misc_disable_seriko_animation.intValue() == 1);
	defaults.setIntegerForKey(misc_show_dev_interfaces.intValue(),"misc.show_dev_interfaces");
	defaults.setIntegerForKey(misc_lightmode_on_sstp.intValue(),"misc.lightmode_on_sstp");
	defaults.setIntegerForKey(misc_reset_surface_on_sstp.intValue(),"misc.reset_surface_on_sstp");
        
        defaults.synchronize();
        return true; // falseԂ΃N[YH~߂B
    }
    
    /******** callback methods ********/
    public void _font_changed() {
	// NSFontManagerĂ΂܂B
        NSFontManager fm = NSFontManager.sharedFontManager();
        NSFont newfont = fm.selectedFont();
        if (newfont == null) return;
        
        String name = newfont.fontName();
        float size = newfont.pointSize();
        
        display_sb_fontnamefield.setStringValue(name);
        display_sb_fontsizefield.setFloatValue(size);
        
        Vector session_list = SCFoundation.sharedFoundation().getSessionsList();
        int n_sessions = session_list.size();
        for (int i = 0;i < n_sessions;i++) {
            SCSession session = (SCSession)session_list.elementAt(i);
            session.getHontaiBalloon().requestChangeFont(newfont);
            session.getUnyuuBalloon().requestChangeFont(newfont);
        }
    }
    
    /************* actions ************/
    public void mailcheck_check_enable(NSButton sender) {
	if (mailcheck_check_enable.intValue() == 1) {
	    // enable
	    mailcheck_check_autocheck.setEnabled(true);
	    mailcheck_fld_server.setEnabled(true);
	    mailcheck_fld_username.setEnabled(true);
	    mailcheck_fld_password.setEnabled(true);
	}
	else {
	    // disable
	    mailcheck_check_autocheck.setEnabled(false);
	    mailcheck_fld_server.setEnabled(false);
	    mailcheck_fld_username.setEnabled(false);
	    mailcheck_fld_password.setEnabled(false);
	}
	
	mailcheck_check_autocheck(null);
    }
    
    public void mailcheck_check_autocheck(NSButton sender) {
	if (mailcheck_check_autocheck.intValue() == 1 && mailcheck_check_enable.intValue() == 1) {
	    // enable
	    mailcheck_fld_autocheck_interval.setEnabled(true);
	}
	else {
	    // disable
	    mailcheck_fld_autocheck_interval.setEnabled(false);
	}
    }
    
    public void mailcheck_update(NSButton sender) {
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	
	defaults.setIntegerForKey(mailcheck_check_enable.intValue(),"mailcheck_check_enable");
	defaults.setIntegerForKey(mailcheck_check_autocheck.intValue(),"mailcheck_check_autocheck");
	defaults.setObjectForKey(mailcheck_fld_server.stringValue(),"mailcheck_server");
	defaults.setObjectForKey(mailcheck_fld_username.stringValue(),"mailcheck_username");
	defaults.setObjectForKey(mailcheck_fld_password.stringValue(),"mailcheck_password");
	defaults.setIntegerForKey(mailcheck_fld_autocheck_interval.intValue(),"mailcheck_autocheck_interval");
	
	defaults.synchronize();
		
	// I[g`FbNNtOĂNAłȂΏIB
	// ǂłɋNĂIĂ肵疳̂ŖȂB
	if (mailcheck_check_enable.intValue() == 1 && mailcheck_check_autocheck.intValue() == 1) {
	    SCFoundation.sharedFoundation().startMailCheckDaemon();
	}
	else {
	    SCFoundation.sharedFoundation().stopMailCheckDaemon();
	}
    }
    
    public void sstp_portselect(NSMatrix sender) {
        int sel_id = sstp_portselect.selectedRow();
        int port = (sel_id == 0 ? 11000 : 9801);
        
        SCFoundation.sharedFoundation().stopSSTPServer();
        SCFoundation.sharedFoundation().startSSTPServer(port); // ̃{^ƂƂ́ASSTPINĂ悢ƂƂۏ؂ĂB
    }
    
    public void sstp_switch(NSButton sender) {
        if (sstp_switch.intValue() == 1) {
	    // onɂȂ
            // SSTPINĂ炻̂܂܁AĂȂNB
            SCFoundation.sharedFoundation().startSSTPServer();
            
            sstp_portselect.setEnabled(true);
        }
        else {
            // SSTPINĂ~B
            SCFoundation.sharedFoundation().stopSSTPServer();
            
            sstp_portselect.setEnabled(false);
        }
    }
    
    public void display_sb_levelselect(NSMatrix sender) {
        int sel_id = display_sb_levelselect.selectedRow();
        int const_level = NSWindow.NormalWindowLevel;
        if (sel_id == 1) {
	    // sel_id == 0̎͏ȗ
            const_level = NSWindow.FloatingWindowLevel;
        }
        else if (sel_id == 2) {
            const_level = NSWindow.ModalPanelWindowLevel;
        }
        
        Vector session_list = SCFoundation.sharedFoundation().getSessionsList();
        int n_sessions = session_list.size();
        for (int i = 0;i < n_sessions;i++) {
            SCSession session = (SCSession)session_list.elementAt(i);
            session.getHontai().setLevel(const_level);
            session.getUnyuu().setLevel(const_level);
            session.getHontaiBalloon().setLevel(const_level);
            session.getUnyuuBalloon().setLevel(const_level);
        }
    }
    
    public void display_sb_balloon_fadeout(NSButton sender) {
	boolean bool = (display_sb_balloon_fadeout.intValue() == 1);
	
	Vector session_list = SCFoundation.sharedFoundation().getSessionsList();
        int n_sessions = session_list.size();
        for (int i = 0;i < n_sessions;i++) {
            SCSession session = (SCSession)session_list.elementAt(i);
            session.getHontaiBalloon().setDoesFadeOut(bool);
	    session.getUnyuuBalloon().setDoesFadeOut(bool);
        }
    }
    
    public void display_sb_showfontpanel(NSButton sender) {
        NSFontManager fm = NSFontManager.sharedFontManager();
        fm.orderFrontFontPanel(null);
    }
    
    public void display_sb_slider_transparency(NSSlider sender) {
	// CWP[^ɂ̓p[Zg\B
	double val = display_sb_slider_transparency.doubleValue();
	
	String indic_str = (int)(val * 100) + "%";
	display_sb_fld_transparency.setStringValue(indic_str);
	
	Vector session_list = SCFoundation.sharedFoundation().getSessionsList();
        int n_sessions = session_list.size();
        for (int i = 0;i < n_sessions;i++) {
            SCSession session = (SCSession)session_list.elementAt(i);
            session.getHontaiBalloon().setTransparency(val);
	    session.getUnyuuBalloon().setTransparency(val);
        }
	
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	defaults.setDoubleForKey(val,"display_slider_transparency");
	// synchronize͂ȂB
    }
    
    public void display_sb_slider_waitrate(Object sender) {
	// CWP[^ɂ̓p[Zg\B
	double val = display_sb_slider_waitrate.doubleValue();
	
	String indic_str = (int)(val * 100) + "%";
	display_sb_fld_waitrate.setStringValue(indic_str);
	
	SCScriptRunner.setWaitRatio(val);
	
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	defaults.setDoubleForKey(val,"display.balloon.wait_rate");
	// synchronize͂ȂB
    }
    
    public void display_gm_preview_select(Object sender) {
	NSOpenPanel openpanel = new NSOpenPanel();
	openpanel.setCanChooseFiles(true);
	openpanel.setCanChooseDirectories(false);
	openpanel.setResolvesAliases(true);
	openpanel.setAllowsMultipleSelection(false);
	openpanel.beginSheetForDirectory(
	    null,null,null,window(),
	    this,new NSSelector("callback_display_gm_preview_selected",new Class[] {NSOpenPanel.class,int.class,Object.class}),null);
    }
    public void callback_display_gm_preview_selected(NSOpenPanel sheet, int returnCode, Object contextInfo) {
	if (returnCode == NSOpenPanel.OKButton) {
	    display_gm_preview_fpath.setStringValue((String)sheet.filenames().objectAtIndex(0));
	}
    }
    
    public void misc_always_show_vanish(NSButton sender) {
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	defaults.setIntegerForKey(misc_always_show_vanish.intValue(),"misc.always_show_vanish");
        defaults.synchronize();
    }
    
    public void misc_delete_after_online_install(NSButton sender) {
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	defaults.setIntegerForKey(misc_delete_after_online_install.intValue(),"misc.delete_after_online_install");
        defaults.synchronize();
    }
    
    public class SCPluginListDataSource implements NSTableView.DataSource {
	Vector list;
	
	public SCPluginListDataSource() {
	    list = new Vector();
	    
	    reloadData();
	}
	
	public void reloadData() {
	    list.clear();
	    
	    SCPlugin[] plugins = SCFoundation.sharedFoundation().getPluginManager().getPlugins();
	    for (int i = 0;i < plugins.length;i++) {
		SCPlugin plugin = plugins[i];
				
		String type = SCStringsServer.getStrFromMainDic("pref.plugin.type."+plugin.getType());
		String name = plugin.getName();
		String info;
		
		if (plugin.getType().equals("hlsensor")) {
		    SCHLSensorResponse resp = ((SCHLSensorPlugin)plugin).request("GET Description HEADLINE/1.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n\r\n");
		    info = resp.getHeader("Name") + " @ " + resp.getHeader("Data-Location");
		}
		else if (plugin.getType().equals("shiori")) {
		    info = SCShioriLoader.getModuleInfo(plugin.getPluginClass());
		}
		else if (plugin.getType().equals("makoto")) {
		    info = SCMakotoLoader.getModuleInfo(plugin.getPluginClass());
		}
		else {
		    info = "";
		}
				
		list.add(new SCPluginListDataElement(name,type,info));
	    }
	}
	
	public int numberOfRowsInTableView(NSTableView aTableView) {
	    return list.size();
	}
		
	public boolean tableViewAcceptDrop(
	    NSTableView tableView,
	    NSDraggingInfo info,
	    int row,
	    int operation) {
	    // optional
	    return false;
	}
		
	public Object tableViewObjectValueForLocation(
	    NSTableView aTableView,
	    NSTableColumn aTableColumn,
	    int rowIndex) {
	    SCPluginListDataElement elem = (SCPluginListDataElement)list.elementAt(rowIndex);
	    String column_id = (String)aTableColumn.identifier();
			
	    if (column_id.equals("name")) {
		return elem.getName();
	    }
	    else if (column_id.equals("type")) {
		return elem.getType();
	    }
	    else if (column_id.equals("info")) {
		return elem.getInfo();
	    }
	    else {
		return null;
	    }
	}
	
	public void tableViewSetObjectValueForLocation(
	    NSTableView aTableView,
	    Object anObject,
	    NSTableColumn aTableColumn,
	    int rowIndex) {
	    
	}
		
	public int tableViewValidateDrop(
	    NSTableView tableView,
	    NSDraggingInfo info,
	    int row,
	    int operation) {
	    // optional
	    return 0;
	}
	
	public boolean tableViewWriteRowsToPasteboard(
	    NSTableView tableView,
	    NSArray rows,
	    NSPasteboard pboard) {
	    // optional
	    return false;
	}
        
        public void tableViewSortDescriptorsDidChange(
            NSTableView tableView,
            NSArray rows) {
            // optional
        }
    }
    
    public class SCPluginListDataElement {
	String name;
	String type;
	String info;
    
	public SCPluginListDataElement(String name,String type,String info) {
	    this.name = name;
	    this.type = type;
	    this.info = info;
	}
		
	public String getName() {return name;}
	public String getType() {return type;}
	public String getInfo() {return info;}
    }
}
