/*  $Id: SCSerikoEnabledBindGroup.java,v 1.4 2004/01/30 06:30:31 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.util.*;
/*
    gpbindO[vłB
    oChZ^[̎zɓo^܂B
*/
public class SCSerikoEnabledBindGroup {
    private SCSession session;
    private SCShell shell;
    private SCSeriko seriko;
    
    private int seqid; // oChO[ṽV[PXIDB
    private boolean hontai; // {̂ۂB
    private SCShellWindowController target;
    private Vector layers; // gSCShellLayerB
    
    public SCSerikoEnabledBindGroup(SCSession session,SCShell shell,SCSeriko seriko,int seqid,boolean hontai) {
	this.session = session;
	this.shell = shell;
	this.seriko = seriko;
	
	this.seqid = seqid;
	this.hontai = hontai;
	target = (hontai ? session.getHontai() : session.getUnyuu());
	
	layers = new Vector();
	
	SCSerikoSeqGroup group = seriko.getCurrentSeqGroup(hontai);
	if (group == null) return;
	SCSerikoSequence seq = group.findSequence(seqid);
	if (seq == null) return;
	
	runSequence(seq);
    }
    
    private void runSequence(SCSerikoSequence seq) {
	Vector patterns = seq.patterns();
	int n_patterns = patterns.size();
	for (int i = 0;i < n_patterns;i++) {
	    Object obj = patterns.elementAt(i);
	    if (obj == null) {
		continue; // pfBOĂ
	    }
	    SCSerikoSeqPatternEntry pat = (SCSerikoSeqPatternEntry)obj;
	    
	    // \bh
	    String method = pat.method();
	    if (method.equals("bind") || method.equals("add")) { // ǂ
		SCShellLayer layer = target.getView().addLayer(
		    shell.getSurfaceServer(),
		    pat.surfaceid(),
		    seqid,
		    new NSPoint(pat.offsetx(),pat.offsety()),
		    true);
		layers.add(layer);
	    }
	}
	//target.getWindow().display();
	target.setViewsNeedDisplay(true);
    }
    
    public void disable() {
	// O[v鎞ɌĂ΂܂B
	// xdisableIuWFNg͓xƎgȂ̂ŁAxgΐVȃCX^X쐬ĉB
	int n_layers = layers.size();
	for (int i = 0;i < n_layers;i++) {
	    SCShellLayer layer = (SCShellLayer)layers.elementAt(i);
	    target.getView().removeLayer(layer);
	}
	//target.getWindow().display();
	target.setViewsNeedDisplay(true);

	session = null;
	shell = null;
	seriko = null;
	target = null;
	layers.clear();
    }
    
    public int seqid() {
	return seqid;
    }
    
    public boolean isHontai() {
	return hontai;
    }
    public boolean isSakura() {
	return hontai;
    }
}
