/*  $Id: SCSessionChanger.java,v 1.7 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;

public class SCSessionChanger extends Thread {
    SCSession before;
    String selfname_of_before;
    String nextPath;
    String nextBalloonPath;
    String nextName;
    double scale;
    boolean sendOnGhostChanging; // ؂ւOnGhostChanging𑗂邩ǂB
    
    public SCSessionChanger(SCSession before,String nextPath,String nextBalloonPath,String nextName,double scale) {
	// OnGhostChanging𑗂^Cv
	this(before,nextPath,nextBalloonPath,nextName,scale,true);
    }
    public SCSessionChanger(SCSession before,String nextPath,String nextBalloonPath,double scale) {
	// OnGhostChanging𑗂Ȃ^CvBnextNamesvB
	this(before,nextPath,nextBalloonPath,null,scale,false);
    }
    private SCSessionChanger(SCSession before,String nextPath,String nextBalloonPath,String nextName,double scale,boolean sendOnGhostChanging) {
	this.before = before;
	this.selfname_of_before = before.getMasterSpirit().getSelfName();
	this.nextPath = nextPath;
	this.nextBalloonPath = nextBalloonPath;
	this.nextName = nextName;
	this.scale = scale;
	this.sendOnGhostChanging = sendOnGhostChanging;
    }
    
    public void run() {
	if (before.isInPassiveMode()) {
	    before = null;
	    return;
	}
	
	int pool = NSAutoreleasePool.push();
	
	postNotification(before,"sessionchanger","closing");
	before.setStatusClosing();
	
	SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	stat.setTypeToText();
	stat.show();
	stat.texttype_print("Unmaterializing...\n");
	
	String name_of_ghost_to_be_unmaterialized = before.getMasterSpirit().getName();
	
	// OnGhostChangings
	String script_in_resp = null;
	if (sendOnGhostChanging) {
	    SCSpirit master_spirit = before.getMasterSpirit();
	    String req;
	    if (master_spirit.getShioriProtocolVersion() == 2)
		req = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnGhostChanging\r\nReference0: "+nextName+"\r\nReference1: manual\r\n\r\n";
	    else
		req = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nID: OnGhostChanging\r\nReference0: "+nextName+"\r\nReference1: manual\r\n\r\n";
	    
	    SCShioriSessionResponce resp = master_spirit.doShioriSession(req);
	    script_in_resp = (master_spirit.getShioriProtocolVersion() == 2 ? resp.getRespForKey("Sentence") : resp.getRespForKey("Value"));
	    before.shioriResponceWork(resp,false); // ĐI܂ŃubNB
	}
	
	// 
	SCFoundation.sharedFoundation().closeSession(before);
	postNotification(before,"sessionchanger","closed");
	
	stat.texttype_print("%[color,orange]ghost \"%[color,white]"+name_of_ghost_to_be_unmaterialized+"%[color,orange]\" unmaterialized.");
	stat.closeWindow();
	
	// bootflag
	SCGhostManager.sharedGhostManager().setBootFlagInDefaults(before.getGhostPath(),false);
	
	// ̃S[XgN
	SCSession s = SCFoundation.sharedFoundation().openSession(nextPath,nextBalloonPath,scale);

	postNotification(s,"sessionchanger","opened");
	
	// bootflagݒ
	SCGhostManager.sharedGhostManager().setBootFlagInDefaults(s.getGhostPath(),true);
	
	// OnGhostChangedႵOnFirstBoots
	if (s.hasBootedBefore()) {
	    s.doShioriEvent("OnGhostChanged",new String[] {selfname_of_before,script_in_resp});
	}
	else {
	    s.doFirstBootEvent();
	}

	before = null;
	NSAutoreleasePool.pop(pool);
    }
    
    private void postNotification(SCSession session,String name,String subinfo) {
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(session,"session");
	NSNotificationCenter.defaultCenter().postNotification(name,subinfo,userinfo);
    }
    
    private void _open() {
	SCFoundation.sharedFoundation().openSession(nextPath,nextBalloonPath,scale);
    }
}
