/*  $Id: SCSessionCloser.java,v 1.8 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCSessionCloser extends Thread {
    SCSession session;
    
    public SCSessionCloser(SCSession session) {
	this.session = session;
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	postNotification("sessioncloser","closing");
	
	SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	stat.setTypeToText();
	stat.show();
	stat.texttype_print("Unmaterializing...\n");
	
	SCSpirit master_spirit = session.getMasterSpirit();
	String ghost_name = master_spirit.getName();
	String req;
	if (master_spirit.getShioriProtocolVersion() == 2)
	    req = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnClose\r\n\r\n";
	else
	    req = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nID: OnClose\r\n\r\n";
	session.shioriResponceWork(master_spirit.doShioriSession(req),false); // ĐI܂ŃubNB
	
	SCFoundation.sharedFoundation().closeSession(session);
	
	stat.texttype_print("%[color,orange]ghost \"%[color,white]"+ghost_name+"%[color,orange]\" unmaterialized.");
	stat.closeWindow();

	postNotification("sessioncloser","closed");
	session = null;
	NSAutoreleasePool.pop(pool);
    }
    
    private void postNotification(String name,String subinfo) {
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(session,"session");
	NSNotificationCenter.defaultCenter().postNotification(name,subinfo,userinfo);
    }
}
