/*  $Id: SCSessionVanisher.java,v 1.7 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.io.*;

public class SCSessionVanisher extends Thread {
    SCSession target;
    String targetPath;
    String targetName;
    
    String nextPath;
    String nextBalloonPath;
    double nextScale;
    
    boolean inLastEvent;
    volatile boolean holded;
    
    public SCSessionVanisher(SCSession target) {
	this.target = target;
	targetPath = target.getGhostPath();
	targetName = target.getSelfName();
	
	inLastEvent = false;
	holded = false;
    }
    
    public void run() {
	if (target.isInPassiveMode()) {
	    target = null;
	    return;
	}
	
	int pool = NSAutoreleasePool.push();
	
	postNotification(target,"vanisher","closing");
	target.setStatusClosing();
	
	// OnVanishSelecteds...
	SCSpirit spirit_of_target = target.getMasterSpirit();
	String req_selected;
	if (spirit_of_target.getShioriProtocolVersion() == 2)
	    req_selected = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnVanishSelected\r\n\r\n";
	else
	    req_selected = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nID: OnVanishSelected\r\nSecurityLevel: local\r\n\r\n";
	target.clearQueue();
	target.forceTerminateScriptRunnder();
	inLastEvent = true;
	target.shioriResponceWork(spirit_of_target.doShioriSession(req_selected),false); // ĐI܂ŃubNB
	inLastEvent = false;
	
	// ~߂ꂽXbhIB
	if (holded) {
	    postNotification(target,"vanisher","holded");
	    target.clearStatusClosing();

	    target = null;
	    NSAutoreleasePool.pop(pool);
	    return;
	}
	
	// ̃S[Xg_ɑI
	nextPath = SCFoundation.sharedFoundation().getAnyGhostPathInAsleep();
	if (nextPath != null) {
	    nextBalloonPath = SCGhostManager.sharedGhostManager().getBalloonPathOfGhost(nextPath);
	    nextScale = SCGhostManager.sharedGhostManager().getScaleOfGhost(nextPath);
	}
	
	// 
	SCFoundation.sharedFoundation().closeSession(target);
	postNotification(target,"vanisher","closed");
	
	// bootflag
	SCGhostManager.sharedGhostManager().setBootFlagInDefaults(targetPath,false);
	
	// 폜
	File targetDirectory = new File(SCFoundation.sharedFoundation().getParentDirOfBundle(),targetPath);
	SCFileUtils.deleteRecursively(targetDirectory);
	postNotification(target,"vanisher","vanished");
	
	// has_booted_beforefalseɁAvanish_countCNgB
	NSMutableDictionary defaults = SCGhostManager.sharedGhostManager().getGhostDefaults(targetPath);
	defaults.setObjectForKey("false","has_booted_before");
	Object vanish_count = defaults.objectForKey("vanish_count");
	if (vanish_count instanceof Integer) {
	    defaults.setObjectForKey(new Integer((vanish_count == null ? 0 : ((Integer)vanish_count).intValue())+1),"vanish_count");
	}
	else {
	    defaults.setObjectForKey(new Long((vanish_count == null ? 0 : ((Long)vanish_count).longValue())+1),"vanish_count");
	}
	SCGhostManager.sharedGhostManager().setGhostDefaults(targetPath,defaults);
	
	// nextPathnullłȂ΁iɃS[XgcĂ΁j̃S[XgN
	if (nextPath != null) {
	    //SCSession s = SCFoundation.sharedFoundation().openSession(nextPath,nextBalloonPath,nextScale);
	    NSTimer open_timer = new NSTimer(
		0.0,
		this,
		new NSSelector("_open",new Class[] {}),
		new Object[] {},
		false);
	    SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
	    SCSession s = null;
	    while (s == null) {
		s = SCFoundation.sharedFoundation().getSession(nextPath);
		if (s == null) { // ܂NĂȂ
		    try{sleep(200);}catch(Exception e){}
		}
	    }
	    postNotification(s,"vanisher","opened");
	    
	    // bootflagݒ
	    SCGhostManager.sharedGhostManager().setBootFlagInDefaults(s.getGhostPath(),true);
	    
	    // OnVanishedsBɉȂOnGhostChangedsB
	    // Ώۂ̃S[Xgu߂ẴS[XgvꍇOnFirstBoot𑗂ׂmȂ...
	    SCShioriSessionResponce shiori_resp;
	    
	    SCSpirit spirit = s.getMasterSpirit();
	    String req_vanished;
	    if (spirit.getShioriProtocolVersion() == 2)
		req_vanished = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnVanished\r\n\r\n";
	    else
		req_vanished = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nID: OnVanished\r\nSecurityLevel: local\r\n\r\n";
	    SCShioriSessionResponce resp_vanished = spirit.doShioriSession(req_vanished);
	    if (resp_vanished.getHeader().indexOf("200 OK") != -1) { // 
		shiori_resp = resp_vanished;
	    }
	    else {
		String req_changed;
		if (spirit.getShioriProtocolVersion() == 2)
		    req_changed = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnGhostChanged\r\nReference0: "+targetName+"\r\n\r\n";
		else
		    req_changed = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nID: OnGhostChanged\r\nSecurityLevel: local\r\n\r\n";
		shiori_resp = s.getMasterSpirit().doShioriSession(req_changed);
	    }
	    s.shioriResponceWork(shiori_resp,false); // ĐI܂ŃubNB
	}

	target = null;
	NSAutoreleasePool.pop(pool);
    }
    
    public SCSession getTarget() {
	return target;
    }
    
    public boolean isInLastEvent() {
	// őÕS[XgŌ̃CxgłtrueԂ܂B
	return inLastEvent;
    }
    
    public void hold() {
	// ~߂܂B
	// xȂ疳łB
	holded = true;
    }
    
    private void postNotification(SCSession session,String name,String subinfo) {
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(session,"session");
	NSNotificationCenter.defaultCenter().postNotification(name,subinfo,userinfo);
    }
    
    private void _open() {
	SCFoundation.sharedFoundation().openSession(nextPath,nextBalloonPath,nextScale);
    }
}
