/*  $Id: SCShellLayer.java,v 1.2 2004/02/05 09:29:35 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCShellLayer {
    SCShellWindowController swc;
    int id;
    int surfaceid;
    int seqid;
    NSImage img = null;
    NSPoint loc = null;
    boolean vis = false;
    
    public SCShellLayer(SCShellWindowController swc,int id,SCSurfaceServer sserver,int surfaceid,int seqid,NSPoint location,boolean visible) {
	this.swc = swc;
	this.id = id;
	this.surfaceid = surfaceid;
	this.seqid = seqid; // dˍ킹̏B
	
	SCSurface surf = sserver.findSurface(surfaceid);
	img = (surf == null ? null : surf.getImage());
	
	loc = location;
	vis = visible;
    }
    
    public void draw() {
	// loc̒l͍W̃ItZbgɂȂĂ̂ŋCtׂB
	
	if (img != null && vis) {
	    double ratio = swc.getRatio();
	    float x = (float)(loc.x() * ratio);
	    float y = (float)(ratio * (swc.currentSurface().getOriginalSize().height() - loc.y() - img.size().height()));
	    
	    img.compositeToPoint(new NSPoint(x,y),NSImage.CompositeSourceOver);
	}
    }
    
    public void setImage(SCSurfaceServer sserver,int surfaceid) {
	SCSurface surf = sserver.findSurface(surfaceid);
	img = (surf == null ? null : surf.getImage());
    }
    
    public void setLoc(NSPoint location) {
	loc = location;
    }
    
    public void setVis(boolean visible) {
	vis = visible;
    }
    
    public int id() {
	return id;
    }
    
    public int seqid() {
	return seqid;
    }
}
