/*  $Id: SCShellWindowController.java,v 1.9 2004/02/05 09:29:35 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import util.*;

public class SCShellWindowController extends NSWindowController {
    SCShellView view;
    
    SCSession session;
    SCSurface surface = null;
    SCSurface basesurface = null; // changeSurfaceł͕ω邪tempChangeBaseł͕ωȂB
    double ratio = 1.0;
    float baseHorizLoc; // SERIKOmoveœȂAhbOŌ肳ꂽʒuB
    int type; // {̂ɂイB
    
    public SCShellWindowController(SCSession s,int type) {
	super("ShellWindow");
	window();
	
	session = s;
	this.type = type;
	
	window().setFrameOrigin( new NSPoint( x() , 0 ) );
	window().setAutodisplay(true);
	
	((SCShellWindow)window()).initialize(s,this);
	view.initialize(this);
    }
    
    public void changeSurface(SCSurfaceServer sserver,int id) {
	// id-1ł\B
	if (id == -1) {
	    // \̈̃TCY͑Ô̂㋂B
	    view.changeSurface(null);
	    basesurface = surface = null;
	}
	else {
	    basesurface = surface = sserver.findSurface(id,type);
	    if (surface == null) return;
	    NSImage image = surface.getImage();
	    if (image == null) return;
	    // WbaseHorizLocgp鎖ŁAoffset𖳎B
	    NSRect newrect = new NSRect(baseHorizLoc,0,image.size().width(),image.size().height());
	    
	    window().setFrame(newrect,false);
	    view.changeSurface(image);
	}
        
        view.display();
	session.recalcBalloonsLoc();
        window().setHasShadow(false);
    }
    
    public void tempChangeBase(SCSurfaceServer sserver,int id) {
	// SERIKObase\bhŎg܂B
	// x[XT[tBX񂪕ς炸ɁAꎞIɃx[XT[tBXւ܂B
	surface = sserver.findSurface(id,type);
        if (surface == null) return;
        NSImage image = surface.getImage();
        if (image == null) return;
        //NSRect newrect = new NSRect(NSPoint.ZeroPoint,image.size());
        //NSRect oldrect = window().frame();
        //newrect = new NSRect(newrect.rectByOffsettingRect(oldrect.x(),oldrect.y()));
	// offsetpB
	NSRect newrect = new NSRect(window().frame().origin(),image.size());
        
        window().setFrame(newrect,false);
        view.changeSurface(image);
        
        view.display();
	session.recalcBalloonsLoc();
        window().setHasShadow(false);
    }
    
    public void reloadSurface(SCSurfaceServer sserver) {
	changeSurface(sserver,surface.getID());
    }
    
    public void surfaceResized(SCSurfaceServer sserver,double r) {
	// TCYꂽɌĂłB
	ratio = r;
	if (surface != null) changeSurface(sserver,surface.getID());
    }
    
    public void setLevel(int level) {
        window().setLevel(level);
    }
    
    public void show() {
	if (window().isVisible()) return;

	/* ւ́AƂApB  */
        //showWindow(null);
	NSTimer open_timer = new NSTimer(
	    0.0,
	    this,
	    new NSSelector("showWindow",new Class[] {NSNull.class}),
	    new Object[] {NSNull.nullValue()},
	    false);
	SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
	if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@

	// SERIKOĊJ
	//session.getCurrentShell().getSeriko().restart(
	//    type == SCFoundation.SAKURA);

	// mredraw
	window().setViewsNeedDisplay(true);
    }
    
    public void hide() {
	if (!window().isVisible()) return;

	/* }`XbhAppKit */
        window().orderOut(null);
	/*NSTimer close_timer = new NSTimer(
	  0.0,
	  window(),
	  new NSSelector("orderOut",new Class[] {NSNull.class}),
	  new Object[] {NSNull.nullValue()},
	  false);
	  SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(close_timer,NSRunLoop.DefaultRunLoopMode);
	  if (!Thread.currentThread().getName().equals("main")) while (window().isVisible()) {} // ҋ@*/

	// SERIKÕXbh~߂B
	session.getCurrentShell().getSeriko().stop(
	    type == SCFoundation.SAKURA);

	basesurface = surface = null;
    }
    
    public void close() {
	super.close();
	
	view.cleanUp();
	view = null;
	session = null;
	surface = null;
	basesurface = null;
    }
    
    public NSRect frame() {
	return window().frame();
    }
    
    public float width() {
        return window().frame().width();
    }
    
    public float height() {
        return window().frame().height();
    }
    
    public float x() {
        return window().frame().x();
    }
    
    public float y() {
        return window().frame().y();
    }
    
    public void setHorizLoc(float x) {
	// xWݒ肵܂B
	baseHorizLoc = x;
	window().setFrameOrigin( new NSPoint( x , y() ) );
    }
    
    public void absoluteSetLoc(float x,float y) {
	// w肳ꂽƂx,yWݒ肵܂B
	baseHorizLoc = x;
	window().setFrameOrigin( new NSPoint(x,y) );
    }
    
    public void setOffset(float x,float y) {
	// SERIKO movepB
	// moveɖ֌WɌ肳ꂽʒu̍ōWύX܂B
	window().setFrameOrigin( new NSPoint(baseHorizLoc + x,y) ); // ỹx[X͏Ƀ[B
    }
    
    /*public void relativeSetLoc(float x,float y) {
    // p[^݂̒l̑ΒlƂĉ߂܂B
    window().setFrameOrigin( new NSPoint( x()+x , y()+y ) );
    }*/
    
    public void setViewsNeedDisplay(boolean bool) {
	// NSWindow#setViewsNeedDisplay()̂@\Ȃ̂ŎŎB
	// ƂĂsōςł܂B
	window().contentView().setNeedsDisplay(true);
    }
    
    public int currentSurfaceId() {
	return (surface == null ? -1 : surface.getID());
    }
    
    public SCSurface currentSurface() {
	return surface;
    }
    
    public int baseSurfaceId() {
	return (basesurface == null ? -1 : basesurface.getID());
    }
    
    public SCSurface baseSurface() {
	return basesurface;
    }
    
    public void setBalloon(SCSafetyBalloonController balloon) {
        ((SCShellWindow)window()).setBalloon(balloon);
    }
    
    public double getRatio() {
	return ratio;
    }
    
    public SCShellWindow getWindow() {
	return (SCShellWindow)window();
    }
    
    public SCShellView getView() {
	return view;
    }
    
    public int getType() {
	return type;
    }
    
    public SCSession session() {
	return session;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("session: {").append(session).append('}');
	buf.append("; ratio: ").append(ratio);
	buf.append("; type: ").append(type);
	return buf.toString();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
}
