/*  $Id: SCShioriLoader.java,v 1.10 2004/02/05 09:29:35 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class SCShioriLoader {
    private static Vector SHIORI_MODULES; // content: (Class)
    static {
	// SHIORI_MODULESɂ́AxW[NXꗗĂ܂B
	// ClassIuWFNg΁ANX̓t@C烍[h悤lbg[NzɃ[h悤S\܂B
	// Ⴆhome/pluginɞxW[vOCƂăCXg[ÃXgɒǉ铙̏l܂B
	SHIORI_MODULES = new Vector();
	SHIORI_MODULES.add(SCKawari.class);
	SHIORI_MODULES.add(aya.Aya.class);
	SHIORI_MODULES.add(satori.Satori.class);
	SHIORI_MODULES.add(SCEseShiori.class);
	SHIORI_MODULES.add(misaka.Misaka.class);
	SHIORI_MODULES.add(SCNiseShiori.class); // Ux͈ԍŌɔ肵Ȃ΂ȂȂB
	//SHIORI_MODULES.add(SCDebugShiori.class); // Uь{̂̃fobOp
    }
    
    public static void installShioriModule(Class module) {
	// ɓ̃W[݂ΒuB
	String module_name = getModuleName(module);
	
	for (int i = 0;i < SHIORI_MODULES.size();i++) {
	    Class current_module = (Class)SHIORI_MODULES.elementAt(i);
	    if (getModuleName(current_module).equals(module_name)) {
		SHIORI_MODULES.removeElementAt(i);
		i--;
	    }
	}
	
	SHIORI_MODULES.add(0, module); // 擪ɁB
    }
    
    public static String getShioriDllFileName(File spirit_root) {
	SCDescription desc = new SCDescription(new File(spirit_root,"descript.txt"));
	if (desc.exists("shiori")) {
	    return desc.getStrValue("shiori");
	}
	
	SCDescription alias = new SCDescription(new File(spirit_root,"alias.txt"));
	if (alias.exists("shiori")) {
	    return alias.getStrValue("shiori");
	}
	
	return "shiori.dll";
    }
    
    public static SCShioriAccessor loadShioriModule(File spirit_root) {
	// FłSHIORI΁Ahome/_system/substitutȇpS[Xg[h܂B
	// DLL𔻕ʂׂspirit_rootdescript.txtalias.txtǂ݂܂B
        SCShioriAccessor shiori = null;
	String shiori_dll_name = getShioriDllFileName(spirit_root);
        
	final int n_SHIORI_MODULES = SHIORI_MODULES.size();
	for (int i = 0;i < n_SHIORI_MODULES;i++) {
	    Class current_module = (Class)SHIORI_MODULES.elementAt(i);
	    if (checkIfUsable(current_module,spirit_root,shiori_dll_name)) {
		shiori = newAccessor(current_module,spirit_root,shiori_dll_name);
		if (shiori != null) {
		    break;
		}
	    }
	}
	
	if (shiori == null) {
	    File substitute = new File(SCFoundation.getParentDirOfBundle(),"home/_system/substitute");
	    if (SCKawari.checkIfUsable(substitute)) {
		try{ shiori = new SCShioriAccessor(new SCKawari(substitute)); }catch(Exception e){}
	    }
	}
	
        return shiori;
    }
    
    public static String getModuleName(File spirit_root) {
	// DLL𔻕ʂׂspirit_rootdescript.txtǂ݂܂B
        String module_name = null;
	String shiori_dll_name = getShioriDllFileName(spirit_root);
	
	final int n_SHIORI_MODULES = SHIORI_MODULES.size();
	for (int i = 0;i < n_SHIORI_MODULES;i++) {
	    Class current_module = (Class)SHIORI_MODULES.elementAt(i);
	    if (checkIfUsable(current_module,spirit_root,shiori_dll_name)) {
		module_name = getModuleName(current_module);
		break;
	    }
	}
        
        return module_name;
    }
    
    public static String getModuleName(Class module) {
	try {
	    Method getModuleName = module.getMethod("getModuleName",null);
	    return (String)getModuleName.invoke(null,null);
	}
	catch (NoSuchMethodException e) {
	    System.err.println("SCShioriLoader error : Shiori module class \""+module.getName()+"\" doesn\'t have method getModuleName().");
	}
	catch (Exception e) {
	    System.err.println("SCShioriLoader error : Exception has occured during accesing shiori module class \""+module.getName()+"\".");
	    e.printStackTrace();
	}
	return null;
    }
    
    public static String getModuleInfo(Class module) {
	// public static String getModuleInfo()ĂԁBnullԂB
	try {
	    Method getModuleInfo = module.getMethod("getModuleInfo",null);
	    return (String)getModuleInfo.invoke(null,null);
	}
	catch (Exception e) {
	    return null;
	}
    }
    
    public static boolean checkIfUsable(Class module,File rootdir,String dll_name) {
	// public static boolean checkIfUsable(File ghostDir,File shiori_dll) D
	// public static boolean checkIfUsable(File ghostDir) tH[obN
	try {
	    try {
		Method checkroutine = module.getMethod("checkIfUsable",new Class[] {File.class,File.class});
		Boolean resp = (Boolean)checkroutine.invoke(null,new Object[] {rootdir,new File(rootdir,dll_name)});
		return resp.booleanValue();
	    }
	    catch (NoSuchMethodException e) {
		Method checkroutine = module.getMethod("checkIfUsable",new Class[] {File.class});
		Boolean resp = (Boolean)checkroutine.invoke(null,new Object[] {rootdir});
		return resp.booleanValue();
	    }
	}
	catch (NoSuchMethodException e) {
	    System.err.println(
		"SCShioriLoader error : Shiori module class \""+
		module.getName()+"\" doesn\'t have method checkIfUsable() .");
	}
	catch (Exception e) {
	    System.err.println("SCShioriLoader error : Exception has occured during accesing shiori module class \""+module.getName()+"\".");
	    e.printStackTrace();
	}
	return false;
    }
    
    public static SCShioriAccessor newAccessor(Class module,File rootdir,String dll_name) {
	// public Foo(File ghostDir,File shiori_dll) D
	// public Foo(File ghostDir) tH[obN
	try {
	    try {
		Constructor con = module.getConstructor(new Class[] {File.class,File.class});
		return new SCShioriAccessor( con.newInstance(new Object[] {rootdir,new File(rootdir,dll_name)}) );
	    }
	    catch (NoSuchMethodException e) {				
		Constructor con = module.getConstructor(new Class[] {File.class});
		return new SCShioriAccessor( con.newInstance(new Object[] {rootdir}) );
	    }
	}
	catch (NoSuchMethodException e) {
	    System.out.println(
		"SCShioriLoader error : Shiori module class \""+
		module.getName()+"\" doesn\'t have some needed methods.");
	    e.printStackTrace();
	}
	catch (Exception e) {
	    System.out.println(
		"SCShioriLoader error : Exception has occured during accesing shiori module class \""+
		module.getName()+"\".");
	    e.printStackTrace();
	}
	return null;
    }
}
