/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCStatusProgressBarView extends NSView
{
	public static NSColor BACKGROUND_COLOR = NSColor.colorWithCalibratedRGB(0.3f,0.3f,0.3f,0.7f);
	
    /*static final NSPoint loc_text1,loc_text2,loc_bar,loc_bar_content;
    static final NSSize size_bar,size_bar_content;
    static final NSRect frame_bar,frame_bar_content;
    static final NSColor color_bar_frame,color_bar_left,color_bar_right;
    static final NSImage image_noise;
    static
    {
		loc_text1 = new NSPoint(7,61);
		loc_text2 = new NSPoint(7,15);
		loc_bar = new NSPoint(20,35);
		loc_bar_content = new NSPoint(loc_bar.x()+2,loc_bar.y()+2);
		size_bar = new NSSize(126,20);
		size_bar_content = new NSSize(size_bar.width()-4,size_bar.height()-4);
		color_bar_frame = NSColor.colorWithCalibratedRGB(1.0f,1.0f,1.0f,0.8f);
		color_bar_left = NSColor.colorWithCalibratedRGB(0.9f,0.0f,0.0f,0.5f);
		color_bar_right = NSColor.colorWithCalibratedRGB(1.0f,1.0f,1.0f,0.2f);
		
		frame_bar = new NSRect(loc_bar,size_bar);
		frame_bar_content = new NSRect(loc_bar.x()+2,loc_bar.y()+2,size_bar.width()-4,size_bar.height()-4);*/
		
		/*NSBitmapImageRep bitmap = new NSBitmapImageRep((int)size_bar.width()-4,
								(int)size_bar.height()-4,
								8,
								4,
								true,
								false,
								NSGraphics.CalibratedRGBColorSpace,
								0,
								0);
		image_noise = new NSImage();
		image_noise.addRepresentation(bitmap);*/
		/*image_noise = null;
    }*/
	
	NSPoint loc_text1,loc_text2,loc_bar,loc_bar_content;
	NSSize size_bar,size_bar_content;
	NSRect frame_bar,frame_bar_content;
	NSColor color_bar_frame,color_bar_left,color_bar_right;
    
    NSFont font;
    NSColor fontcolor;
    NSMutableAttributedString text1,text2;
    double val;
    
    public SCStatusProgressBarView(NSRect r)
    {
		super(r);
				
		font = NSFont.systemFontOfSize(11.0f);
		fontcolor = NSColor.whiteColor();
		text1 = text2 = null;
		val = 0.0;
		
		float height = r.height();
		float width = r.width();
		
		float font_height = font.boundingRectForFont().height();
		
		float bar_width = width - 40;
		float bar_height = 20;
		float bar_top = height/2 + bar_height/2;
		float bar_bottom = height/2 - bar_height/2;
		float over_bar_height = height - bar_top;
		float under_bar_height = over_bar_height;
		
		loc_text1 = new NSPoint(7,bar_top + over_bar_height * (1.0f / 3.0f));
		loc_text2 = new NSPoint(7,bar_bottom - under_bar_height * (1.0f / 3.0f) - font_height/2);
		loc_bar = new NSPoint(20,bar_bottom);
		loc_bar_content = new NSPoint(loc_bar.x()+2,loc_bar.y()+2);
		size_bar = new NSSize(bar_width,bar_height);
		size_bar_content = new NSSize(size_bar.width()-4,size_bar.height()-4);
		color_bar_frame = NSColor.colorWithCalibratedRGB(1.0f,1.0f,1.0f,0.8f);
		color_bar_left = NSColor.colorWithCalibratedRGB(0.9f,0.0f,0.0f,0.5f);
		color_bar_right = NSColor.colorWithCalibratedRGB(1.0f,1.0f,1.0f,0.2f);
		frame_bar = new NSRect(loc_bar,size_bar);
		frame_bar_content = new NSRect(loc_bar.x()+2,loc_bar.y()+2,size_bar.width()-4,size_bar.height()-4);
    }
    
    public void setText1(String str) // can be null
    {
		if (str == null)
		{
			text1 = null;
		}
		else
		{
			text1 = new NSMutableAttributedString(str);
			NSRange wholeStrRange = new NSRange(0,str.length());
			text1.addAttributeInRange(NSAttributedString.FontAttributeName,font,wholeStrRange);
			text1.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,fontcolor,wholeStrRange);
		}
		
		display();
    }
    public void setText2(String str)
    {
		if (str == null)
		{
			text2 = null;
		}
		else
		{
			text2 = new NSMutableAttributedString(str);
			NSRange wholeStrRange = new NSRange(0,str.length());
			text2.addAttributeInRange(NSAttributedString.FontAttributeName,font,wholeStrRange);
			text2.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,fontcolor,wholeStrRange);
		}
		
		display();
    }
    public void setVal(double d) // 0.0 ... 1.0
    {
		val = d;
		display();
    }
    
    static NSMutableRect mrect;
    static NSRect[] rectarray;
    static
    {
		mrect = new NSMutableRect();
		rectarray = new NSRect[] {mrect};
    }
    public void drawRect(NSRect r)
    {
		BACKGROUND_COLOR.set();
		NSBezierPath.fillRect(r);
		
		if (text1 != null) NSGraphics.drawAttributedString(text1,loc_text1);
		if (text2 != null) NSGraphics.drawAttributedString(text2,loc_text2);
		
		if (val >= 0.0 && val <= 1.0)
		{
			color_bar_frame.set();
			NSGraphics.frameRect(frame_bar);
			
			float x,y,w,h;
			int pos = (int)((size_bar.width() - 4) * val);
			mrect.setX(loc_bar.x() + 2);
			mrect.setY(loc_bar.y() + 2);
			mrect.setWidth(pos);
			mrect.setHeight(size_bar.height() - 4);
			color_bar_left.set();
			NSGraphics.fillRectList(rectarray);
			
			mrect.setX(loc_bar.x() + 2 + pos);
			mrect.setWidth(size_bar.width() - 4 - pos);
			color_bar_right.set();
			NSGraphics.fillRectList(rectarray);
		}
		else
		{
			//SCNoiseImageGenerator.scramble(image_noise);
			//image_noise.compositeToPoint(loc_bar_content,NSImage.CompositeSourceOver);
			mrect.setX(loc_bar_content.x());
			mrect.setWidth(size_bar_content.width());
			mrect.setHeight(1);
			int top = (int)loc_bar_content.y() + (int)size_bar_content.height();
			for (int y = (int)loc_bar_content.y();y < top;y++)
			{
				float white = (float)(((Math.random() * Integer.MAX_VALUE) % 70) / 100.0f);
				float alpha = (float)(((Math.random() * Integer.MAX_VALUE) % 70) / 100.0f);
				NSColor.colorWithCalibratedWhite(white,alpha).set();
				
				mrect.setY(y);
				NSGraphics.frameRect(mrect);
			}
		}
    }
}
