/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
	%[color,r,g,b] FݒBeF͈̔͂0-255B
	
	%[color,black]
	%[color,blue]
	%[color,brown]
	%[color,clear]
	%[color,darkgray]
	%[color,gray]
	%[color,green]
	%[color,lightgray]
	%[color,magenta]
	%[color,orange]
	%[color,purple]
	%[color,red]
	%[color,yellow]
	%[color,white]
	
	%[color,default] ftHg̐Fɖ߂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCStatusTextView extends NSView
{
    private static final NSRange FIRSTCHAR_RANGE = new NSRange(0,1);
    private static final int LINE_INTERVAL = 0;
	
	public static NSColor BACKGROUND_COLOR = NSColor.colorWithCalibratedRGB(0.3f,0.3f,0.3f,0.7f);
    
    NSFont font;
    float fontHeight;
	NSColor default_color;
    NSColor current_color;
    
    float x,y;
    NSImage offscreen;
    
    StringBuffer buffer;
    
    public SCStatusTextView(NSRect r)
    {
		super(r);
		
		buffer = new StringBuffer();
		
		setFont(NSFont.systemFontOfSize(10.0f));
		default_color = current_color = NSColor.greenColor();
		
		offscreen = new NSImage(r.size());
		
		x = 0;
		y = r.height() - fontHeight;
    }
    
    public void setFont(NSFont f)
    {
		font = f;
		fontHeight = Math.round(font.boundingRectForFont().height());
    }
    
    public void setColor(NSColor c)
    {
		current_color = c;
    }
    
    public void drawRect(NSRect r)
    {
		BACKGROUND_COLOR.set();
		NSBezierPath.fillRect(r);
		
		// obt@tbV
		if (buffer.length() > 0)
		{
			offscreen.lockFocus();
			while (buffer.length() > 0)
			{
				char c = buffer.charAt(0);
				if (c == '%') // 䖽
				{
					int blockstart = 1;
					int blockend = buffer.toString().indexOf(']');
					
					try
					{
						executeControlCommand(new StringTokenizer(buffer.substring(blockstart+1,blockend),","));
						
						buffer.delete(0,blockend+1);
					}
					catch (Exception e)
					{
						System.err.println("SCStatusTextView: control command error.");
						e.printStackTrace();
						
						buffer.deleteCharAt(0);
					}
				}
				else
				{
					drawChar(c);
					buffer.deleteCharAt(0);
				}
			}
			offscreen.unlockFocus();
		}
		offscreen.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);
    }
    private void drawChar(char c)
    {
		NSMutableAttributedString astr = new NSMutableAttributedString(c+"");
		astr.addAttributeInRange(NSAttributedString.FontAttributeName,font,FIRSTCHAR_RANGE);
		astr.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,current_color,FIRSTCHAR_RANGE);
		
		float widthOfCurrentChar = NSGraphics.sizeOfAttributedString(astr).width();
		// słȂĂA̕`悵ƂŔ͈͂𒴂悤ȂsB
		if (c == '\n' || x + widthOfCurrentChar > frame().width())
		{
			x = 0;
			y -= fontHeight + LINE_INTERVAL;
			
			if (y < 0) // y(0)˂jXN[B
			{
				float deltaY = -1*y;
				
				// ݂̃XN[̓eɉグB
				offscreen.compositeToPoint(new NSPoint(0,deltaY),NSImage.CompositeCopy);
				NSColor.clearColor().set();
				NSGraphics.fillRectList(new NSRect[] {new NSRect(0,0,frame().width(),fontHeight + LINE_INTERVAL)});
				
				y = LINE_INTERVAL;
			}
		}
		if (c != '\n')
		{
			NSGraphics.drawAttributedString(astr,new NSPoint(x,y));
			x += widthOfCurrentChar;
		}
    }
	private void executeControlCommand(StringTokenizer args) throws Exception
	{
		String type = args.nextToken();
		if (type.equals("color"))
		{
			String name = args.nextToken();
			if (name.equals("default"))
			{
				current_color = default_color;
			}
			else if (name.equals("black"))
			{
				current_color = NSColor.blackColor();
			}
			else if (name.equals("blue"))
			{
				current_color = NSColor.blueColor();
			}
			else if (name.equals("brown"))
			{
				current_color = NSColor.brownColor();
			}
			else if (name.equals("clear"))
			{
				current_color = NSColor.clearColor();
			}
			else if (name.equals("darkgray"))
			{
				current_color = NSColor.darkGrayColor();
			}
			else if (name.equals("gray"))
			{
				current_color = NSColor.grayColor();
			}
			else if (name.equals("green"))
			{
				current_color = NSColor.greenColor();
			}
			else if (name.equals("lightgray"))
			{
				current_color = NSColor.lightGrayColor();
			}
			else if (name.equals("magenta"))
			{
				current_color = NSColor.magentaColor();
			}
			else if (name.equals("orange"))
			{
				current_color = NSColor.orangeColor();
			}
			else if (name.equals("purple"))
			{
				current_color = NSColor.purpleColor();
			}
			else if (name.equals("red"))
			{
				current_color = NSColor.redColor();
			}
			else if (name.equals("yellow"))
			{
				current_color = NSColor.yellowColor();
			}
			else if (name.equals("white"))
			{
				current_color = NSColor.whiteColor();
			}
			else
			{
				String r = name;
				String g = args.nextToken();
				String b = args.nextToken();
				try
				{
					current_color = NSColor.colorWithCalibratedRGB(
						Integer.parseInt(r) / 255.0f,
						Integer.parseInt(g) / 255.0f,
						Integer.parseInt(b) / 255.0f,
						1.0f);
				}
				catch (Exception e) {}
			}
		}
	}
        
    public void printstr(String str)
    {
		buffer.append(str);
		display();
    }
}
