/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCStatusWindowCenter
{
	public static int WAIT_BEFORE_CLOSE = 6000; // ~b
	
    Vector stats; // Content : (SCStatusWindowController)Xe[^XEChE@ォ珇ɕłB
    
    public SCStatusWindowCenter()
    {
		stats = new Vector();
    }
    
    public SCStatusWindowController newStatusWindow()
    {
		// 쐬o^
		SCStatusWindowController stat = new SCStatusWindowController(this);
		Hashtable refcon = new Hashtable();
		stat.setRefcon(refcon);
		stats.add(stat);
		
		// ړ
		float screentop = NSScreen.mainScreen().visibleFrame().y() + NSScreen.mainScreen().visibleFrame().height();
		float windowheight = stat.window().frame().height();
		float y = (screentop - (windowheight * stats.size())) + 1;
		refcon.put("virtual_y",new Integer((int)y));
		stat.window().setFrameOrigin(new NSPoint(0,y));
		
		return stat;
    }
    
    public void closeStatusWindow(SCStatusWindowController stat)
    {
		(new AnimationFadeOut(stat)).start();
    }
    
    protected synchronized void removeStatAndAlignAllStats(SCStatusWindowController statToRemove)
    {
		stats.remove(statToRemove);
	
		float current_top = NSScreen.mainScreen().visibleFrame().y() + NSScreen.mainScreen().visibleFrame().height();
		
		final int n_stats = stats.size();
		for (int i = 0;i < n_stats;i++)
		{
			SCStatusWindowController stat = (SCStatusWindowController)stats.elementAt(i);
			current_top = current_top - stat.window().frame().height() + 1;
			
			Hashtable refcon = (Hashtable)stat.getRefcon();
			if (((Integer)refcon.get("virtual_y")).intValue() != (int)current_top)
			{
				refcon.put("virtual_y",new Integer((int)current_top)); // IȃEChEʒuBۂɂ̓Aj[VŕωB
				
				if (refcon.get("mover") != null && ((AnimationMove)refcon.get("mover")).isAlive())
				{
					((AnimationMove)refcon.get("mover")).terminate();
				}
				
				AnimationMove mover = new AnimationMove(stat,0,(int)current_top);
				refcon.put("mover",mover);
				mover.start();
			}
		}
    }
    
    protected class AnimationFadeOut extends Thread
    {
		SCStatusWindowController stat;
		
		public AnimationFadeOut(SCStatusWindowController stat)
		{
			this.stat = stat;
		}
		
		public void run()
		{
			int pool = NSAutoreleasePool.push();
			
			try{sleep(WAIT_BEFORE_CLOSE);}catch (Exception e){}
			removeStatAndAlignAllStats(stat);
			
			final int fade_out_step = 3;
			for (int i = fade_out_step;i >= 0;i--)
			{
				stat.window().setAlphaValue((float)i / (float)fade_out_step);
			}
			
			Hashtable refcon = (Hashtable)stat.getRefcon();
			if (refcon.get("mover") != null && ((AnimationMove)refcon.get("mover")).isAlive())
			{
				((AnimationMove)stat.getRefcon()).terminate();
			}
			stat.close();
			
			NSAutoreleasePool.pop(pool);
		}
	}
    
    protected class AnimationMove extends Thread
	{
		SCStatusWindowController stat;
		int destX,destY;
		
		volatile boolean flagTerm = false;
		
		public AnimationMove(SCStatusWindowController stat,int destX,int destY)
		{
			this.stat = stat;
			this.destX = destX;
			this.destY = destY;
		}
		
		// ֍sAj[VsȂB
		public void run()
		{
			int pool = NSAutoreleasePool.push();
			
			NSWindow targetWindow = stat.window();
			NSMutablePoint point = new NSMutablePoint();
			boolean done = false;
			int Y = (int)stat.window().frame().y();
			int speedY = 0;
			int turnY = (int)(Y + ((destY - Y) / 2)); // ̒n_߂xtɂȂB
			while (!flagTerm && !done)
			{
				int accY = (Y > turnY ? -1 : 1);
				speedY += accY;
				
				int nextY = Y + speedY;
				if (nextY <= Y) nextY = Y + 1;
				if (nextY >= destY)
				{
					nextY = destY;
					done = true;
				}
		
				point.setX(destX);
				point.setY(nextY);
				targetWindow.setFrameOrigin(point);
				
				Y = nextY;
			}
	    
			NSAutoreleasePool.pop(pool);
		}
	
		public void terminate()
		{
			flagTerm = true;
			while (isAlive()) {}
		}
    }
}
