/*
	$Id: SCUpdateCheckerDB.java,v 1.4 2003/10/30 09:59:30 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCUpdateCheckerDB implements NSTableView.DataSource
{
    public static final int STATUS_NO_UPDATE = 0;
    public static final int STATUS_UPDATED = 1;
    public static final int STATUS_NOT_CHECKED_YET = 2;
    
    private static NSColor INAVAILABLE_COLOR = NSColor.grayColor();
    private static NSColor UPDATED_COLOR = NSColor.redColor();
    
    Vector elements;
    File bundleDir;
    File db_dir;
    
    public SCUpdateCheckerDB()
    {
		elements = new Vector();
		bundleDir = new File(SCFoundation.getParentDirOfBundle());
		db_dir = new File(bundleDir,"home/_system/updatechecker_db");
		
		reloadList(false);
    }
    
    public void reloadList(boolean reloadAll)
    {
		// home/ghost/̃S[XgXLăXgč\܂B
		// reloadAll == trueȂ
		//	f[^SSHIORI荞Ńt@Cɕۑ܂B
		// reloadAll == falseȂ
		// 	SHIORIURL擾AۑĂt@Cǂݍ݂܂B
		// 	f[^x[Xɑ݂ȂS[XgSHIORIf[^擾܂B
		elements.clear();
		
		File home_ghost = new File(bundleDir,"home/ghost");
		File[] ghost_dirs = home_ghost.listFiles();
		Vector available_db_elements = new Vector(); // ݂ȂS[XgɑΉDBvft@C͌ɍ폜B
		
		for (int i = 0;i < ghost_dirs.length;i++)
		{
			if (!ghost_dirs[i].isDirectory()) {continue;}
	    
			// descript.txtǂŃS[Xg擾B
			SCDescription desc = new SCDescription(new File(ghost_dirs[i],"/ghost/master/descript.txt"));
			String ghostname = desc.getStrValue("name");
					
			// f[^t@Cdb̒ɂB
			// S[Xg̃fBNg.dbe𖼑OɎB
			String ghostpath = "home/ghost/"+ghost_dirs[i].getName();
			File db_elem_file = new File(db_dir,ghost_dirs[i].getName()+".dbe");
			if (!reloadAll && db_elem_file.exists())
			{
				// reloadAllfalseAt@Ĉ݂łURL񓙂ǂݏoB
				available_db_elements.add(db_elem_file);
				
				SCDescription db_elem = new SCDescription(db_elem_file);
				String available = db_elem.getStrValue("available"); // true : XV\
				String url = db_elem.getStrValue("url"); // XVURL
				int status = db_elem.getIntValue("status"); // 0=`FbN,1=XV,2=XVL
				
				elements.add(available.equals("true") ? new ListElement(ghostpath,ghostname,url,status) : new ListElement(ghostpath,ghostname));
			}
			else
			{
				// SHIORINURL擾
				SCSpirit master_spirit = new SCSpirit(ghost_dirs[i],"master",false);
				String homeurl = master_spirit.getStringFromShiori("homeurl");
				ListElement le;
				if (homeurl == null) // 擾s
				{
					le = new ListElement(ghostpath,ghostname);
				}
				else // 
				{
					le = new ListElement(ghostpath,ghostname,homeurl,STATUS_NOT_CHECKED_YET);
				}
				elements.add(le);
				saveToFile(le,db_elem_file);
				available_db_elements.add(db_elem_file);
			}
		}
		
		// db̒ɑ݂Ȃavailable_db_elementsɓĂȂt@Ci܂S~j
		File[] db_elems = db_dir.listFiles();
		for (int i = 0;i < db_elems.length;i++)
		{
			if (db_elems[i].getName().charAt(0) == '.') continue; // hbgt@C̓XLbv
			if (!available_db_elements.contains(db_elems[i]))
			{
			db_elems[i].delete();
			}
		}
    }
    
    public Vector generateGhostListToCheck()
    {
		/*
			`FbNKvƂSS[Xg̃XgԂB
			̏ɊYS[XgI΂B
			
			Eavailableł邱
			E[Õ`FbNŁuXVꂽvƂȂĂȂ] ς߁B
			
			
			ԂVectoř`͎̒ʂB
			content : (Hashtable)data
			data - key : (String)"ghost_path" , value : (String)S[Xg̃pXihome/ghost/...j
			data - key : (String)"url" , value : (String)XVURL
		*/
		Vector result = new Vector();
		
		final int n_elems = elements.size();
		for (int i = 0;i < n_elems;i++)
		{
			ListElement le = (ListElement)elements.elementAt(i);
			if (le.isAvailable())
			{
				Hashtable ht = new Hashtable();
				ht.put("ghost_path",le.getPath());
				ht.put("url",le.getUrl());
				result.add(ht);
			}
		}
	
		return result;
    }
    
    public void setStatusOfGhost(String ghost_path,int status)
    {
		// status : SCUpdateCheckerDB̒萔
		ListElement le = findElement(ghost_path);
		if (le == null) return;
		
		le.setStatus(status);
		File db_elem_file = new File(db_dir,NSPathUtilities.lastPathComponent(ghost_path)+".dbe");
		saveToFile(le,db_elem_file);
	}
		
	protected ListElement findElement(String ghost_path)
	{
		final int n_elems = elements.size();
		for (int i = 0;i < n_elems;i++)
		{
			ListElement le = (ListElement)elements.elementAt(i);
			if (le.getPath().equals(ghost_path))
			{
				return le;
			}
		}
		return null;
    }
    
    protected void saveToFile(ListElement le,File dest_file)
    {
		boolean available = le.isAvailable();
		
		SCDescription db_elem = new SCDescription();
		if (available)
		{
			db_elem.setStrValue("available","true");
			db_elem.setStrValue("url",le.getUrl());
			db_elem.setIntValue("status",le.getStatus());
		}
		else
		{
			db_elem.setStrValue("available","false");
		}
		
		try
		{
			db_elem.save(dest_file);
		}
		catch (Exception e){}
    }
    
    private class ListElement
    {
		String ghost_path;
		String ghost_name;
		String url;
		boolean available; // XV\ۂB = SHIORIURLԂۂB
		int status; // available == false̎ɂ͂̒l͖ӖB
		
		public ListElement(String ghost_path,String ghost_name)
		{
			// XVs\ȃS[Xg
			this.ghost_path = ghost_path;
			this.ghost_name = ghost_name;
			url = null;
			available = false;
		}
		
		public ListElement(String ghost_path,String ghost_name,String url,int status)
		{
			// XV\ȃS[Xg
			this.ghost_path = ghost_path;
			this.ghost_name = ghost_name;
			this.url = url;
			this.available = true;
			this.status = status;
		}
		
		public String getPath() {return ghost_path;}
		public String getName() {return ghost_name;}
		public String getUrl() {return url;}
		public boolean isAvailable() {return available;}
		public int getStatus() {return status;}
		
		public void setAvailable(boolean b) {available = b;}
		public void setStatus(int s) {status = s;}
    }
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView)
    {
        return elements.size();
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return false;
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        String column_id = (String)aTableColumn.identifier();
        ListElement elem = (ListElement)elements.elementAt(rowIndex);
        
        if (column_id.equals("ghost"))
        {
			if (!elem.isAvailable())
			{
				return putColor(elem.getName(),INAVAILABLE_COLOR);
			}
			else
			{
				return elem.getName();
			}
        }
        else if (column_id.equals("status"))
        {
			if (!elem.isAvailable())
			{
				return putColor("\u66f4\u65b0\u4e0d\u53ef",INAVAILABLE_COLOR); // XVs
			}
	    
            switch (elem.getStatus())
			{
				case	STATUS_NO_UPDATE:
				return "\u66f4\u65b0\u7121\u3057"; // XV
				
				case	STATUS_UPDATED:
				return putColor("\u66f4\u65b0\u6709\u308a",UPDATED_COLOR); // XVL
				
				case	STATUS_NOT_CHECKED_YET:
				return "\u672a\u30c1\u30a7\u30c3\u30af"; // `FbN
			}
        }
	
		return null;
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        // do nothing
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard)
    {
        // optional
        return false;
    }
    
    public void tableViewSortDescriptorsDidChange(
        NSTableView tableView,
        NSArray rows) {
        // optional
    }
    
    public static NSAttributedString putColor(String src,NSColor color)
    {
		NSMutableAttributedString mas = new NSMutableAttributedString(src);
		mas.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,color,new NSRange(0,src.length()));
		return mas;
    }
}
