/*
	$Id: SCUpdateDataMaker.java,v 1.4 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;

public class SCUpdateDataMaker extends Thread
{
    String path;
    SCSession target;
    
    public SCUpdateDataMaker(String path)
    {
		this.path = (path.endsWith("/") ? path.substring(0,path.length()-1) : path);
		this.target = null;
    }
    
    public SCUpdateDataMaker(String path,SCSession target)
    {
		// targetɎw肳ꂽS[XgSHIORICxgM܂B
		this.path = path;
		this.target = target;
    }
    
    public void run()
    {
		int pool = NSAutoreleasePool.push();
		
		SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
		stat.setTypeToText();
		stat.show();
		stat.texttype_print("Creating %[color,orange]updates.txt%[color,default] and %[color,orange]updates2.dau%[color,default]...\n");
		
		// ^[Qbgw肳ĂȂΓKɑIԁB
		if (target == null) target = SCFoundation.sharedFoundation().getSession();
		
		final File rootdir = new File(path);
		
		// Ƃ肠fBNg̃[gupdates.txtႵupdates2.dauΘbɂȂȂB
		if (!hasDauFile(rootdir))
		{
			stat.closeWindow();
			NSAutoreleasePool.pop(pool);
			return;
		}
	
		// OnUpdatedataCreatingM
		if (target != null) target.doShioriEvent("OnUpdatedataCreating");
		
		// 쐬Jn
		SCStatusWindowController prog_ud2 = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
		prog_ud2.setTypeToProgressBar();
		prog_ud2.show();
		prog_ud2.pbartype_setText1("Creating updates.txt and updates2.dau...\n");
		
		SCUpdatesList dau = new SCUpdatesTxt();
		workForDir(rootdir,dau,prog_ud2);
		
		prog_ud2.pbartype_setVal(1.0);
		prog_ud2.pbartype_setText1("Done.");
		prog_ud2.pbartype_setText2(null);
		prog_ud2.closeWindow();
		
		// updates2_dau쐬BdauRs[B
		SCUpdatesList updates2_dau = new SCUpdates2Dau();
		updates2_dau.addAll(dau);
		
		// ۑ
		File out_updatestxt = new File(rootdir,"updates.txt");
		try{ dau.saveToFile(out_updatestxt); }catch(Exception e){}
		
		File outdau = new File(rootdir,"updates2.dau");
		try{ updates2_dau.saveToFile(outdau); }catch(Exception e){}
	
		// OnUpdatedataCreatedM
		if (target != null) target.doShioriEvent("OnUpdatedataCreated");
		
		stat.texttype_print("%[color,white]Created.%[color,default]");
		stat.closeWindow();
		
		NSAutoreleasePool.pop(pool);
    }
    
    private void workForDir(File dir,SCUpdatesList dau,SCStatusWindowController prog_ud2)
    {
		prog_ud2.pbartype_setVal(-1.0);
		prog_ud2.pbartype_setText2(dir.getName());
		
		final File[] files = dir.listFiles();
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].isDirectory())
			{
				workForDir(files[i],dau,prog_ud2); // ċA
			}
			else if (files[i].isFile())
			{
				String name = files[i].getName();
				if (name.charAt(0) != '.' && !name.equals("updates2.dau") &&
					!name.equals("updates.txt") && !name.equals("delete.txt"))
				{
					// hbgt@COB
					prog_ud2.pbartype_setVal(-1.0);
					prog_ud2.pbartype_setText2(name);
					
					String relative_path = files[i].getPath().substring(path.length()+1);
					String md5_string = SCFileUtils.getMD5AsString(files[i]);
				
					dau.addFile(relative_path,md5_string);
				}
			}
		}
    }
    
    public void waitUntilEnd()
    {
		while (isAlive()) {}
    }
    
    public static boolean hasDauFile(File dir)
    {
		// fBNgdir̃[gupdates.txtupdates2.dau݂邩ǂ𒲂ׂ܂B
		// ȂdirfBNgłȂfalseԂ܂B
		if (!dir.isDirectory()) return false;
		
		File[] files = dir.listFiles();
		boolean foundDau = false;
		for (int i = 0;i < files.length;i++)
		{
			if (files[i].getName().equals("updates.txt") ||
				files[i].getName().equals("updates2.dau"))
			{
				foundDau = true;
				break;
			}
		}
		return foundDau;
    }
}
