/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawkput

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya;
import aya.*;

public class Token {
    int type;
    String token;
    boolean space_was_before_token;
    Position position;
	
    public Token(int type,String token,boolean space_was_before_token) {
	this.type = type;
	this.token = token;
	this.space_was_before_token = space_was_before_token;
	this.position = new Position();
    }
    public Token(int type,String token,boolean space_was_before_token, int row) {
	this(type, token, space_was_before_token);
	this.position = new Position(row);
    }
	
    public int getType() {
	return type;
    }
	
    public boolean isIdentifier() {
	return type == LexicalAnalyzer.TYPE_IDENTIFIER;
    }
    public boolean isSymbol() {
	return type == LexicalAnalyzer.TYPE_SYMBOL;
    }
    public boolean isNumber() {
	return type == LexicalAnalyzer.TYPE_NUMBER;
    }
    public boolean isString() {
	return type == LexicalAnalyzer.TYPE_STRING;
    }
    
    public String getToken() {
	return token;
    }
    
    public boolean wasSpaceBefore() {
	return space_was_before_token;
    }
    
    public String toString() {
	return "{"+type+":"+token+"}";
    }
    
    public Position getPosition() {
	return this.position;
    }
    public class Position {
	private int row;
//	private int column;
	public Position() {
	    this.row = 0;
	}
	public int getRow() {
	    return this.row;
	}
	public Position(int row) {
	    this.row = row;
	}
	public String toString() {
	    return "line " + Integer.toString(row);
	}
    }
}