/*  $Id: Dictionary.java,v 1.4 2004/01/29 20:59:02 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.io.*;
import java.util.*;

public class Dictionary {
    Misaka misaka;
    Hashtable root; // key : (String)ϐ , content : Vector<Variable>ϐ
    
    public Dictionary(Misaka misaka) {
	this.misaka = misaka;
	root = new Hashtable();
    }
    
    public void loadDicFile(File dicfile) {
	if (!dicfile.exists()) return;
	
	try {
	    // vvZbTV{𔽉f邽߁Aϐ𐏎e[uɓĂ܂Ȃŗ߂ĂB
	    Vector all_variables_in_this_file = new Vector();
	    
	    BufferedReader br;
	    if (dicfile.getName().endsWith(".__1")) {
		br = new BufferedReader(
		    new InputStreamReader(
			new DictionaryDecodingInputStream(
			    new FileInputStream(dicfile)),"SJIS"));
	    }
	    else {
		br = new BufferedReader(
		    new InputStreamReader(
			new FileInputStream(dicfile),"SJIS"));
	    }
	    String header = null;
	    Vector lines = new Vector();
	    while (true) {
		String line = br.readLine();
		if (line == null) break;
		if (line.length() == 0) continue; // ̍ŝŖ
		if (line.startsWith("//")) continue; // Rgs
		
		if (header == null) { // Ggm肵ĂȂ
		    if (line.charAt(0) != '$' && line.charAt(0) != '#') continue; // $#Ŏn܂ĂȂ̂Ŗ
		    else {
			header = convertBackslashToYen(line);
		    }
		}
		else { // Ggm肵Ă
		    if (line.charAt(0) == '$' || line.charAt(0) == '#') { // ̃GgBIB
			all_variables_in_this_file.add(
			    parseHeaderAndLines(header,lines));
			header = convertBackslashToYen(line);
			lines.clear();
		    }
		    else { // Gg̑B{}̂܂܈̍ڂɂȂĂ邱ƂɒӁB
			lines.add(convertBackslashToYen(line));
		    }
		}
	    }
	    if (header != null) {
		all_variables_in_this_file.add(
		    parseHeaderAndLines(header,lines));
	    }
	    br.close();
	    
	    // all_variables_in_this_file̒V{#_CommonTB
	    // ݂΂폜AXv[ꂽSĂ̕ϐɏtB
	    String common_condition = null;
	    for (Iterator vars = all_variables_in_this_file.iterator();vars.hasNext();) {
		Variable current_var = (Variable)vars.next();
		if (current_var.getName().equals("#_Common")) {
		    vars.remove();
		    
		    common_condition = current_var.getContent();
		    if (common_condition.length() == 0) common_condition = null;
		    
		    break;
		}
	    }
	    
	    // Vɐݒ肳̗p͌̕ϐ̗pĂȂ#_Common̓ê̂ŁA
	    // ɎĂ{$if ([̏] && [#_Common̓e])}ƂȂB
	    if (common_condition != null) {
		for (Iterator vars = all_variables_in_this_file.iterator();vars.hasNext();) {
		    Variable current_var = (Variable)vars.next();
		    if (current_var.getCondition().length() == 0) {
			current_var.setCondition(common_condition);
		    }
		    else {
			current_var.setCondition(
			    "{$if ("+current_var.getCondition()+" && "+common_condition+")}");
		    }
		}
	    }
	    
	    // all_variables_in_this_file̓eSăe[uɏ悹B
	    for (Iterator vars = all_variables_in_this_file.iterator();vars.hasNext();) {
		appendVariable((Variable)vars.next());
	    }
	}
	catch (Exception e) {
	    System.err.println("The Misaka Java Clone : exception occured in loading dictionary "+dicfile.getName());
	    e.printStackTrace();
	}
    }
	
	public void restoreUserVariables()
	{
		// SĂ̎[hɌĂŉB
		loadDicFile(new File(misaka.getGhostDir(),".misakajava-savedata.txt"));
		
		misaka.getEvaluator().evaluate(getContentOfVariable("$_Variable"));
		misaka.getEvaluator().evaluate(getContentOfVariable("$___MISAKA-JAVA_SAVEDATA_ENTRY___"));
		misaka.getEvaluator().evaluate(getContentOfVariable("$_Constant"));
	}
	
	public void saveUserVariables()
	{
		try
		{
			File savedatafile = new File(misaka.getGhostDir(),".misakajava-savedata.txt");
			if (savedatafile.exists()) savedatafile.delete();
			
			Writer w = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(savedatafile),"SJIS"));
			w.write("// This is savedata file for misaka-java.\n");
			w.write("\n");
			w.write("$___MISAKA-JAVA_SAVEDATA_ENTRY___\n");
			w.write("{\n");
			
			for (Enumeration var_names_e = root.keys();var_names_e.hasMoreElements();)
			{
				String var_name = (String)var_names_e.nextElement();
				Vector vars = (Vector)root.get(var_name);
				
				for (Enumeration vars_e = vars.elements();vars_e.hasMoreElements();)
				{
					Variable variable = (Variable)vars_e.nextElement();
					final int var_size = variable.size();
					
					if (variable.isVariableOfDictionary()) continue;
					if (var_size == 0) continue;
					if (var_size == 1 && variable.getContentAtIndex(0).length() == 0) continue;
					
					if (var_size == 1)
					{
						w.write("\t{"+var_name+"=\""+variable.getContentAtIndex(0)+"\"}\n");
					}
					else
					{
						w.write("\t{"+var_name+"=\""+variable.getContentAtIndex(0)+"\"}");
						for (int i = 1;i < var_size;i++)
						{
							w.write("{$append("+var_name+",\""+variable.getContentAtIndex(i)+"\")}");
						}
						w.write("\n");
					}
				}
			}
			
			w.write("}\n");
			w.flush();
			w.close();
		}
		catch (Exception e)
		{
			System.err.println("misaka.Dictionary#saveUserVariables : couldn't save user variables.");
			e.printStackTrace();
		}
	}
    
    public String getContentOfVariable(String var_name) {
	// w肵Oϐ̒gԂB
	// t̕ϐ݂ꍇA
	// 1) ɍ̂΂ꂪD悳Bi̖͑I΂Ȃj
	// 2) ɍ̂Ώ̖̂I΂B
	// YϐnullԂB
	// ܂Ã\bh̓VXeϐ̒lԂB
	String sysvar_content = misaka.getSystemVariablePackage().get(var_name);
	if (sysvar_content != null) return sysvar_content;
	
	Variable v = findVariable(var_name,true);
	if (v == null) {
	    return null;
	}
	else {
	    return v.getContent();
	}
    }
    
    public Variable findVariable(String var_name,boolean do_condition_evaluating) {
	/*
	  do_condition_evaluating:
	  trueȂt̕ϐ̏]đIBfalseȂn߂Ɍt̂IB
	  
	  ǌtȂnullԂB
	*/
	Vector vars = (Vector)root.get(var_name);
	if (vars == null) return null;
	
	if (do_condition_evaluating) {
	    final int n_vars = vars.size();
	    for (int i = 0;i < n_vars;i++) {
		Variable v = (Variable)vars.elementAt(i);
		String condition = v.getCondition();

		try {
		    if (condition.length() == 0 ||
			misaka.getEvaluator().evaluate(condition).equals("true")) {
			return v;
		    }
		} catch (Exception e) {
		    throw new RuntimeException(
			"Evaluation of condition failed: variable `"+var_name+"'", e);
		}
	    }
	    return null;
	}
	else {
	    return (Variable)vars.elementAt(0);
	}
    }
	
	public Vector collectVariablesWhoseNamesContainThese(Vector strings)
	{
		// ϐVector<String> strings̓eSĊ܂ނ̂W߂ĕԂB߂lVector<Variable>B
		// ̃\bh͏tőd`ꂽϐAŏɒ`ꂽ̂IԁB
		// 𖞂̂IԂׂmȂAdȂ肻B
		// ǂɂׂ̓}jAɋLqĂȂB
		Vector result = new Vector();
		final int n_strings = strings.size();
		
		for (Enumeration name_e = root.keys();name_e.hasMoreElements();)
		{
			String name = (String)name_e.nextElement();
			
			boolean matched_all = true;
			for (int i = 0;i < n_strings;i++)
			{
				String str = (String)strings.elementAt(i);
				if (name.indexOf(str) == -1) // sv
				{
					matched_all = false;
					break;
				}
			}
			
			if (matched_all)
			{
				result.add(findVariable(name,false));
			}
		}
		return result;
	}
    
    public static String convertBackslashToYen(String src)
    {
		// obNXbVɒu
		StringBuffer buf = new StringBuffer();
		final int len = src.length();
		for (int i = 0;i < len;i++)
		{
			char c = src.charAt(i);
			int n = (int)c;
			buf.append(c == 0x005c ? 0x00a5 : c);
		}
		return buf.toString();
    }
	
	public Variable putUserVariable(String name,String content)
	{
		// Vɕϐǉ邩㏑A̕ϐԂB
		// ̕ϐread-onlyƂĒ`Ă牽ȂB
		if (name == null || content == null) return null;
		
		Variable new_var = putUserVariable(name);
		if (new_var != null)
		{
			new_var.addContent(content);
		}
		return new_var;
	}
	
	public Variable putUserVariable(String name,Vector contents)
	{
		// Vɕϐǉ邩㏑A̕ϐԂB
		// ̕ϐread-onlyƂĒ`Ă牽ȂB
		if (name == null || contents == null) return null;
		
		Variable new_var = putUserVariable(name);
		if (new_var != null)
		{
			new_var.addContents(contents);
		}
		return new_var;
	}
	
	public Variable putUserVariable(String name)
	{
		// Vɕϐǉ邩㏑A̕ϐԂB
		// ̕ϐread-onlyƂĒ`Ă牽ȂB
		if (name == null) return null;
		
		Variable new_var = null;
		if (root.containsKey(name))
		{
			Vector variables = (Vector)root.get(name);
			if (variables.size() > 0 && ((Variable)variables.elementAt(0)).isVariableOfDictionary())
			{
				System.err.println("misaka.Dictionary#putUserVariable : read-only variable \""+name+"\" was getting modified.");
				return null;
			}
			else
			{
				new_var = new Variable(name,false);
				
				variables.clear();
				variables.add(new_var);
			}
		}
		else
		{
			new_var = new Variable(name,false);
			
			Vector dummy_vec = new Vector(1);
			dummy_vec.add(new_var);
			
			root.put(name,dummy_vec);
		}
		return new_var;
	}

    public class VariableHeaderTokenizer {
	StringBuffer buf;
	public VariableHeaderTokenizer(String header) {
	    buf = new StringBuffer(header);
	}
	public boolean hasNext() {
	    return buf.length() > 0;
	}
	public String next() {
	    for (int i = 0; i < buf.length(); i++) {
		if (buf.charAt(i) == '"') {
		    int quote = buf.indexOf("\"", i+1);
		    if (quote != -1) {
			i = quote;
		    }
		}
		else if (buf.charAt(i) == '{') {
		    String block = Evaluator.getOutmostNest(buf.toString(), '{', '}', i);
		    i += block.length() - 1;
		}
		else if (buf.charAt(i) == ';' || buf.charAt(i) == ',') {
		    String token = buf.substring(0, i).trim();
		    buf.delete(0, i+1);
		    return token;
		}
	    }
	    String last = buf.toString().trim();
	    buf.setLength(0);
	    return last;
	}
    }
    protected Variable parseHeaderAndLines(String header,Vector lines) {
	String varname; // $#Ŏn܂B
	Vector parameters = new Vector();

	VariableHeaderTokenizer vht = new VariableHeaderTokenizer(header);
	varname = vht.next().trim();
	while (vht.hasNext()) {
	    parameters.add(vht.next().trim());
	}
	
	Variable variable = new Variable(varname,true,parameters);
	for (Iterator ite = lines.iterator(); ite.hasNext(); ) {
	    String line = (String)ite.next();
	    if (line.equals("{")) {
		StringBuffer buf = new StringBuffer();
		
		boolean closed = false;
		while (ite.hasNext()) {
		    String inner_line = (String)ite.next();
		    if (inner_line.equals("{")) {
			System.err.println(
			    "misaka.Dictionary: warning: nested block `{' in `"+header+"' is ignored.");
			continue;
		    }
		    else if (inner_line.equals("}")) {
			closed = true;
			break;
		    }
		    buf.append(inner_line.trim());
		}
		if (!closed) {
		    System.err.println("misaka.Dictionary: warning; `$header' has unclosed block.");
		}
		
		variable.addContent(buf.toString());
	    }
	    else {
		variable.addContent(line.trim());
	    }
	}
	
	return variable;
    }
    
    protected void appendVariable(Variable variable)
    {
		String name = variable.getName();
		
		Vector variables;
		if (root.containsKey(name)) // ̕ϐɑ݂Ă
		{
			variables = (Vector)root.get(name);
		}
		else
		{
			variables = new Vector();
			root.put(name,variables);
		}
		variables.add(variable);
    }
}
