/*
 $Id: DictionaryDecodingInputStream.java,v 1.1 2003/01/05 10:54:10 phonohawk Exp $
 -----
 
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2002 phonohawk

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import java.io.*;

public class DictionaryDecodingInputStream extends FilterInputStream
{
	public DictionaryDecodingInputStream(InputStream is)
	{
		super(is);
	}
	
	public int read() throws IOException
	{
		int int_data = in.read();
		if (int_data == -1) return -1;
		
		return (int_data & 0xff) ^ 0xff;
	}
	
	public int read(byte[] b,int off,int len) throws IOException
	{
		final int n_read = in.read(b,off,len);
		if (n_read == -1) return -1;
		
		for (int i = off;i < off + n_read;i++)
		{
			b[i] = (byte)((b[i] & 0xff) ^ 0xff);
		}
		return n_read;
	}
}