/*  $Id: ExpressionTokenizer.java,v 1.2 2004/01/29 20:59:02 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;

public class ExpressionTokenizer {
    StringBuffer buf;
    
    public ExpressionTokenizer(String expr) {
	buf = new StringBuffer(expr);
    }
    
    public boolean hasMoreTokens() {
	return (buf.length() > 0);
    }
    
    protected String startsWithOperator(String world,int pos) {
	// worldposԖڂ̕牉Zqn܂Ă炻̉ZqA
	// łȂnullԂB
	String result = null;
	
	char c = world.charAt(pos);
	if (c == '+') {
	    result = "+";
	}
	else if (c == '-') {
	    result = "-";
	}
	else if (c == '*') {
	    result = "*";
	}
	else if (c == '/') {
	    result = "/";
	}
	else if (c == '%') {
	    result = "%";
	}
	else if (c == '^') {
	    result = "^";
	}
	else if (c == '(') {
	    result = "(";
	}
	else if (c == ')') {
	    result = ")";
	}
	else if (c == '"') {
	    int end_quote = world.indexOf('"', pos+1);
	    if (end_quote == -1) {
		throw new RuntimeException("Unbalanced quote: `"+world+"'");
	    }
	    result = world.substring(pos, end_quote+1);
	}
	else if (c == '{') {
	    int brace_level = 1;
	    boolean is_in_string_literal = false;
	    
	    final int len = world.length();
	    for (int i = pos+1;i < len;i++) {
		char ch = world.charAt(i);
		
		if (ch == '"') {
		    is_in_string_literal = !is_in_string_literal;
		}
		else if (ch == '{' && !is_in_string_literal) {
		    brace_level++;
		}
		else if (ch == '}' && !is_in_string_literal) {
		    brace_level--;
		    if (brace_level == 0) { // Ńg[NI
			result = world.substring(pos,i+1);
			break;
		    }
		}
	    }
	}
	return result;
    }
    
    public String nextToken() {
	String result = null;
	
	result = startsWithOperator(buf.toString(),0);
	if (result == null) {
	    // ̉ZqTB΍Ō܂ł̃g[NłB
	    final int len = buf.length();
	    for (int i = 1;i < len;i++) {
		if (startsWithOperator(buf.toString(),i) != null) {
		    // ZqnP[BZqO̕ԂB
		    result = buf.substring(0,i);
		    break;
		}
	    }
	    if (result == null) {
		result = buf.toString();
	    }
	}
	
	buf.delete(0,result.length());
	return result;
    }
}