/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package misaka;
import misaka.*;
import java.util.*;

public class Variable
{
    String name;
    String condition; // ̗p@΋
	boolean is_dictionary; // ϐǂBϐread-onlyłA܂Z[uȂB
	boolean nonoverlap; // nonoverlap
	boolean sequential; // sequential
    Vector contents; // <String>e
	
	Vector pool_for_nonoverlap = null; // nonoverlaptĂ鎞Acontentv[ĂׂɎgB
	int current_index_for_sequential = 0; // sequentialtĂ鎞Ä݂ʒuۑׂɎgB
    
	public Variable(String name,boolean is_dictionary)
	{
		this(name,is_dictionary,null);
	}
	
    public Variable(String name,boolean is_dictionary,Vector parameters)
    {
		// parameters : Vector<String>
		this.name = name;
		this.is_dictionary = is_dictionary;
		condition = "";
		nonoverlap = false;
		sequential = false;
		contents = new Vector();
		
		// parameters
		if (parameters != null)
		{
			for (Enumeration e = parameters.elements();e.hasMoreElements();)
			{
				String param = (String)e.nextElement();
				if (param.startsWith("{"))
				{
					// {Ŏn܂}ŏÎ͍̗pB
					// cc$symbol; true; sequentialƂ`Ă邩mȂc
					condition = param.trim();
				}
				else if (param.equals("nonoverlap"))
				{
					nonoverlap = true;
				}
				else if (param.equals("sequential"))
				{
					sequential = true;
				}
			}
		}
    }
    
    public String getName()
    {
		return name;
    }
	
	public boolean isVariableOfDictionary()
	{
		return is_dictionary;
	}
	
	public String getCondition()
	{
		return condition;
	}
	
	public void setCondition(String condition)
	{
		this.condition = condition;
	}
	
	public String getContent()
	{
		// nonoverlap,sequentialȂǂ̑𔽉fAgoB
		if (contents.size() == 0)
		{
			return "";
		}
		else if (nonoverlap)
		{
			if (pool_for_nonoverlap == null)
					pool_for_nonoverlap = new Vector();
			
			if (pool_for_nonoverlap.size() == 0)
			{
				// contents̓eSpoolɃRs[
				pool_for_nonoverlap.addAll(contents);
			}
			
			int idx = (int)(Math.random() * Integer.MAX_VALUE) % pool_for_nonoverlap.size();
			String result = (String)pool_for_nonoverlap.elementAt(idx);
			pool_for_nonoverlap.removeElementAt(idx); // Icontentpool폜
			return result;
		}
		else if (sequential)
		{
			if (current_index_for_sequential >= contents.size())
			{
				current_index_for_sequential = 0; // contents̃TCYzĂ犪߂B
			}
			
			String result = (String)contents.elementAt(current_index_for_sequential);
			current_index_for_sequential++;
			return result;
		}
		else
		{
			int idx = (int)(Math.random() * Integer.MAX_VALUE) % contents.size();
			return (String)contents.elementAt(idx);
		}
	}
	
	public String getContentAtIndex(int index)
	{
		// indexԖڂ̗vfԂB
		// vf݂Ȃ΃G[oċ󕶎ԂB
		if (index >= contents.size())
		{
			System.err.println("misaka.Variable#getContentAtIndex : "+name+"["+index+"] is illegal.");
			System.err.println("  variable "+name+" has only "+contents.size()+" elements.");
			return "";
		}
		else
		{
			return (String)contents.elementAt(index);
		}
	}
    
    public void addContent(String str)
    {
		contents.add(str);
    }
	
	public void addContents(Vector src)
	{
		contents.addAll(src);
	}
    
    public void addContents(Variable src)
    {
		contents.addAll(src.getContents());
    }
	
	public void clearContents()
    {
		contents.clear();
    }
	
	public void deleteContentAtIndex(int index)
	{
		// indexԖڂ̗vf폜B
		contents.remove(index);
	}
	
	public Vector getContents()
    {
		// ԂꂽVectorύX鎖͏߂ȂB
		return contents;
    }
	
	public int size()
	{
		return contents.size();
	}
}
