/*  $Id: Evaluator.java,v 1.7 2004/01/29 12:14:45 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;
import satori.saori.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;

public class Evaluator {
    public static final int WAIT_MAX_LIMIT = 400;
    Satori satori;
    
    public Evaluator(Satori satori) {
	this.satori = satori;
    }
    
    public String evaluate(String sentence_block) {
	satori.getDictionary().updateSettingOfAllBlocks();
	
	boolean scope_hontai = false;
	try {
	    StringBuffer buf = new StringBuffer();
	    BufferedReader br = new BufferedReader(new StringReader(sentence_block));
	    while (true) {
		String line = br.readLine();
		if (line == null) break; // end
		
		while (line.length() > 0 && line.charAt(line.length()-1) == Satori.ZENKAKU_FAI) {
		    // ӂŏIĂ玟̍sƌqB
		    line = line.substring(0,line.length()-1) + br.readLine();
		}
		
		while (checkMatchingParenthesis(line) == false) { // ʂ̍sɓnĂSĘA
		    String next_line = br.readLine();
		    if (next_line == null) {
			System.err.println("satori.Evaluator#evaluate : parenthesis not matched");
			System.err.println(sentence_block);
			System.err.println("");
			return "";
		    }
		    
		    line = line + next_line;
		}
		
		if (line.length() == 0) {
		    buf.append("\\n");
		}
		else {
		    StringBuffer linebuf = new StringBuffer(line);
		    
		    if (linebuf.charAt(0) == '$') { // Ŏn܂Ă
			int tab_pos = linebuf.toString().indexOf('\t');
			int equal_pos = linebuf.toString().indexOf('=');
			if (tab_pos != -1) { // P
			    String name = evaluateParenthesis(linebuf.substring(1,tab_pos),"",scope_hontai);
			    String val = evaluateParenthesis(linebuf.substring(tab_pos+1),"",scope_hontai);
			    
			    // ʏ
			    if (name.equals(Satori.ZENKAKU_RELOAD_DIC)
				&& val.equals(Satori.ZENKAKU_JIKKOU)) {
				
				satori.getVariable().remove(name);
				satori.reloadDictionary();
			    }
			    else if (name.equals(Satori.ZENKAKU_SHUDOU_SAVE)
				     && val.equals(Satori.ZENKAKU_JIKKOU)) {

				satori.getVariable().remove(name);
				satori.getVariable().synchronize();
			    }
			    else if (name.equals(Satori.ZENKAKU_JIDOU_SAVE_KANKAKU)) {
				try {
				    satori.setAutosaveInterval(Integer.parseInt(val));
				}
				catch (Exception e) {
				    satori.getVariable().put(name, val);
				}
			    }
			    else if (name.equals(Satori.ZENKAKU_DIC_DIR)) {
				satori.getVariable().put(name,val);
				satori.reloadDictionary();
			    }
			    else if (name.equals(Satori.ZENKAKU_WHAT_TO_LEARN)) {
				satori.getVariable().put("***WHAT_TO_LEARN***",val);
				buf.append("\\__t"); // TEACH BOX\B
			    }
			    else if (name.equals(Satori.ZENKAKU_TUGI_NO_TALK)) {
				satori.getVariable().remove(name);
				satori.reserveTalk(0, val);
			    }
			    else if (name.startsWith(Satori.ZENKAKU_TUGIKARA)
				     && name.endsWith(Satori.ZENKAKU_KAIME_NO_TALK)) {
				satori.getVariable().remove(name);
				try {
				    Pattern pat = Pattern.compile(
					Satori.ZENKAKU_TUGIKARA + "(\\d+)" + Satori.ZENKAKU_KAIME_NO_TALK);
				    Matcher m = pat.matcher(val);
				    m.find();
				    int n = Integer.parseInt(m.group(1));
				    satori.reserveTalk(n-1, val);
				}
				catch (Exception e) {
				    satori.getVariable().put(name, val);
				}
			    }
			    else {
				satori.getVariable().put(name,val);
			    }
			}
			else if (equal_pos != -1) { // vZɑ
			    String name = evaluateParenthesis(linebuf.substring(1,equal_pos),"",scope_hontai);
			    String cond = evaluateParenthesis(linebuf.substring(equal_pos+1),"0",scope_hontai);
			    
			    satori.getVariable().put(name,evalCondition(cond));
			}
			else {
			    System.err.println("The Satori Java Clone: syntax error in variable command: "+linebuf);
			}
			continue; // ̍sցB
		    }
		    else if (linebuf.charAt(0) == '>') { // Ŏn܂Ă
			if (linebuf.toString().indexOf('\t') != -1) { // t
			    StringTokenizer st = new StringTokenizer(linebuf.toString(),"\t");
			    String destination = evaluateParenthesis(st.nextToken().trim(),"",scope_hontai);
			    String condition = evaluateParenthesis(st.nextToken().trim(),"0",scope_hontai);
			    
			    if (evalCondition(condition).equals("0")) {
				// ̌ʂ[Ȃ瑱s
				continue;
			    }
			    else {
				linebuf.replace(0, linebuf.length(), destination);
			    }
			}
			
			// ݂̕邩B
			String sentence = satori.getDictionary().getSentenceBlock(
			    evaluateParenthesis(linebuf.substring(1),"",scope_hontai), true).get();
			if (sentence != null) { // 
			    // br蒼B
			    br.close();
			    br = new BufferedReader(new StringReader(sentence));
			    buf.append("\\1"); // ԂłkeroXR[v
			    scope_hontai = false;
			    continue;
			}
			else {
			    // ݂ȂΑs
			    continue;
			}
		    }
		    else if (linebuf.charAt(0) == Satori.ZENKAKU_DOUBLE_GT) { // Ŏn܂Ă
			String matched = satori.getDictionary().getSentenceMatchesTo(
			    evaluateParenthesis(linebuf.substring(1),"",scope_hontai));
			if (matched != null) { // }b`̂𔭌
			    // br蒼B
			    br.close();
			    br =
				new BufferedReader(
				    new StringReader(
					satori.getDictionary().getSentenceBlock(matched, true).get()));
			    buf.append("\\1"); // ԂłkeroXR[v
			    scope_hontai = false;
			    continue;
			}
			else {
			    // ݂ȂΑs
			    continue;
			}
		    }
		    else if (linebuf.charAt(0) == '_') { // QŎn܂Ă
			String arg = linebuf.substring(1).trim();
			final int tab_pos = arg.indexOf('\t');
			String label,entry;
			if (tab_pos == -1) {
			    label = entry = evaluateParenthesis(arg,"",scope_hontai);
			}
			else {
			    label = evaluateParenthesis(arg.substring(0,tab_pos).trim(),"",scope_hontai);
			    entry = evaluateParenthesis(arg.substring(tab_pos+1).trim(),"",scope_hontai);
			}
			
			linebuf.replace(0,linebuf.length(),"\\q["+label+','+entry+"]\\n");
			buf.append(linebuf.toString());
			continue;
		    }
		    else if (linebuf.charAt(0) == ':') { // FŎn܂Ă
			linebuf.replace(0,1,(scope_hontai ? "\\1" : "\\0"));
			scope_hontai = !scope_hontai;
		    }
		    
		    buf.append(
			evaluateParenthesis(linebuf.toString(), "", scope_hontai) + "\\n");
		}
	    }
	    br.close();
	    
	    // bufȂԂB
	    if (buf.length() == 0) {
		return "";
	    }
	    
	    // Ōɕt]ȁnAɁeB
	    if (buf.toString().endsWith("\\n")) {
		buf.replace(buf.length()-2,buf.length(),"\\e");
	    }
	    else {
		buf.append("\\e");
	    }
	    
	    return autoSurfaceResetInsert("\\1"+autoWaitInsert(buf.toString())); // ԂłkeroXR[vB
	}
	catch (Exception e) {
	    System.err.println("Evaluator error : evaluate caused an exception.");
	    System.err.println("The sentence block was:");
	    System.err.println(sentence_block);
	    e.printStackTrace();
	    return "";
	}
    }
    
    public String autoWaitInsert(String s) {
	// EGCg}s܂B
	// XR[v؂ւ̃^O}s܂B
	StringBuffer buf = new StringBuffer(s);
	
	String strToInsertWhenScopeChanged = satori.getVariable().get(Satori.ZENKAKU_CHANGING_SCOPE);
	if (strToInsertWhenScopeChanged == null) strToInsertWhenScopeChanged = "\\n";
	
	double rate;
	String rate_str = satori.getVariable().get(Satori.ZENKAKU_AUTOINSERT_WAIT_RATE);
	if (rate_str == null) {
	    rate = 1.0;
	}
	else {
	    try {
		int rate_parcentage = Integer.parseInt(rate_str.substring(0,rate_str.length()-1)); // Ṓ͍B
		rate = rate_parcentage / 100.0;
	    }
	    catch (Exception e) {
		rate = 1.0;
	    }
	}
	
	int pos = 0;
	int bytecount = 0;
	boolean hasChangedToSakuraScope = false; // sakuraXR[vւ̕ύX^OɌĂ邩
	while (pos < buf.length()) {
	    // _AǓ_AXR[v؂芷As̎_ŏ
	    boolean doInsert = false;
	    int charsToSkip = 0;
	    
	    char currentChar = buf.charAt(pos);
	    if (currentChar == Satori.ZENKAKU_KUTEN || currentChar == Satori.ZENKAKU_TOUTEN) {
		doInsert = true;
		charsToSkip = 1;
	    }
	    else {
		String currentStr = buf.toString();
		if (currentStr.startsWith("\\h",pos) || currentStr.startsWith("\\0",pos)) {
		    if (hasChangedToSakuraScope) {
			buf.insert(pos,strToInsertWhenScopeChanged);
			pos += strToInsertWhenScopeChanged.length();
			charsToSkip = 2; // XR[v؂ւ^O͑S2B
			doInsert = true;
		    }
		    else {
			hasChangedToSakuraScope = true;
		    }
		}
		else if (currentStr.startsWith("\\u",pos) || currentStr.startsWith("\\1",pos)) {
		    buf.insert(pos,strToInsertWhenScopeChanged);
		    pos += strToInsertWhenScopeChanged.length();
		    charsToSkip = 2;
		    doInsert = true;
		}
		else if (currentStr.startsWith("\\n",pos)) {
		    doInsert = true;
		    charsToSkip = 2;
		}
	    }
	    
	    // []ň͂܂ꂽEFCgLZB
	    int last_block_start = buf.toString().lastIndexOf('[',pos);
	    int last_block_end = buf.toString().lastIndexOf(']',pos);
	    if (last_block_start != -1 &&
		(last_block_end == -1 || last_block_end < last_block_start)) {
		doInsert = false;
	    }
	    
	    if (doInsert) { // 
		pos += charsToSkip;
		
		int wait = (int)(bytecount * 3 * rate);
		String waitTagToInsert = "\\_w["+(wait > WAIT_MAX_LIMIT ? WAIT_MAX_LIMIT : wait)+"]";
		buf.insert(pos,waitTagToInsert);
		pos += waitTagToInsert.length();
		bytecount = 0;
	    }
	    else {
		bytecount += (currentChar <= 0x00ff ? 1 : 2);
		pos++;
	    }
	}
	
	return buf.toString();
    }
    
    public String autoSurfaceResetInsert(String s) {
	// T[tBXZbgs܂B
	String autoreset_str = satori.getVariable().get(Satori.ZENKAKU_AUTORESET_SURFACES);
	if (autoreset_str != null && !autoreset_str.equals(Satori.ZENKAKU_ENABLED)) return s;
	
	// s0sA1sA\sŎn܂Ă璝OT[tBXςĂ̂ŏLZB
	if (s.startsWith("\\0\\s") || s.startsWith("\\1\\s") || s.startsWith("\\s")) return s;
	
	// T[tBXZl
	int sakura_offset = 0,kero_offset = 0;
	try {
	    String str_sakura_offset = satori.getVariable().get(Satori.ZENKAKU_SURFACE_OFFSET+'0');
	    sakura_offset = (str_sakura_offset == null ? 0 : Integer.parseInt(str_sakura_offset));
	    
	    String str_kero_offset = satori.getVariable().get(Satori.ZENKAKU_SURFACE_OFFSET+'1');
			kero_offset = (str_kero_offset == null ? 0 : Integer.parseInt(str_kero_offset));
	}
	catch (NumberFormatException e){}
	
	// ߂ԍ擾B
	String default_id_sakura = satori.getVariable().get(Satori.ZENKAKU_DEFAULT_SURFACE+'0');
	if (default_id_sakura == null) {
	    default_id_sakura = Integer.toString(sakura_offset);
	}
	else {
	    try {
		default_id_sakura = Integer.toString(Integer.parseInt(default_id_sakura));
	    }
	    catch (NumberFormatException e) {
		default_id_sakura = Integer.toString(sakura_offset);
	    }
	}
	String default_id_kero = satori.getVariable().get(Satori.ZENKAKU_DEFAULT_SURFACE+'1');
	if (default_id_kero == null) {
	    default_id_kero = Integer.toString(kero_offset);
	}
	else {
	    try {
		default_id_kero = Integer.toString(Integer.parseInt(default_id_kero));
	    }
	    catch (NumberFormatException e) {
		default_id_kero = Integer.toString(kero_offset);
	    }
	}
	
	return "\\1\\s["+default_id_kero+"]\\0\\s["+default_id_sakura+"]"+s;
    }
    
    public String evaluateParenthesis(String str,String not_found,boolean is_sakura_scope) {
	// ʂ߂ĕԂ܂B
	// ʂuoȂnot_foundɒu܂B
	return evaluateParenthesis(new Vector(),str,not_found,false,is_sakura_scope);
    }
    private String evaluateParenthesis(Vector history,String str,String not_found,boolean pure,boolean is_sakura_scope) {
	// łɂ銇ʂ𔲂očĉ߂܂B
	if (pure) {
	    // ŏƍŌɊʂA͂܂ĂB
	    String arg = str.substring(1,str.length()-1);
	    if (arg.length() == 0) return ""; // ̊ʂ͋󔒂ԂB
	    
	    // lȂ灏s^Oɒu
	    try {
		int surface_offset = 0;
		try {
		    String str_offset = satori.getVariable().get(
			Satori.ZENKAKU_SURFACE_OFFSET+(is_sakura_scope ? '0' : '1'));
		    
		    surface_offset = Integer.parseInt(str_offset);
		}
		catch (Exception e) {}
		
		
		String result = "\\s["+(Integer.parseInt(arg) + surface_offset)+"]";
		history.add(result);
		return result;
	    }
	    catch (NumberFormatException e){}
	    
	    // lłȂ΃qXg[u
	    if (arg.charAt(0) == 'H' && isAllNumber(arg.substring(1))) {
		int history_idx = -1;try{history_idx=Integer.parseInt(arg.substring(1));}catch(Exception e){}
		final int size_history = history.size();
		if (history_idx < 1 || history_idx > size_history) {
		    System.err.println("The Satori Java Clone: illegal history replacement.");
		    return "0";
		}
		else {
		    return (String)history.elementAt(history_idx-1);
		}
	    }
	    
	    // 
	    LinedDataBlock sentences = satori.getDictionary().getSentenceBlock(arg);
	    if (sentences != null) { // 
		String result = evaluate(sentences.get());
		history.add(result);
		return result;
	    }
	    
	    // P
	    LinedDataBlock words = satori.getDictionary().getWordList(arg);
	    if (words != null) { // 
		String result = evaluateParenthesis(
		    history, words.get(), not_found, false, is_sakura_scope);
		history.add(result);
		return result;
	    }
	    
	    // VXeϐB͂܂݂Ȃ\B
	    if (satori.getSysVars() != null) {
		String sysvar_value = satori.getSysVars().getStrValue(arg);
		if (sysvar_value != null) { // 
		    history.add(sysvar_value);
		    return sysvar_value;
		}
	    }
	    
	    // ϐ
	    String var_value = satori.getVariable().get(arg);
	    if (var_value != null) { // 
		String result = evaluateParenthesis(history,var_value,not_found,false,is_sakura_scope);
		history.add(result);
		return result;
	    }
	    
	    // Cxgt@Xǂ̔
	    if (arg.length() == 2 && arg.charAt(0) == 'R' && arg.charAt(1) >= '0' && arg.charAt(1) <= '9') { // t@X
		String ref_value = satori.getReferences().getDataAt(arg.charAt(1) - '0');
		String result = (ref_value == null ? "" : ref_value);
		history.add(result);
		return result;
	    }
	    
	    // ǂ̔
	    if (arg.startsWith(Satori.ZENKAKU_RANDOM_NUMBER) && arg.indexOf('~') != -1) {
		try {
		    int pos_nami = arg.indexOf('~');
		    int min = Integer.parseInt(arg.substring(Satori.ZENKAKU_RANDOM_NUMBER.length(),pos_nami));
		    int max = Integer.parseInt(arg.substring(pos_nami+1));
		    int rand = (int)((Math.random() * Integer.MAX_VALUE) % (max - min)) + min;
		    String result = ""+rand;
		    history.add(result);
		    return result;
		}
		catch (NumberFormatException e) {}
	    }
	    
	    // *̑
	    if (arg.endsWith(Satori.ZENKAKU_EXISTANCE_OF)) {
		String targetGhostName = arg.substring(0,arg.length() - Satori.ZENKAKU_EXISTANCE_OF.length());
		
		Vector ghostEx = satori.getOtherGhostNames();
		final int n_ghosts = ghostEx.size();
		for (int i = 0;i < n_ghosts;i++) {
		    String[] entry = (String[])ghostEx.elementAt(i);
		    if (entry[0].equals(targetGhostName)) { // found
			String one = "1";
			history.add(one);
			return one;
		    }
		}
		history.add(not_found);
		return not_found; // not found
	    }
	    
	    // SAORI
	    {
		FunctionArgumentTokenizer fat_args = new FunctionArgumentTokenizer(arg,","+Satori.ZENKAKU_TOUTEN);
		String saori_name_to_call = (String)fat_args.nextToken();
		
		// c̈Vectorɓ
		Vector args = new Vector();
		while (fat_args.hasMoreTokens()) {
		    args.add(fat_args.nextToken());
		}
		
		String saori_result = satori.getSaoriManager().call(saori_name_to_call,args);
		if (saori_result != null) { // SAORIĂ΂ČʂԂꂽB
		    history.add(saori_result);
		    return saori_result;
		}
	    }
	    
	    history.add(not_found);
	    return not_found; // Ȃ
	}
	else {
	    // ʂ݂邩ǂ番ĂȂB
	    StringBuffer buf = new StringBuffer(str);
	    while (true) {
		int blockend = buf.toString().indexOf(ZenHanTranslator.ZENKAKU_PARENTHESIS_CLOSE);
		if (blockend == -1) return buf.toString(); // ȏ㊇ʖ
		
		int blockstart = buf.toString().lastIndexOf(ZenHanTranslator.ZENKAKU_PARENTHESIS_OPEN,blockend);
		if (blockstart == -1) return buf.toString(); // ȏ㊇ʖ
		
		buf.replace(
		    blockstart,
		    blockend + 1,
		    evaluateParenthesis(
			history, buf.substring(blockstart,blockend+1), not_found, true, is_sakura_scope));
	    }
	}
    }
    
    public static String evalCondition(String condition) {
	try {
	    Vector condArray = toInvPorlandCondArray(condition);
	    Vector work_stack = new Vector(); // vZp , <Integer or String>
	    final int n_cond_elems = condArray.size();
	    for (int i = 0;i < n_cond_elems;i++) {
		String currentElem = (String)condArray.elementAt(i);
		if (isAllNumber(currentElem)) {
		    work_stack.add(new Integer(Integer.parseInt(currentElem)));
		}
		else if (getPriorityOfOperator(currentElem) == 0) {
		    work_stack.add(currentElem);
		}
		else if (currentElem.equals("*INVERT*")) {
		    Integer top = (Integer)pop(work_stack);
		    work_stack.add(new Integer(top.intValue() * -1));
		}
		else if (currentElem.equals("!")) {
		    Integer top = (Integer)pop(work_stack);
		    work_stack.add(new Integer(top.intValue() == 0 ? 1 : 0));
		}
		else {
		    Object arg2 = pop(work_stack); // E
		    Object arg1 = pop(work_stack); // 
		    
		    // ̓<,>,<=,>=ŎgpB
		    int int_arg1 = (arg1 instanceof Integer ? ((Integer)arg1).intValue() : ((String)arg1).length());
		    int int_arg2 = (arg2 instanceof Integer ? ((Integer)arg2).intValue() : ((String)arg2).length());
		    
		    if (currentElem.equals("^")) {
			work_stack.add(new Integer((int)(Math.pow(((Integer)arg1).intValue(),((Integer)arg2).intValue()))));
		    }
		    else if (currentElem.equals("*")) {
			if (arg1 instanceof Integer) {
			    work_stack.add(new Integer(((Integer)arg1).intValue() * ((Integer)arg2).intValue()));
			}
			else {
			    StringBuffer buf = new StringBuffer();
			    final int repeat_times = ((Integer)arg2).intValue();
			    for (int j = 0;j < repeat_times;j++) {
				buf.append((String)arg1);
			    }
			    work_stack.add(buf.toString());
			}
		    }
		    else if (currentElem.equals("/")) {
			work_stack.add(new Integer(((Integer)arg1).intValue() / ((Integer)arg2).intValue()));
		    }
		    else if (currentElem.equals("%")) {
			work_stack.add(new Integer(((Integer)arg1).intValue() % ((Integer)arg2).intValue()));
		    }
		    else if (currentElem.equals("+")) {
			if (arg1 instanceof Integer) {
			    if (arg2 instanceof Integer) {
				work_stack.add(new Integer(((Integer)arg1).intValue() + ((Integer)arg2).intValue()));
			    }
			    else {
				work_stack.add(((Integer)arg1).toString() + (String)arg2);
			    }
			}
			else {
			    if (arg2 instanceof Integer) {
				work_stack.add((String)arg1 + ((Integer)arg1).toString());
			    }
			    else {
				work_stack.add((String)arg1 + (String)arg2);
			    }
			}
		    }
		    else if (currentElem.equals("-")) {
			if (arg1 instanceof Integer) {
			    work_stack.add(new Integer(((Integer)arg1).intValue() - ((Integer)arg2).intValue()));
			}
			else {
			    // arg1arg2A폜
			    StringBuffer world = new StringBuffer((String)arg1);
			    while (true) {
				int arg2_pos = world.toString().indexOf((String)arg2);
				if (arg2_pos == -1) break;
				
				world.delete(arg2_pos,arg2_pos + ((String)arg2).length());
			    }
			    work_stack.add(world.toString());
			}
		    }
		    else if (currentElem.equals("<")) {
			work_stack.add(new Integer(int_arg1 < int_arg2 ? 1 : 0));
		    }
		    else if (currentElem.equals(">")) {
			work_stack.add(new Integer(int_arg1 > int_arg2 ? 1 : 0));
		    }
		    else if (currentElem.equals("<=")) {
			work_stack.add(new Integer(int_arg1 <= int_arg2 ? 1 : 0));
		    }
		    else if (currentElem.equals(">=")) {
			work_stack.add(new Integer(int_arg1 >= int_arg2 ? 1 : 0));
		    }
		    else if (currentElem.equals("==")) {
			if (arg1 instanceof Integer) {
			    work_stack.add(new Integer(((Integer)arg1).intValue() == ((Integer)arg2).intValue() ? 1 : 0));
			}
			else {
			    work_stack.add(new Integer(((String)arg1).equals((String)arg2) ? 1 : 0));
			}
		    }
		    else if (currentElem.equals("!=")) {
			if (arg1 instanceof Integer) {
			    work_stack.add(new Integer(((Integer)arg1).intValue() != ((Integer)arg2).intValue() ? 1 : 0));
			}
			else {
			    work_stack.add(new Integer(((String)arg1).equals((String)arg2) ? 0 : 1));
			}
		    }
		    else if (currentElem.equals("&&")) {
			work_stack.add(new Integer(((Integer)arg1).intValue() != 0 && ((Integer)arg2).intValue() != 0 ? 1 : 0));
		    }
		    else if (currentElem.equals("||")) {
			work_stack.add(new Integer(((Integer)arg1).intValue() != 0 || ((Integer)arg2).intValue() != 0 ? 1 : 0));
		    }
		}
	    }
	    // ŏIIɃX^bNɂ͒lĉŁAԂB
	    Object result = work_stack.elementAt(0);
	    return (result instanceof Integer ? ((Integer)result).toString() : (String)result);
	}
	catch (Exception e) {
	    throw new RuntimeException("syntax error in condition: "+condition);
	}
    }
    private static Object pop(Vector vec) {
	final int size = vec.size();
	Object top = vec.elementAt(size-1);
	vec.removeElementAt(size-1);
	return top;
    }
    private static Vector toInvPorlandCondArray(String condition) throws Exception {
	// Spyєp̋󔒂폜
	StringBuffer buf = new StringBuffer(condition);
	int pos;
	while ((pos = buf.toString().indexOf('\u3000')) != -1) {
	    buf.deleteCharAt(pos);
	}
	while ((pos = buf.toString().indexOf(' ')) != -1) {
	    buf.deleteCharAt(pos);
	}
	
	// t|[h֕ϊB
	Vector cond_stack = new Vector();
	Vector ope_stack = new Vector();
	ConditionTokenizer sct = new ConditionTokenizer(buf.toString());
	String tokenJustBefore = null; // Õg[N
	String currentToken = null;
	while (sct.hasMoreTokens()) {
	    tokenJustBefore = currentToken;
	    currentToken = sct.nextToken();
	    if (isAllNumber(currentToken)) {
		// ͂̂܂܏o
		cond_stack.add(currentToken);
		continue;
	    }
	    
	    if (currentToken.equals("-")) {
		// 񂪏߂Ẵg[NA͒Õg[NJʈ͉Zqꍇ͒PZqB
		// łȂΓ񍀉ZqB
		// ʂ͓̒񍀉Zqł邱ƂɒӁB
		if (tokenJustBefore == null ||
		    tokenJustBefore.equals("(") ||
		    getPriorityOfOperator(tokenJustBefore) != 0) {
		    
		    ope_stack.add("*INVERT*");
		    continue;
		}
	    }
	    
	    if (currentToken.equals("(")) {
		// Jʂpush
		ope_stack.add(currentToken);
	    }
	    else if (currentToken.equals(")")) {
		// ʂꂽ牉ZqX^bNɊJʂ܂popB
		while (true) {
		    String top = (String)pop(ope_stack);
		    
		    if (top.equals("(")) {
			break;
		    }
		    else {
			cond_stack.add(top);
		    }
		}
	    }
	    else if (getPriorityOfOperator(currentToken) == 0) {
		// 萔B̂܂܏óB
		cond_stack.add(currentToken);
	    }
	    else {
		// Zq́A̎_ł̃X^bÑgbvƔrėD揇ʂpoppushAłȂpusĥ
		// ZqX^bN󂾂gbvJʂȂ疳pusĥ݁B
		if (ope_stack.size() > 0) {
		    String top = (String)ope_stack.elementAt(ope_stack.size()-1);
		    if (!top.equals("(") &&
			getPriorityOfOperator(currentToken) <= getPriorityOfOperator(top)) {
			cond_stack.add(top);
			ope_stack.removeElementAt(ope_stack.size()-1);
		    }
		}
		ope_stack.add(currentToken);
	    }
	}
	// ZqX^bNSpop
	final int ope_stack_size = ope_stack.size();
	for (int i = ope_stack_size-1;i >= 0;i--) {
	    cond_stack.add(ope_stack.elementAt(i));
	}
	
	return cond_stack;
    }
    
    public static boolean isAllNumber(String s) {
	// sSĔpŕ\ĂtrueB
	final int len = s.length();
	for (int i = 0;i < len;i++) {
	    if (!Character.isDigit(s.charAt(i))) return false;
	}
	return true;
    }
    
    private static Hashtable OPE_PRIORITY;
    static {
	OPE_PRIORITY = new Hashtable();
	OPE_PRIORITY.put("*INVERT*",new Integer(7));
	OPE_PRIORITY.put("!",new Integer(7));
	OPE_PRIORITY.put("^",new Integer(6));
	OPE_PRIORITY.put("*",new Integer(5));
	OPE_PRIORITY.put("/",new Integer(5));
	OPE_PRIORITY.put("%",new Integer(5));
	OPE_PRIORITY.put("+",new Integer(4));
	OPE_PRIORITY.put("-",new Integer(4));
	OPE_PRIORITY.put("<",new Integer(3));
	OPE_PRIORITY.put(">",new Integer(3));
	OPE_PRIORITY.put("<=",new Integer(3));
	OPE_PRIORITY.put(">=",new Integer(3));
	OPE_PRIORITY.put("==",new Integer(2));
	OPE_PRIORITY.put("!=",new Integer(2));
	OPE_PRIORITY.put("&&",new Integer(1));
	OPE_PRIORITY.put("||",new Integer(1));
    }
    public static int getPriorityOfOperator(String ope) {
	// 傫قǗD揇ʂB
	// ZqłȂ0ԂB
	Integer pri = (Integer)OPE_PRIORITY.get(ope);
	return (pri == null ? 0 : pri.intValue());
    }
    
    public static boolean checkMatchingParenthesis(String sentence) {
	// sentence̊ʂ̑ΉtrueԂB
	// GXP[v͗\߃GR[hĂB
	final int len = sentence.length();
	int paren_level = 0;
	
	for (int i = 0;i < len;i++) {
	    char c = sentence.charAt(i);
	    if (c == ZenHanTranslator.ZENKAKU_PARENTHESIS_OPEN) {
		paren_level++;
	    }
	    else if (c == ZenHanTranslator.ZENKAKU_PARENTHESIS_CLOSE) {
		paren_level--;
	    }
	}
	
	return paren_level == 0;
    }
}
