/*  $Id: Logger.java,v 1.2 2004/02/05 09:29:35 phonohawk Exp $

    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package util;
import java.io.*;
import java.util.*;

public class Logger {
    // ٥
    public static final int DEBUG    = 1;
    public static final int NOTICE   = 2;
    public static final int WARN     = 3;
    public static final int CRITICAL = 4;
    
    private static final String[] loglevel2str = {
	"debug", "notice", "warn", "critical",
    };

    private static boolean enabled = true;
    private static int loglevel_limit = CRITICAL;
    private static PrintStream output = System.err;

    public static void setLogLevelLimit(int level) {
	loglevel_limit = level;
    }
    
    public static void log(Object sender, int level, String message) {
	if (enabled && level >= loglevel_limit) {
	    // åɥդતˡΥ֥Ȥźľ
	    StringBuffer buf = new StringBuffer();
	    Calendar cal = Calendar.getInstance();

	    // timestamp
	    buf.append(cal.get(Calendar.MONTH)+1).append('/');
	    buf.append(cal.get(Calendar.DAY_OF_MONTH)).append(' ');
	    buf.append(cal.get(Calendar.HOUR_OF_DAY)).append(':');
	    buf.append(cal.get(Calendar.MINUTE)).append(':');
	    buf.append(cal.get(Calendar.SECOND)).append(' ');

	    // loglevel
	    try {
		String level_str = loglevel2str[level - 1];
		level_str.length(); // nullʤ㳰
		buf.append('[').append(level_str).append("] ");
	    }
	    catch (Exception e) {
		buf.append("[unknown loglevel: ").append(level).append("] ");
	    }

	    // sender
	    if (sender != null) {
		buf.append('[').append(sender.getClass().getName()).append("] ");
	    }

	    // message
	    buf.append(message);

	    // sender
	    if (sender != null) {
		buf.append(" {").append(sender.toString()).append('}');
	    }

	    output.println(buf.toString());
	}
    }
}